// this polyfill doesn't work correctly in Firefox

function setSelectionRangePolyfill(el)
{
  var start = 0, end = 0, normalizedValue, range,
  textInputRange, len, endRange;
  
  if (typeof el.selectionCustom === 'undefined' && typeof el.selectionStart == "number" && typeof el.selectionEnd == "number")
  {
    start = el.selectionStart;
    end = el.selectionEnd;
  }
  else
  {
    range = document.selection.createRange();
    
    if (range && range.parentElement() == el)
    {
      len = el.value.length;
      normalizedValue = el.value.replace(/\r\n/g, "\n");
      
      // Create a working TextRange that lives only in the input
      textInputRange = el.createTextRange();
      textInputRange.moveToBookmark(range.getBookmark());
      
      // Check if the start and end of the selection are at the very end
      // of the input, since moveStart/moveEnd doesn't return what we want
      // in those cases
      endRange = el.createTextRange();
      endRange.collapse(false);
      
      if (textInputRange.compareEndPoints("StartToEnd", endRange) > -1)
        start = end = len;
        
      else
      {
        start = -textInputRange.moveStart("character", -len);
        start += normalizedValue.slice(0, start).split("\n").length - 1;
        
        if (textInputRange.compareEndPoints("EndToEnd", endRange) > -1)
          end = len;
        else
        {
          end = -textInputRange.moveEnd("character", -len);
          end += normalizedValue.slice(0, end).split("\n").length - 1;
        }
      }
    }

    // save selection values (and custom value to know if generated values are custom or not)
    el.selectionStart = start;
    el.selectionEnd = end;
    el.selectionCustom = true;
  }
  
  // create setSelectionRange
  if (typeof el.setSelectionRange === 'undefined')
  {
    el.setSelectionRange = function (start, end)
    {
      var range = el.createTextRange();
      range.collapse(true);
      range.moveStart('character', start);
      range.moveEnd('character', end - start);
      range.select();
      el.focus();
    }
  }

  return {start: start, end: end};
}

function fixGSAKKeyPress(element, capture)
{
  if (!element)
    return;

  EventUtil.addHandler(element, "keypress", function (e, target)
  {
    // return if target is not input
    if (!(target.tagName.toLowerCase() == "input" && target.type.toLowerCase().substr(0, 4) == "text"))
      return;

    var keyCode = (typeof e.charCode == "number") ? e.charCode : e.keyCode;//EventUtil.getCharCode(e);

    // let browser handle backspace and characters lower then 0xFF
    if (keyCode == 8 && keyCode <= 0xFF)
      return;  
  
    var textbox = target;

    // GSAK may give us codes like 6000FE, convert to 0x0060FE (browsers give us correct number)
    var key = keyCode.toString(16);
    var hex = ((key.length % 2) ? "0" : "") + key
    hex = hex.replace(/(..)(?=\w)/g, "$1,");
    hex = hex.split(",");
    
    var chr = hex.pop();
    chr = hex.reverse().join("") + chr;
    chr = String.fromCharCode(parseInt(chr, 16));
    
    // initialization for IE7/8
    if (typeof textbox.selectionCustom !== 'undefined' || (typeof setSelectionRangePolyfill !== 'undefined' && typeof textbox.setSelectionRange === 'undefined'))
      setSelectionRangePolyfill(textbox);
 
    // get selection start/end
    var selStart = textbox.selectionStart;
    var selEnd = textbox.selectionEnd;

    // remove selected text + set cursor after our new character
    textbox.value = textbox.value.substring(0, selStart) + chr + textbox.value.substring(selEnd);

    if (typeof textbox.setSelectionRange !== 'undefined')
      textbox.setSelectionRange(selStart + 1, selStart + 1);

    // prevent putting original character to the text
    EventUtil.preventDefault(e);
  }, capture);
}