SMap.CONFIG = {};
SMap.CONFIG.version = "4.10.13";
SMap.CONFIG.protocol = (location.protocol.match(/^http/i) ? "" : "http:");
SMap.CONFIG.base = SMap.CONFIG.protocol + "//api.mapy.cz";
SMap.CONFIG.img = "" + window.basePath + "Seznam/img/api";
SMap.CONFIG.media = {
	rpc: "http://api.mapy.cz/mediaserver",
	storage: "http://api.mapy.cz/mediastorage"
}
SMap.CONFIG.pano = {
	rpc: SMap.CONFIG.base + "/panorpc",
	storage: SMap.CONFIG.protocol + "//#.mapserver.mapy.cz/panorama"
}
SMap.CONFIG.route = SMap.CONFIG.base + "/route";
SMap.CONFIG.geocode = SMap.CONFIG.base + "/geocode";
SMap.CONFIG.rgeocode = SMap.CONFIG.base + "/rgeocode";

SMap.CONFIG[SMap.DEF_BASE] = {
	zoom: [3, 16],
	label: "Obecná",
	preview: "preview-zakladni.png",
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/base/",
	copyright: {
		"1-8": "Seznam.cz, a.s.",
		"9-": ["Seznam.cz, a.s.", "Přispěvatelé <a href='http://www.openstreetmap.org/copyright' target='_blank'>OpenStreetMap</a>"]
	}
};

SMap.CONFIG[SMap.DEF_OPHOTO] = {
	zoom: [3, 18],
	label: "Letecká",
	preview: "preview-letecka.png",
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/ophoto/",
	copyright: {
		"1-6": "NASA Earth Observatory",
		"7-10": ["GEODIS BRNO, s.r.o", "USGS & NASA. Datasource: Global Land Cover Facility"],
		"11-": "GEODIS BRNO, s.r.o"
	}
};

SMap.DEF_GEOGRAPHY = 123456;

SMap.CONFIG[SMap.DEF_GEOGRAPHY] = {
	zoom: [3, 16],
	label: "Zeměpisná",
	preview: "preview-zemepisna.png",
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/zemepis/",
	copyright: {
		"-": "Seznam.cz, a.s."
	}
};

SMap.CONFIG[SMap.DEF_TURIST] = {
	zoom: [3, 16],
	label: "Turistická",
	preview: "preview-turisticka.png",
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/{}/",
	copyright: {
		"-": "Seznam.cz, a.s."
	}
};

SMap.CONFIG[SMap.DEF_TURIST_WINTER] = {
	zoom: [3, 16],
	label: "Zimní",
	preview: "preview-zimni.png",
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/turist_winter/",
	copyright: {
		"-": "Seznam.cz, a.s."
	}
};

SMap.CONFIG[SMap.DEF_HISTORIC] = {
	zoom: [5, 13],
	label: "Historická",
	title: "Historická 1836–1852",
	preview: "preview-historicka.png",
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/army2/",
	copyright: {
		"5-13": ["2nd Military Survey, Austrian State Archive", "Datový podklad MŽP ČR", "Laboratoř geoinformatiky UJEP"]
	}
};

SMap.CONFIG[SMap.DEF_HYBRID] = {
	options: {
		animTime: 0,
		fadeTime: 0,
		prefetch: 0,
		alpha: true
	},
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/hybrid/",
	copyright: {
		"-": ["Seznam.cz, a.s."]
	}
};

SMap.CONFIG[SMap.DEF_OPHOTO0203] = {
	zoom: [3, 16],
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/ophoto0203/",
	label: "Letecká 03",
	title: "Letecká 2002–2003",
	preview: "preview-letecka0203.png",
	copyright: {
		"1-6": "NASA Earth Observatory",
		"7-10" :"USGS & NASA. Datasource: Global Land Cover Facility",
		"11-": "GEODIS BRNO, s.r.o"
	}
};

SMap.CONFIG[SMap.DEF_OPHOTO0406] = {
	zoom: [3, 18],
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/ophoto0406/",
	label: "Letecká 06",
	title: "Letecká 2004–2006",
	preview: "preview-letecka0406.png",
	copyright: {
		"1-6": "NASA Earth Observatory",
		"7-10" :"USGS & NASA. Datasource: Global Land Cover Facility",
		"11-": "GEODIS BRNO, s.r.o"
	}
};

SMap.CONFIG[SMap.DEF_SUMMER] = {
	zoom: [3, 16],
	url: "//m#.mapserver.mapy.cz/turist_aquatic/",
	label: "Letní",
	title: "Letní",
	preview: "preview-letni.png",
	copyright: {
		"-": "Seznam.cz, a.s."
	}
};

SMap.CONFIG[SMap.DEF_TRAIL] = {
	options: {
		animTime: 0,
		fadeTime: 0,
		prefetch: 0,
		alpha: true
	},
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/ttur/",
	copyright: {
		"3-16": "Seznam.cz, a.s."
	}
};

SMap.CONFIG[SMap.DEF_BIKE] = {
	options: {
		animTime: 0,
		fadeTime: 0,
		prefetch: 0,
		alpha: true
	},
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/tcyklo/",
	copyright: {
		"3-16": "Seznam.cz, a.s."
	}
};

SMap.CONFIG[SMap.DEF_RELIEF] = {
	zoom: [3, 15],
	options: {
		animTime: 0,
		fadeTime: 0,
		prefetch: 0,
		alpha: true
	},
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/relief/",
	copyright: {
		"-": "Seznam.cz, a.s."
	}
};

SMap.CONFIG[SMap.DEF_OBLIQUE] = {
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/oblique/",
	copyright: {
		"geodis": ["GEODIS BRNO, s.r.o", "Seznam.cz, a.s."],
		"topgis": ["TopGis, s.r.o", "Seznam.cz, a.s."],
	}
};

SMap.CONFIG[SMap.DEF_OBLIQUE_HYBRID] = {
	options: {
		animTime: 0,
		fadeTime: 0,
		prefetch: 0,
		alpha: true
	},
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/oblique_hybrid/",
	copyright: {
		"-": "Seznam.cz, a.s."
	}
};


SMap.CONFIG[SMap.DEF_SMART_BASE] = {
	label: "Obecná",
	preview: "preview-zakladni.png"
};

SMap.CONFIG[SMap.DEF_SMART_TURIST] = {
	label: "Turistická",
	preview: "preview-turisticka.png",
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/{}/"
};

SMap.CONFIG[SMap.DEF_SMART_OPHOTO] = {
	label: "Letecká",
	preview: "preview-letecka.png"
};

SMap.CONFIG[SMap.DEF_SMART_WINTER] = {
	label: "Zimní",
	preview: "preview-zimni.png"
};

SMap.CONFIG[SMap.DEF_SMART_SUMMER] = {
	label: "Letní",
	preview: "preview-letni.png"
};

SMap.CONFIG[SMap.DEF_PANO] = {
	zoom: [3, 18],
	options: {
		availUrl: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/getMultiple?path=/panorama_mask/&tiles="
	},
	url: SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/panorama_hybrid/",
};

SMap.CONFIG.ophotoExtents = [
[[684575.8,5410891.5],[651567.6,5410078.1],[641760,5477920],[672414.2,5479415.1],[656256.9,5502533.3],[714767.1,5494304],[731281.9,5508967.1],[717464.7,5507960.5],[721979.5,5533221.9],[756503.3,5536170.9],[776059.9,5496607.6],[757688,5499872.4],[755545.2,5520180.9],[748405.7,5503186.7],[734502.3,5506703.6],[756448,5494304],[740064,5428768],[723680,5428768],[723680,5412384],[684575.8,5410891.5]],[[553697.7,5412052.2],[510688,5412384],[510688,5396000],[494304,5396000],[494304,5379616],[461536,5379616],[461536,5363232],[445152,5363232],[445152,5379616],[412384,5379616],[412384,5396000],[396000,5396000],[346848,5461536],[314080,5461536],[314080,5494304],[297696,5494304],[297696,5527072],[314080,5527072],[314080,5543456],[281312,5559840],[281312,5592608],[379616,5608992],[379616,5625376],[412384,5625376],[412384,5641760],[445152,5641760],[445152,5658144],[477920,5658144],[477920,5641760],[494304,5641760],[494304,5658144],[527072,5658144],[527072,5641760],[559840,5641760],[559840,5625376],[608992,5625376],[608992,5576224],[641760,5576224],[641760,5509303.8],[654943.3,5519540.6],[653744,5502698.1],[641760,5502372.4],[641760,5477920],[595200.9,5471785.2],[527183.5,5509969.3],[529651,5481243.9],[510688,5463815],[540352.5,5465271.1],[543456,5445152],[560278.4,5445764.4],[553697.7,5412052.2]],[[626225.8,5449785.1],[605258.4,5441329.8],[602145.2,5461279],[625362,5461669.4],[626225.8,5449785.1]],[[696716.5,5500858.8],[682738,5522001.5],[716143,5542162.9],[701393.6,5513967],[721147.4,5514160.6],[696716.5,5500858.8]]
];

SMap.CONFIG.debugMode = 0;

SMap.CONFIG.obliqueExtents = [
	[[770138,5501050],[770724,5501922],[771503,5502061],[771999,5501922],[772165,5500961],[773167,5501044],[773370,5497509],[772468,5497186],[771504,5498309],[771048,5497826],[770638,5498032],[771107,5498914],[770505,5499313],[770138,5501050]],
	[[761086,5510877],[761729,5511823],[762446,5512034],[762699,5513048],[765003,5512360],[765390,5511239],[766271,5511225],[766936,5510488],[766468,5507556],[764435,5507260],[763460,5508248],[762027,5508108],[761086,5510877]],
	[[758630,5517261],[759440,5518829],[761051,5519316],[760978,5518667],[761624,5518488],[762018,5517361],[761313,5514845],[759807,5515007],[758630,5517261]],
	[[752524,5531285],[753944,5532410],[755342,5532505],[755573,5531954],[756276,5531914],[756379,5530552],[757241,5530352],[756754,5528136],[755782,5527269],[754401,5527112],[753707,5528128],[753175,5528096],[752524,5531285]],
	[[747395,5514602],[747264,5516269],[749121,5516558],[750037,5516086],[750030,5513456],[747870,5513215],[747395,5514602]],
	[[743580,5522569],[743727,5523311],[746141,5524579],[746613,5523388],[747928,5523501],[748122,5522875],[748805,5522742],[749002,5521431],[749749,5521417],[749687,5519016],[748048,5518432],[746939,5518642],[745538,5520660],[744058,5521371],[743580,5522569]],
	[[744864,5530413],[745044,5532235],[747721,5532192],[747652,5530286],[746967,5529743],[746756,5528299],[745831,5528269],[745250,5528845],[744864,5530413]],
	[[740884,5499934],[742096,5501382],[743321,5501620],[743840,5496194],[742152,5495524],[741898,5496905],[740527,5499367],[740884,5499934]],
	[[739176,5533381],[739615,5534105],[739398,5535708],[741689,5535908],[743518,5535439],[743667,5532905],[741811,5532600],[741197,5531370],[739701,5531147],[739176,5533381]],
	[[737492,5507996],[739345,5509236],[737864,5511775],[738013,5512717],[739738,5512828],[740724,5511862],[741736,5511838],[743312,5510864],[743664,5507024],[740915,5506708],[740387,5505661],[738523,5505379],[737644,5506501],[737492,5507996]],
	[[725410,5527792],[729231,5529027],[729742,5528922],[729929,5527874],[730930,5527682],[731844,5528684],[732667,5528824],[732854,5529468],[734348,5530047],[734387,5530480],[736101,5530778],[736364,5529545],[737620,5529625],[738187,5524461],[739189,5524562],[740186,5522514],[739964,5519650],[738474,5519467],[738071,5518561],[736296,5518408],[735786,5517231],[734642,5517039],[733986,5518070],[730533,5518430],[729783,5519789],[731080,5521643],[731028,5522496],[728865,5523545],[726784,5523319],[725410,5527792]],
	[[733896,5537317],[736386,5537800],[736562,5534816],[734470,5534553],[733896,5537317]],
	[[730319,5494274],[730694,5495866],[732354,5495810],[732758,5495136],[733797,5494835],[734172,5494025],[734728,5494042],[734383,5491922],[733714,5491617],[733142,5492132],[731322,5491928],[730319,5494274]],
	[[731000,5512183],[732029,5513013],[733542,5512937],[734253,5510337],[734040,5509539],[732018,5509165],[731000,5512183]],
	[[731865,5502293],[731558,5503858],[733010,5504382],[733940,5504208],[734260,5501070],[732276,5500789],[731865,5502293]],
	[[727462,5531858],[727952,5534277],[729164,5534645],[730135,5534133],[731254,5532050],[731089,5531159],[729359,5530214],[729043,5530836],[727817,5531108],[727462,5531858]],
	[[723576,5499282],[723841,5499920],[724857,5500252],[724521,5501353],[725663,5501759],[725316,5504644],[726314,5504921],[726764,5505813],[728434,5506043],[728741,5504513],[728075,5503409],[728178,5502279],[729387,5502412],[729637,5501465],[730647,5501422],[729402,5498427],[728194,5497549],[724210,5497045],[723576,5499282]],
	[[725025,5484584],[727002,5485842],[728603,5486034],[729431,5485674],[729811,5484740],[729120,5483203],[727718,5482259],[726789,5483188],[725756,5483131],[725025,5484584]],
	[[717461,5513076],[717343,5513712],[717975,5513856],[718526,5513259],[719989,5513043],[721063,5514252],[722779,5513698],[723034,5512945],[721479,5510621],[719530,5509992],[718968,5511393],[718348,5511562],[717461,5513076]],
	[[719078,5440322],[719109,5441211],[719944,5441788],[719844,5442831],[720435,5444227],[721212,5444334],[721807,5443826],[721729,5442704],[721016,5441411],[720803,5439023],[719440,5439522],[719078,5440322]],
	[[715183,5471657],[715175,5472113],[715618,5472172],[716498,5471291],[717776,5471551],[718689,5470600],[720498,5470534],[720521,5469857],[719461,5469390],[718539,5468247],[716511,5468375],[714894,5471352],[715183,5471657]],
	[[715331,5498870],[716205,5499439],[716866,5500809],[719222,5501068],[720228,5500246],[720190,5498858],[719250,5498702],[719214,5497239],[718387,5496679],[717117,5496483],[716595,5497166],[715192,5497441],[714873,5498559],[715331,5498870]],
	[[714906,5517243],[716632,5517750],[717013,5518694],[718022,5518684],[718999,5516613],[718869,5515429],[716474,5515105],[714906,5517243]],
	[[714486,5534868],[715103,5537453],[716093,5536996],[718097,5537135],[718607,5534776],[714697,5534546],[714486,5534868]],
	[[713041,5487267],[712947,5488179],[714564,5488265],[715345,5485982],[716467,5485560],[716987,5486152],[717067,5484459],[716628,5483954],[716970,5482984],[716393,5481931],[715441,5481983],[714634,5483807],[713982,5483945],[713041,5487267]],
	[[704287,5537118],[704992,5538335],[704997,5539970],[706368,5539966],[706632,5539432],[709896,5538161],[711472,5535092],[710768,5534900],[710068,5533440],[712007,5533862],[712354,5533388],[712857,5530726],[712619,5529870],[710546,5529509],[709922,5532613],[708439,5533258],[707846,5534474],[704930,5534530],[704625,5534976],[704924,5536165],[704287,5537118]],
	[[708258,5441965],[709301,5443193],[710554,5442993],[711084,5441586],[712125,5441280],[712134,5440089],[710484,5439748],[710091,5440760],[709037,5440744],[708258,5441965]],
	[[706900,5511685],[709873,5512714],[710675,5511889],[710297,5510416],[707838,5510102],[707179,5510289],[706900,5511685]],
	[[704741,5527449],[704433,5529448],[705660,5530013],[706961,5529878],[707142,5526382],[705140,5526133],[704741,5527449]],
	[[702579,5506923],[703176,5507415],[705205,5507193],[705521,5506412],[705022,5504488],[703761,5504549],[702579,5506923]],
	[[698974,5442221],[699446,5442424],[699664,5443402],[700491,5443277],[701141,5444079],[701930,5444104],[702178,5442453],[701176,5441545],[699476,5440961],[698974,5442221]],
	[[696109,5493913],[698619,5495592],[699260,5495363],[699418,5494696],[700299,5494863],[700241,5493495],[699522,5493194],[699864,5492066],[698477,5491831],[698496,5490877],[696917,5491311],[696095,5492813],[696109,5493913]],
	[[696792,5518539],[697483,5518829],[697719,5519872],[699070,5520440],[699119,5518819],[699620,5518522],[698984,5516647],[697172,5517483],[696792,5518539]],
	[[687399,5454442],[687594,5455505],[689208,5455566],[689212,5456331],[690964,5456688],[691475,5457482],[691265,5458578],[692318,5458873],[692660,5459675],[694546,5459734],[695140,5459079],[696134,5459500],[696399,5458386],[697321,5458040],[697856,5458367],[698272,5457555],[699386,5457128],[699310,5456267],[697964,5455695],[690662,5454384],[689935,5452921],[688267,5453012],[687399,5454442]],
	[[691137,5477378],[692035,5477003],[694690,5477314],[695168,5476391],[696504,5475780],[697343,5475928],[697294,5474165],[696434,5473986],[695595,5474973],[693495,5474320],[691481,5476057],[691137,5477378]],
	[[690975,5435499],[691346,5436056],[693459,5436327],[694805,5435838],[696061,5436666],[696709,5436455],[696818,5435749],[696476,5434861],[695048,5434226],[694430,5432507],[693761,5432404],[691374,5434172],[690975,5435499]],
	[[689546,5551807],[690306,5553152],[689879,5554972],[693249,5555509],[693196,5556928],[694719,5557027],[695713,5550861],[692715,5550845],[690242,5550136],[689546,5551807]],
	[[690094,5524621],[690015,5525016],[690521,5525138],[692743,5525120],[692745,5521848],[690751,5521505],[689844,5524082],[690094,5524621]],
	[[687557,5520047],[687534,5520763],[689428,5521661],[690053,5520963],[690195,5518309],[688083,5518074],[687557,5520047]],
	[[684007,5467919],[684911,5468361],[684925,5468830],[685983,5468973],[685962,5469646],[687492,5469670],[689662,5470519],[689373,5468569],[688786,5468404],[688531,5467086],[687237,5466241],[686598,5466179],[686009,5467040],[684291,5466536],[684007,5467919]],
	[[685079,5489840],[685076,5490319],[685981,5490980],[688144,5491392],[688927,5490973],[688809,5489717],[687607,5489052],[687373,5488364],[685851,5488627],[685079,5489840]],
	[[681994,5455327],[681887,5456656],[682583,5456780],[682338,5457975],[682709,5457989],[683718,5457817],[683844,5456566],[685941,5454707],[686043,5452346],[684157,5451728],[684158,5448635],[682822,5448443],[682060,5449925],[681942,5450934],[683053,5451510],[681994,5455327]],
	[[676478,5438781],[677408,5440647],[678795,5440877],[679883,5439339],[681438,5439911],[681841,5437261],[680265,5436471],[677801,5438344],[676669,5438286],[676478,5438781]],
	[[677972,5466106],[678277,5467061],[678924,5467308],[678808,5467989],[679724,5468100],[680950,5465914],[680842,5464259],[680185,5463949],[679431,5465042],[678229,5465410],[677972,5466106]],
	[[674377,5481648],[675532,5481926],[675350,5483696],[677144,5484414],[677675,5484328],[677766,5483640],[679516,5483156],[680275,5481885],[678667,5478707],[677540,5478543],[676712,5479152],[675681,5479071],[674377,5481648]],
	[[672754,5543135],[677826,5544211],[678309,5543673],[678552,5541737],[678434,5540464],[677886,5540217],[677855,5538666],[676704,5538488],[676423,5539089],[675564,5539035],[674395,5541170],[673126,5541865],[672754,5543135]],
	[[671235,5462969],[671796,5463350],[671552,5464570],[672661,5465542],[672725,5466826],[673636,5467452],[673986,5467429],[674125,5465930],[674966,5465949],[676625,5464883],[677023,5463457],[676640,5462449],[675432,5462287],[675033,5460913],[674482,5460802],[672355,5461897],[671419,5461861],[671235,5462969]],
	[[672164,5424408],[672546,5426677],[673861,5427065],[674485,5428317],[676174,5428224],[675841,5424534],[675154,5423561],[672467,5423012],[672164,5424408]],
	[[668601,5533219],[669065,5533628],[672272,5533558],[672149,5532505],[671121,5531206],[669851,5531025],[668918,5531664],[668601,5533219]],
	[[668101,5556243],[668196,5557007],[669031,5557596],[668672,5559850],[669611,5559953],[670372,5558684],[670995,5555251],[671843,5554844],[671895,5553862],[670984,5553753],[668640,5554923],[668101,5556243]],
	[[667560,5419102],[667456,5420006],[668110,5420272],[668107,5420972],[668812,5421688],[670914,5421185],[671014,5418709],[670085,5417994],[668492,5417308],[668030,5417521],[667560,5419102]],
	[[665384,5470263],[665191,5471227],[666619,5471751],[667164,5471212],[668339,5471255],[668534,5467800],[666746,5467514],[666007,5467836],[665384,5470263]],
	[[658475,5495529],[658416,5496377],[659641,5497169],[659510,5498187],[659996,5498470],[660065,5499306],[660989,5499452],[661916,5498964],[662977,5500105],[663654,5500009],[664006,5498940],[665243,5499882],[666230,5499464],[667601,5496593],[666524,5493301],[665590,5493144],[664419,5493646],[662402,5491255],[660554,5493649],[659900,5493828],[659647,5494974],[658730,5494972],[658475,5495529]],
	[[663397,5511710],[664797,5513339],[666254,5513715],[666511,5510722],[665219,5508859],[663743,5509871],[663397,5511710]],
	[[663853,5549826],[663885,5550999],[666239,5551737],[666343,5548633],[664268,5548348],[663853,5549826]],
	[[661330,5534468],[661496,5535807],[663391,5536144],[663690,5535139],[665568,5534989],[665686,5533726],[662515,5532991],[661905,5533216],[661330,5534468]],
	[[653120,5338158],[653330,5339118],[656130,5339319],[658200,5340742],[663212,5341457],[663139,5339858],[662016,5339421],[661710,5338459],[659727,5336492],[659662,5334036],[656447,5333622],[654009,5334268],[653120,5338158]],
	[[660348,5525533],[662714,5525538],[662902,5522505],[660875,5522237],[660242,5524158],[660348,5525533]],
	[[657797,5552369],[660056,5553563],[660686,5553286],[661237,5549544],[661017,5548078],[658869,5547847],[657797,5552369]],
	[[654904,5566783],[655513,5568636],[656841,5568732],[657364,5569528],[658463,5569818],[658199,5565211],[657368,5564349],[655377,5565268],[654904,5566783]],
	[[653986,5413973],[655150,5416435],[655910,5415910],[657165,5416248],[657818,5414825],[656836,5414068],[656866,5412982],[656277,5412323],[654274,5412925],[653986,5413973]],
	[[653361,5431782],[654308,5432301],[654009,5433372],[654592,5434298],[656847,5434148],[657277,5431929],[656818,5429785],[655373,5429217],[654186,5429873],[653361,5431782]],
	[[648583,5482193],[648783,5483073],[650892,5484038],[650564,5485188],[651325,5485382],[652493,5484821],[653223,5486000],[654590,5486214],[656499,5484837],[657199,5482946],[656717,5481596],[655779,5481295],[655659,5479702],[654730,5479568],[652704,5480087],[651811,5481196],[649156,5480918],[648583,5482193]],
	[[651439,5516898],[651507,5517964],[651992,5518200],[655551,5517948],[655503,5516171],[654902,5516059],[654810,5515397],[653456,5515209],[653297,5514553],[651661,5514311],[651439,5516898]],
	[[651855,5422146],[653698,5422868],[654968,5422339],[654643,5420003],[652558,5420098],[651855,5422146]],
	[[648405,5509567],[649895,5510131],[650113,5509497],[650930,5509304],[651042,5508087],[650346,5507253],[650246,5506134],[649258,5506262],[648405,5509567]],
	[[644011,5447463],[646844,5448133],[647184,5446831],[648062,5446024],[647971,5445213],[645017,5445548],[644011,5447463]],
	[[644011,5461057],[644491,5461840],[646276,5462098],[646297,5459873],[644591,5459661],[644011,5461057]],
	[[638966,5539021],[639355,5539741],[640508,5539251],[642110,5539652],[642221,5538927],[644414,5538179],[644296,5536842],[642255,5535188],[640095,5534913],[640069,5537331],[638966,5539021]],
	[[637862,5402093],[637360,5403308],[638044,5404579],[639469,5405399],[639748,5403020],[640485,5401789],[638970,5401362],[637862,5402093]],
	[[635292,5516856],[637568,5517621],[638193,5517114],[639367,5517453],[640144,5516592],[640155,5515482],[639816,5515054],[638011,5514841],[637232,5515777],[635658,5515621],[635292,5516856]],
	[[637852,5559630],[638676,5560640],[639626,5560054],[639609,5557803],[638921,5557661],[638385,5558123],[637852,5559630]],
	[[634977,5446645],[635091,5448120],[637412,5449433],[638386,5449282],[638625,5446053],[637701,5445473],[637628,5444811],[635313,5445198],[634977,5446645]],
	[[635017,5498116],[636829,5498153],[637141,5497532],[637916,5497561],[637242,5494308],[636220,5494181],[635299,5494816],[634770,5496058],[635017,5498116]],
	[[632544,5528388],[633736,5529242],[635589,5529615],[636263,5528955],[636272,5527492],[637183,5526838],[636983,5525664],[634465,5525672],[634134,5526272],[633375,5526240],[632544,5528388]],
	[[627497,5399823],[627830,5400635],[627317,5401845],[629628,5402293],[630468,5401765],[630273,5399504],[627921,5399239],[627497,5399823]],
	[[625360,5423625],[625373,5424507],[628333,5424515],[628101,5422495],[628549,5422228],[628611,5421209],[626091,5421674],[625360,5423625]],
	[[624264,5550447],[623937,5551320],[626644,5550728],[626669,5549178],[624674,5549387],[624264,5550447]],
	[[603154,5453817],[604003,5454844],[603915,5456150],[605070,5457033],[604774,5459162],[604024,5460405],[605321,5460486],[606200,5461310],[606644,5460882],[607962,5460979],[609049,5459714],[610153,5459593],[609908,5458652],[610511,5457260],[611039,5457619],[610996,5458246],[612263,5458575],[613067,5459173],[613105,5459786],[614083,5460155],[614133,5461467],[615533,5461698],[616089,5462323],[617393,5462106],[618396,5462762],[620374,5462266],[619921,5460839],[618498,5459838],[620052,5458904],[620204,5457297],[621557,5456388],[621603,5455921],[622442,5455273],[623559,5455928],[624114,5456755],[623665,5457534],[625103,5457593],[626159,5457089],[625269,5454277],[625532,5450721],[624135,5449827],[624636,5448801],[625632,5449385],[626331,5449238],[626330,5448377],[626762,5448266],[626460,5447072],[626189,5446574],[625789,5447019],[625417,5446493],[624785,5448097],[624237,5448160],[624322,5446417],[625133,5446251],[624749,5443454],[623391,5443185],[622726,5441797],[620100,5441825],[618656,5441225],[617877,5442172],[618344,5443227],[617778,5444188],[615666,5444021],[615451,5446255],[613304,5445763],[612658,5447706],[611778,5447254],[610655,5447467],[610127,5448650],[609064,5449011],[608293,5450296],[606275,5449995],[604956,5452145],[603154,5453817]],
	[[618064,5408674],[618071,5409723],[620636,5409863],[621348,5410596],[622567,5410168],[622645,5408598],[621816,5407330],[621659,5406061],[619013,5406153],[618064,5408674]],
	[[617455,5484298],[617785,5485001],[620408,5485716],[620866,5484783],[622374,5484381],[622714,5482870],[622436,5482158],[621696,5482065],[619882,5482880],[617994,5482287],[617508,5482884],[617941,5483599],[617455,5484298]],
	[[617812,5513316],[617766,5514192],[618312,5515003],[619114,5515049],[619285,5516178],[620020,5516226],[620436,5514933],[622101,5514482],[622497,5513901],[622396,5513514],[621282,5513322],[621120,5512662],[619369,5512359],[618661,5513169],[617812,5513316]],
	[[618439,5469857],[618974,5471573],[619944,5471653],[620396,5471274],[620835,5469017],[619821,5467907],[618653,5468525],[618439,5469857]],
	[[613605,5531585],[614922,5532125],[614827,5533912],[615699,5533849],[616112,5532398],[616906,5532068],[616841,5529186],[614259,5529219],[613605,5531585]],
	[[612431,5490201],[612439,5493076],[615291,5492183],[614707,5488162],[613686,5488877],[612964,5488726],[612431,5490201]],
	[[613201,5543604],[614013,5544134],[614160,5545361],[614608,5545579],[615281,5544983],[615517,5544155],[615114,5543170],[613546,5542961],[613201,5543604]],
	[[609817,5462775],[611059,5464982],[612757,5465743],[612902,5461302],[610125,5461149],[609817,5462775]],
	[[605803,5544901],[605752,5545251],[608132,5545579],[608476,5544558],[609758,5544327],[609816,5542323],[609265,5542109],[607838,5542693],[607374,5543325],[606356,5543160],[605803,5544901]],
	[[603500,5513960],[603561,5515191],[605808,5515968],[605981,5517750],[607039,5517688],[607565,5513761],[607079,5510653],[606346,5510570],[605646,5511636],[604031,5512377],[603500,5513960]],
	[[602103,5528645],[601783,5531053],[602449,5531528],[602409,5532248],[603551,5532400],[603691,5531331],[604980,5530206],[605166,5529095],[606617,5528363],[606862,5526862],[605633,5527180],[603401,5526681],[602103,5528645]],
	[[602374,5549056],[603409,5549459],[603206,5551641],[604889,5551591],[605845,5550505],[605760,5548207],[603488,5547599],[602894,5547842],[602374,5549056]],
	[[600395,5468505],[600544,5469524],[602696,5468818],[603508,5469353],[605569,5466695],[605426,5465882],[604317,5465482],[603792,5466184],[602470,5466317],[600395,5468505]],
	[[601116,5475104],[603247,5475418],[603730,5474294],[603476,5473170],[601611,5472928],[601116,5475104]],
	[[597541,5438994],[597706,5439431],[596935,5440383],[598236,5440723],[598997,5442065],[601227,5442460],[601169,5441178],[602157,5440335],[602035,5439311],[600796,5439014],[600508,5438384],[598514,5438105],[597541,5438994]],
	[[596643,5536829],[596736,5537517],[598705,5537984],[598903,5539018],[600500,5539551],[601282,5539028],[601705,5534902],[600401,5534809],[599251,5536307],[597086,5536148],[596643,5536829]],
	[[596833,5476378],[596855,5476894],[597691,5477417],[598890,5477331],[598971,5475265],[597251,5475001],[596833,5476378]],
	[[594013,5435402],[595182,5435847],[597271,5435168],[597410,5431608],[596312,5431378],[594844,5431827],[594013,5435402]],
	[[592337,5606626],[594910,5607060],[595546,5606041],[595712,5603522],[595230,5603164],[593657,5603397],[592525,5605207],[592337,5606626]],
	[[591328,5526993],[591633,5527895],[593058,5527779],[593546,5527033],[594356,5527221],[594477,5526681],[595141,5526768],[595770,5524352],[593659,5524365],[592662,5526157],[591328,5526993]],
	[[589296,5508541],[589658,5509765],[591374,5510466],[591811,5509621],[593931,5509850],[594318,5508451],[593820,5507553],[592058,5507301],[591272,5506512],[590368,5506397],[589296,5508541]],
	[[588300,5488101],[589839,5488596],[590071,5488140],[592102,5488242],[592976,5487300],[591045,5485105],[589870,5484959],[588300,5488101]],
	[[587331,5461353],[587878,5463014],[588834,5462931],[588987,5462403],[590096,5462253],[590275,5460110],[588221,5460309],[587331,5461353]],
	[[585726,5540043],[587160,5541708],[587941,5541656],[588127,5540652],[588669,5540381],[588126,5538171],[586192,5537908],[586330,5539373],[585726,5540043]],
	[[584866,5552990],[585541,5554594],[586517,5554889],[587139,5554728],[587482,5553541],[588119,5553164],[588108,5552256],[585317,5552150],[584866,5552990]],
	[[582685,5452623],[585053,5452917],[584471,5450469],[583302,5450665],[582685,5452623]],
	[[581688,5536235],[583707,5536338],[584250,5534390],[584038,5532812],[582447,5533203],[581688,5536235]],
	[[572891,5415472],[574697,5415871],[574687,5417333],[575759,5417391],[577127,5416586],[577498,5415242],[579562,5414287],[579860,5412407],[580700,5411911],[580526,5410134],[579583,5409986],[579577,5408716],[577991,5408590],[576884,5410903],[575560,5411615],[575135,5412965],[573188,5413785],[572891,5415472]],
	[[576106,5492345],[577286,5492928],[577394,5494001],[578519,5493921],[578631,5493195],[579208,5493040],[579093,5491403],[578320,5490396],[578227,5489335],[577520,5489205],[576505,5490123],[576106,5492345]],
	[[571200,5468603],[571229,5469712],[572406,5469568],[573986,5470244],[575904,5467440],[575950,5466417],[572094,5466240],[571200,5468603]],
	[[569508,5548320],[570598,5549503],[571639,5548402],[573220,5549023],[574092,5548862],[574125,5548401],[574051,5547612],[572819,5547483],[571052,5546167],[570033,5546122],[569284,5547564],[569508,5548320]],
	[[571178,5428447],[573473,5428679],[573713,5425724],[571752,5425456],[571178,5428447]],
	[[566000,5491857],[567068,5492519],[566613,5494529],[568669,5494078],[569165,5491278],[569571,5491013],[569373,5489139],[567936,5489152],[566876,5489905],[566434,5489612],[566000,5491857]],
	[[562434,5512554],[563604,5512816],[563690,5513795],[564845,5514817],[566201,5515053],[566949,5514338],[566805,5511852],[564898,5511927],[564125,5511172],[563116,5511060],[562434,5512554]],
	[[560932,5451727],[561272,5453272],[562216,5453245],[562605,5454383],[563820,5454698],[564998,5454738],[565712,5453395],[566955,5452855],[566924,5451946],[565717,5450365],[563551,5450794],[561691,5450558],[560932,5451727]],
	[[563520,5439250],[563531,5439663],[564961,5440335],[566002,5439803],[565967,5438309],[565541,5437884],[564110,5438069],[563520,5439250]],
	[[554904,5562728],[556242,5563794],[555995,5564913],[556478,5565224],[556569,5566362],[559055,5566789],[559668,5567684],[560564,5567638],[561483,5566830],[561541,5566036],[563302,5565475],[563327,5564960],[564271,5564315],[563346,5562078],[561622,5560191],[561710,5558312],[560105,5558083],[559022,5558696],[558204,5559901],[556943,5559778],[556493,5561076],[555571,5560965],[554904,5562728]],
	[[557465,5433733],[558004,5436554],[560692,5435923],[560972,5434194],[560440,5432713],[558344,5432794],[557465,5433733]],
	[[548597,5548068],[553796,5548837],[554393,5548814],[554882,5548083],[556161,5548222],[556697,5546957],[555933,5545592],[557612,5545807],[558044,5546674],[559237,5545947],[559753,5545034],[559124,5543398],[560449,5542924],[560379,5541674],[559262,5541513],[558793,5540777],[556966,5541623],[554803,5540628],[551869,5541027],[550670,5541838],[550230,5542890],[550866,5543170],[550808,5544202],[549591,5544312],[548146,5545543],[548539,5546033],[547895,5547617],[548597,5548068]],
	[[547146,5508189],[547625,5510043],[548999,5509879],[549642,5507999],[550832,5507465],[550769,5506509],[547912,5506822],[547146,5508189]],
	[[541088,5620329],[541729,5620916],[541760,5621968],[543222,5621882],[544316,5621061],[544637,5621657],[545311,5621506],[545755,5620215],[543446,5618847],[542625,5619509],[541451,5619350],[541088,5620329]],
	[[539232,5473492],[539775,5473868],[539895,5474871],[542161,5475558],[542139,5476306],[543029,5476970],[542904,5477774],[544879,5478399],[544379,5476510],[545432,5472966],[544521,5472722],[544038,5470054],[542729,5469925],[542338,5470773],[540408,5471663],[539232,5473492]],
	[[538766,5497401],[540800,5496963],[542172,5497604],[542597,5497022],[543260,5497094],[543657,5494772],[543365,5493751],[541895,5493151],[541494,5494090],[540139,5493966],[539501,5494573],[538766,5497401]],
	[[540506,5431287],[541099,5432196],[543383,5431802],[543304,5429624],[541374,5429047],[540273,5430799],[540506,5431287]],
	[[533432,5460529],[533616,5462172],[535217,5462283],[536231,5461221],[535287,5459212],[533776,5459359],[533432,5460529]],
	[[531566,5449077],[532610,5449995],[533907,5449505],[535060,5449839],[534841,5448302],[534095,5447948],[534154,5446630],[533585,5446414],[531887,5447828],[531566,5449077]],
	[[530083,5436821],[529752,5437360],[530120,5438080],[532350,5439477],[533389,5437323],[533224,5436479],[531731,5435618],[530083,5436821]],
	[[527836,5502562],[527926,5503439],[529178,5504222],[530089,5503339],[531119,5503133],[530855,5502151],[529708,5501608],[528747,5501536],[527836,5502562]],
	[[526234,5529199],[527226,5531745],[528024,5531843],[528865,5530150],[529344,5530059],[529440,5527620],[527687,5527421],[526234,5529199]],
	[[523112,5589222],[524988,5590297],[526312,5589763],[527714,5587954],[527484,5586633],[525388,5585264],[524409,5585250],[523112,5589222]],
	[[524461,5598501],[524420,5599143],[524952,5599509],[524762,5600501],[525561,5600567],[526084,5599889],[527068,5599768],[527649,5597348],[527134,5596769],[525943,5597118],[524461,5598501]],
	[[523783,5488078],[524480,5489698],[525557,5490718],[527256,5489554],[526548,5486853],[525752,5486369],[525006,5486310],[523783,5488078]],
	[[521615,5607321],[521963,5607858],[524169,5607865],[525208,5605323],[523285,5604972],[522482,5605431],[521615,5607321]],
	[[518110,5621426],[517831,5622027],[519164,5622938],[520980,5622395],[521282,5623077],[522582,5623108],[523185,5622006],[522140,5620416],[519676,5620265],[518110,5621426]],
	[[516207,5533615],[516340,5534342],[517706,5534568],[517590,5535432],[519235,5535997],[520026,5535809],[520882,5536920],[522599,5536229],[520895,5531219],[518957,5531267],[517966,5532513],[516758,5532799],[516207,5533615]],
	[[516464,5610635],[517402,5612038],[517999,5612209],[518308,5611779],[519848,5611602],[520386,5610196],[519961,5609199],[517732,5609253],[516464,5610635]],
	[[514609,5477148],[515296,5477872],[516217,5477945],[516923,5477898],[517101,5477176],[517762,5476942],[516774,5472230],[515253,5472831],[514638,5474130],[514258,5475332],[514747,5475647],[514609,5477148]],
	[[508747,5622164],[508859,5623278],[510350,5623122],[511504,5623944],[512010,5622672],[513273,5622375],[513871,5621472],[514534,5621745],[514436,5620655],[513980,5620725],[513729,5619991],[514207,5617995],[513034,5616365],[511191,5616079],[510800,5618444],[509950,5618953],[508747,5622164]],
	[[507816,5605470],[508382,5606758],[510454,5607273],[512139,5606588],[512996,5605275],[512228,5603264],[510819,5602804],[510251,5603405],[508636,5603600],[508174,5604233],[508594,5604733],[507816,5605470]],
	[[506449,5430440],[506195,5431065],[506844,5431258],[506919,5431793],[507902,5431810],[508507,5429683],[506861,5429439],[506449,5430440]],
	[[499060,5623444],[500097,5624710],[500047,5626070],[500635,5626384],[500483,5627541],[501823,5628594],[503150,5628044],[505394,5629015],[505568,5628081],[506214,5628248],[506040,5626138],[507801,5626036],[508092,5624652],[507699,5621130],[504736,5619115],[502694,5619014],[500777,5620769],[500109,5620775],[500088,5622371],[499060,5623444]],
	[[503068,5641617],[504381,5642638],[504550,5643491],[505552,5643472],[506705,5642739],[506875,5640207],[506266,5639687],[505160,5640656],[504461,5640284],[503383,5640772],[503068,5641617]],
	[[499607,5558870],[500650,5560024],[500507,5561079],[501858,5561623],[501738,5562694],[503630,5562955],[503878,5562137],[505165,5561627],[506126,5560403],[505577,5559062],[504798,5558481],[502668,5558154],[502492,5557503],[500792,5556243],[499607,5558870]],
	[[498092,5446521],[501845,5447488],[502401,5445579],[503488,5445424],[504059,5441976],[499194,5441787],[498092,5446521]],
	[[494554,5630543],[497985,5630185],[499043,5631772],[498884,5630691],[498018,5629549],[494803,5629411],[494259,5630431],[494554,5630543]],
	[[490363,5507743],[491391,5509066],[493612,5510008],[493602,5509208],[494414,5508934],[494523,5507609],[494990,5507433],[494885,5504524],[493084,5504326],[492754,5504797],[491619,5504728],[490363,5507743]],
	[[487315,5634952],[488552,5635960],[489705,5635798],[490113,5634861],[490865,5634451],[490187,5632423],[488248,5632865],[487315,5634952]],
	[[480774,5428773],[481533,5429826],[481255,5430857],[482590,5431200],[482790,5430512],[485444,5429989],[486069,5428846],[485942,5428236],[484147,5428003],[483832,5427277],[483214,5427191],[482897,5427551],[481390,5427366],[480774,5428773]],
	[[479077,5612339],[479843,5613779],[481025,5614109],[482014,5612548],[481999,5610735],[480489,5610161],[479838,5612041],[479303,5611901],[479077,5612339]],
	[[477604,5457963],[477556,5458542],[477976,5458642],[480271,5458559],[480754,5456971],[480178,5454694],[479142,5455247],[477604,5457963]],
	[[476536,5449197],[476825,5449764],[478510,5450544],[479103,5451965],[479691,5451956],[480178,5451149],[480374,5448556],[477750,5446971],[476536,5449197]],
	[[443193,5552878],[443902,5554302],[445854,5554407],[446199,5555082],[448406,5555464],[448472,5556060],[452326,5556660],[452328,5557411],[453165,5558390],[457370,5558835],[458082,5559443],[460121,5559867],[460139,5560491],[461442,5560748],[461844,5561433],[467108,5562313],[468102,5560672],[469982,5559961],[470096,5559393],[472222,5559265],[472572,5558773],[472395,5556365],[474718,5556639],[474853,5555813],[477045,5555664],[476887,5553538],[479045,5552962],[478931,5552136],[479917,5551971],[480101,5550654],[479731,5548322],[478996,5547017],[476916,5546538],[477385,5544350],[477085,5543225],[477754,5542921],[477169,5540879],[475643,5538781],[472147,5538238],[471771,5538870],[469849,5539834],[467485,5539597],[466883,5538175],[463930,5537767],[463804,5537302],[462441,5536936],[462373,5535715],[458067,5534478],[457535,5532637],[455670,5532317],[454111,5533384],[451647,5533011],[450632,5534143],[449643,5535877],[450381,5536358],[449785,5537646],[450194,5538107],[449306,5539079],[448674,5539092],[447413,5540913],[448337,5541612],[444279,5547786],[445361,5548946],[444030,5550208],[442864,5552474],[443193,5552878]],
	[[472689,5474766],[473016,5475493],[474353,5476022],[475038,5477279],[475870,5477380],[476228,5476376],[477129,5477146],[477986,5476717],[477705,5475344],[478023,5474280],[479848,5473450],[479822,5472738],[477979,5471826],[479131,5470799],[479044,5468186],[478456,5467994],[477213,5468873],[475909,5471615],[476001,5472693],[474586,5472845],[473068,5473910],[472689,5474766]],
	[[475472,5514358],[476626,5517010],[478381,5516447],[478495,5515748],[479227,5515455],[479224,5514237],[478595,5513304],[477027,5512540],[475472,5514358]],
	[[473724,5603736],[474689,5604221],[475332,5603539],[476963,5603512],[477036,5601921],[475694,5600659],[474613,5601387],[473724,5603736]],
	[[471307,5641831],[472051,5642640],[474403,5642673],[474855,5641571],[475719,5641123],[475693,5639667],[474551,5639048],[473818,5637510],[472810,5637501],[472348,5638248],[472226,5639393],[471635,5639505],[471307,5641831]],
	[[466710,5646091],[467192,5646966],[468130,5647180],[468333,5648326],[470020,5648004],[469865,5645831],[470764,5645084],[470481,5643702],[469002,5643904],[467694,5643323],[466710,5646091]],
	[[467027,5623811],[467248,5625563],[467966,5625915],[468733,5625592],[468781,5624925],[469382,5624774],[469443,5622430],[468165,5622136],[467287,5622537],[467027,5623811]],
	[[464402,5616285],[464724,5617336],[467843,5618517],[469546,5615791],[469182,5613762],[466529,5612682],[464523,5614380],[464899,5615366],[464402,5616285]],
	[[457292,5427539],[459013,5428369],[459434,5429327],[462823,5430158],[463458,5428904],[465145,5427728],[465363,5426247],[464646,5423668],[461840,5422497],[461309,5421413],[460774,5421376],[459168,5423254],[458737,5425408],[457292,5427539]],
	[[461059,5399210],[460852,5399750],[461394,5400056],[461365,5400625],[462807,5400885],[464207,5399333],[463663,5397844],[462009,5397633],[461059,5399210]],
	[[457398,5435152],[458080,5436069],[458888,5435811],[460183,5436186],[460216,5435623],[461201,5434882],[460865,5433644],[460219,5433139],[458436,5432929],[457398,5435152]],
	[[457181,5501077],[457316,5502213],[458507,5503780],[459094,5503697],[459404,5502051],[460399,5502029],[460800,5501337],[460219,5500132],[458363,5499392],[457181,5501077]],
	[[455996,5453751],[456193,5454247],[458291,5454857],[459334,5452816],[458991,5451122],[458013,5450943],[456815,5451913],[455996,5453751]],
	[[454178,5591139],[454930,5591876],[456196,5591996],[456609,5591026],[457202,5590904],[457023,5589617],[455746,5588469],[455111,5588741],[454178,5591139]],
	[[452270,5477897],[452718,5478528],[452564,5479288],[454023,5480614],[455137,5479103],[455162,5478219],[456320,5477584],[455858,5476676],[454266,5476405],[452855,5476955],[452270,5477897]],
	[[447952,5408191],[448726,5408782],[448880,5409660],[450138,5409318],[451745,5409607],[451616,5408267],[449617,5405024],[448527,5405117],[448268,5405609],[448575,5406913],[447952,5408191]],
	[[445314,5586993],[446184,5588149],[448142,5587492],[449571,5589140],[450309,5588923],[449731,5586492],[447351,5585010],[446375,5584935],[445314,5586993]],
	[[440882,5625264],[441225,5626304],[441845,5626522],[443445,5626564],[445732,5627586],[446737,5627066],[446354,5624309],[444672,5624041],[444061,5622647],[441876,5622371],[440882,5625264]],
	[[438963,5516182],[440140,5517341],[441699,5517190],[441897,5515982],[441244,5515876],[440738,5514456],[439830,5513995],[438963,5516182]],
	[[431944,5555658],[431319,5557157],[433723,5557982],[433457,5558942],[433953,5559604],[435593,5560389],[436691,5560480],[437721,5559493],[438628,5559564],[439333,5558290],[440514,5558846],[441445,5558100],[441369,5556674],[438961,5555106],[438639,5552659],[438077,5552042],[436119,5552475],[435422,5553931],[434300,5554488],[432811,5554036],[431944,5555658]],
	[[431162,5598417],[432768,5598997],[432787,5598346],[433885,5597381],[436146,5597746],[436280,5596304],[434507,5595448],[432042,5595421],[431052,5597194],[431162,5598417]],
	[[436896,5598134],[436088,5599990],[436942,5601365],[438360,5601607],[439469,5600473],[440377,5600393],[441431,5599509],[441374,5598391],[436896,5598134]],
	[[438166,5445215],[439222,5445999],[440931,5446194],[441272,5443609],[439042,5443336],[438166,5445215]],
	[[435526,5463037],[436377,5463892],[436215,5464508],[438811,5465050],[440220,5464341],[439566,5460984],[438677,5460048],[437386,5460231],[436874,5460955],[435973,5460794],[435487,5461646],[435526,5463037]],
	[[427059,5617057],[430515,5617476],[431267,5616731],[432252,5616582],[432743,5615470],[433689,5615445],[434337,5614825],[435475,5615193],[436006,5615978],[437786,5616066],[437980,5614371],[436647,5612643],[434756,5612337],[434312,5611277],[432913,5610734],[432337,5610695],[431592,5611618],[429063,5611385],[427529,5614630],[428447,5615041],[427059,5617057]],[[429110,5614781],[428720,5614943],[428555,5614549],[428949,5614386],[429110,5614781]],
	[[432682,5565671],[432787,5566737],[435338,5567487],[436744,5566089],[436889,5564595],[433935,5563074],[433252,5563482],[432682,5565671]],
	[[428442,5532798],[429107,5534233],[428796,5534891],[430694,5535672],[433254,5538350],[435070,5536950],[434934,5534921],[433892,5534012],[432293,5533747],[429776,5531030],[429089,5531039],[428442,5532798]],
	[[425439,5503905],[425681,5505395],[426820,5506494],[426523,5507332],[426947,5507664],[428770,5507786],[429391,5506706],[431150,5505940],[430736,5504457],[429756,5504611],[429285,5502906],[428086,5502714],[426696,5501542],[426060,5501754],[425439,5503905]],
	[[425679,5429444],[425342,5431857],[426670,5431903],[427407,5431381],[428176,5431718],[428183,5428001],[426449,5428198],[425679,5429444]],
	[[413402,5611676],[413447,5612580],[414297,5613204],[413636,5616538],[414212,5616625],[414787,5615511],[417407,5615925],[419116,5616736],[419463,5616299],[422623,5616696],[422334,5614132],[419993,5613301],[419755,5611467],[420876,5609581],[420586,5608512],[418924,5608317],[418067,5609485],[417594,5609303],[417486,5608443],[415775,5608532],[415345,5609668],[414019,5610451],[413402,5611676]],
	[[418049,5458775],[417940,5459197],[420028,5460020],[421146,5460173],[421372,5459727],[422395,5459693],[422537,5457024],[422096,5456820],[421846,5455551],[420209,5455015],[418049,5458775]],
	[[418885,5520918],[419040,5522532],[419656,5523105],[420284,5522843],[421887,5523441],[422424,5520974],[420988,5520431],[418885,5520918]],
	[[416813,5476576],[417180,5477534],[418462,5477888],[420220,5477235],[420053,5475706],[419199,5474471],[417110,5475309],[416813,5476576]],
	[[411659,5579347],[413445,5580946],[414098,5581051],[414439,5580606],[415949,5581259],[416929,5580464],[416293,5577561],[415414,5578102],[414251,5577965],[413809,5578895],[411815,5578691],[411659,5579347]],
	[[409546,5608207],[409828,5609487],[410462,5609836],[412783,5607624],[413408,5607733],[413392,5608712],[414334,5608487],[414677,5606484],[415827,5606505],[416183,5605704],[416200,5602925],[414534,5603057],[414477,5601588],[415255,5601350],[415181,5600689],[414590,5599615],[413995,5599662],[413575,5599046],[411855,5599266],[411378,5601158],[411783,5601533],[411621,5602946],[412590,5603751],[412359,5605365],[412087,5605890],[410593,5606350],[409546,5608207]],
	[[408691,5436355],[411213,5437663],[411424,5436520],[412492,5436535],[412465,5435630],[413210,5435378],[413095,5434112],[410470,5433437],[409524,5434015],[408691,5436355]],
	[[406473,5553218],[407721,5553632],[410151,5552718],[410996,5552066],[410946,5549767],[408685,5549513],[407095,5551014],[406473,5553218]],
	[[399335,5592905],[401527,5594085],[399863,5596881],[399597,5598578],[401289,5598696],[401602,5599252],[402752,5599408],[403322,5599019],[404473,5599660],[404505,5598796],[406430,5597148],[407455,5598306],[408399,5598596],[408628,5595656],[410192,5593448],[409494,5592253],[408030,5593773],[406049,5593168],[405292,5593406],[403880,5591195],[401770,5591894],[399841,5591674],[399335,5592905]],[[400760,5596761],[401068,5596454],[401446,5596764],[401119,5597068],[400760,5596761]],
	[[397126,5606333],[398047,5606837],[397869,5607558],[399747,5607888],[399460,5609498],[400128,5610479],[401913,5609969],[403146,5608552],[403737,5608607],[404395,5609589],[405625,5609606],[405236,5607872],[405907,5607661],[406010,5603617],[404882,5603166],[404193,5604281],[403222,5604403],[402681,5605260],[397784,5604666],[397126,5606333]],
	[[396482,5511202],[397155,5512555],[398398,5512763],[398763,5513270],[399687,5513333],[400694,5512241],[400199,5509890],[399292,5509396],[398132,5509581],[396482,5511202]],
	[[393520,5577673],[393694,5578598],[395556,5578426],[395943,5579435],[396644,5579787],[396883,5578867],[397867,5578825],[397526,5577454],[398545,5576763],[398499,5575567],[395293,5574807],[393520,5577673]],
	[[384838,5590464],[384936,5593383],[386217,5594563],[387045,5594540],[387063,5595832],[388140,5596972],[389680,5597337],[390011,5598084],[390926,5598077],[391411,5596458],[390747,5593443],[389767,5593211],[389226,5593578],[388922,5593161],[389938,5592150],[389342,5589432],[387973,5589542],[385559,5588575],[384949,5589247],[384838,5590464]],
	[[376547,5513278],[376927,5514213],[378430,5515136],[378534,5515672],[382005,5516984],[383705,5517202],[386833,5516460],[386915,5515614],[387841,5515585],[388225,5514895],[387968,5513357],[388344,5512624],[388123,5511482],[387457,5511323],[386743,5505557],[386121,5505414],[385445,5506050],[384691,5507661],[381459,5507881],[380846,5509158],[378158,5509564],[377376,5510785],[377632,5512051],[376942,5512165],[376547,5513278]],
	[[384547,5564496],[384998,5564735],[385197,5566445],[387079,5567072],[387000,5564644],[385751,5564442],[385548,5563754],[384737,5563651],[384547,5564496]],
	[[377595,5494108],[377870,5494569],[379930,5494993],[380603,5493007],[378559,5491695],[377595,5494108]],
	[[368721,5581875],[369548,5582999],[368810,5585159],[370193,5585344],[370597,5586290],[371789,5586394],[372568,5584171],[373809,5584123],[374142,5583141],[372714,5582682],[372283,5581935],[370943,5582770],[370095,5582588],[369477,5581634],[368721,5581875]],
	[[374773,5583162],[374745,5583548],[375490,5583667],[375517,5585279],[378137,5585706],[377671,5583899],[378456,5583514],[378652,5582505],[378087,5581115],[377629,5580969],[374773,5583162]],
	[[375405,5501688],[376295,5503399],[378155,5503489],[378198,5501966],[376687,5501048],[376565,5500304],[376018,5500244],[375405,5501688]],
	[[373314,5474517],[373871,5475201],[373797,5476092],[377001,5475564],[377115,5474658],[377864,5474529],[378010,5473967],[377339,5470667],[376679,5470188],[375949,5470515],[375460,5471916],[374533,5472148],[373749,5473084],[373314,5474517]],
	[[368661,5509305],[370016,5510009],[372113,5509868],[372288,5507744],[369829,5507344],[368661,5509305]],
	[[353710,5514344],[355018,5514674],[355092,5515483],[356679,5515527],[356891,5512231],[355482,5511453],[355051,5512786],[354003,5513284],[353710,5514344]],
	[[347432,5479459],[348934,5480676],[350478,5480828],[351435,5479074],[352546,5478876],[352351,5476957],[350755,5477116],[349983,5477994],[348116,5478132],[347432,5479459]],
	[[343504,5566959],[344203,5568049],[343869,5570073],[346173,5570275],[346762,5569461],[348923,5569885],[349059,5569347],[350395,5569032],[350621,5568568],[350632,5566341],[349939,5566147],[349512,5564813],[347556,5565931],[344627,5564864],[343504,5566959]],
	[[341193,5558334],[342223,5558376],[344243,5557356],[344926,5557550],[343466,5554445],[341699,5555049],[341193,5558334]],
	[[337422,5568201],[338298,5569758],[339836,5569674],[340578,5568682],[340746,5566785],[338976,5566181],[337422,5568201]],
	[[336478,5577369],[337435,5578999],[339215,5578995],[339815,5578428],[339932,5576421],[337493,5576427],[336478,5577369]],
	[[333572,5537307],[333504,5538101],[334781,5538555],[334741,5540194],[336163,5539736],[335979,5537946],[336123,5537192],[336687,5537056],[336656,5535837],[335570,5535247],[334766,5535506],[333572,5537307]],
	[[330309,5560556],[330842,5561795],[330692,5563667],[333344,5563826],[333637,5563186],[334517,5562951],[334481,5561109],[333898,5559665],[332649,5559874],[332267,5559124],[330649,5558915],[330309,5560556]],
	[[328073,5518548],[327698,5519238],[328168,5519465],[328646,5521055],[330681,5521849],[331358,5521346],[331674,5519852],[333235,5519492],[332610,5518090],[331413,5517545],[330406,5518115],[329016,5517918],[328073,5518548]],
	[[321187,5578534],[321287,5580827],[322080,5580667],[322265,5581426],[323724,5581515],[324048,5579201],[324623,5578437],[323778,5577414],[323698,5576151],[323034,5576031],[322628,5577558],[321460,5577525],[321187,5578534]],
	[[309421,5552153],[310703,5552646],[311302,5553569],[313497,5553383],[315770,5552095],[315614,5551117],[314028,5550730],[314451,5549146],[314080,5548127],[312990,5547984],[311198,5548447],[309591,5550908],[309421,5552153]],
	[[297199,5569052],[297678,5570187],[299536,5570301],[299569,5569354],[301314,5567740],[301480,5565364],[300781,5565087],[299485,5566309],[297840,5566341],[297440,5567514],[297987,5567987],[297199,5569052]],
	[[525190,5426920],[523901,5428832],[526783,5429190],[526681,5427164],[525190,5426920]]
];