use strict;
use warnings;
use utf8;
use LWP::Simple;

my $basepath = "\" + window.basePath + \"Seznam";#"Seznam";

# get loader.js
download ('http://api4.mapy.cz/loader.js', 'loader.js');

# put relative links in there
my $put_to_loader_js = "list[0] = '$basepath/jak.js';"
  . "list[1] = '$basepath/smap.js';"
  . "list[2] = '$basepath/config.js';";
  
my $loader_js = read_file("loader.js");
$loader_js =~ s/(?<!;)(if \(this\.async\))/$put_to_loader_js$1/;
$loader_js .= ";Loader.load();"; # add loader
save_file("loader.js", $loader_js);

# get version parameter
my $version = ($loader_js =~ m/version: "(\d+)"/)[0];

# download all JS files
foreach my $url (
  "http://api4.mapy.cz/js/api/jak.js?v=$version", 
  "http://api4.mapy.cz/js/api/smap.js?v=$version",
  "http://api4.mapy.cz/config.js?key=&v=$version")
{
  download ($url, $url =~ s|^.*/(.*?\.js).*|$1|r);
}

# change path to images
my $config_js = read_file("config.js");
# $config_js =~ s|(SMap\.CONFIG\.base).*?;|$1 = "$basepath";|;
$config_js =~ s|(SMap\.CONFIG\.img).*?;|$1 = "$basepath/img/api";|;
$config_js =~ s|(SMap\.CONFIG\.css).*?;|$1 = "$basepath/css/api";|; # deprecated since v89
save_file("config.js", $config_js);

# download images/css
mkdir "img";
mkdir "img/api";
mkdir "img/api/zoom";
mkdir "img/api/layer-switch";
mkdir "img/api/compass";
mkdir "img/api/card";
mkdir "img/api/marker";
mkdir "css";
mkdir "css/api";
my $img_url = "http://api4.mapy.cz";

download_img ("$img_url/img/api", "logo.png");
download_img ("$img_url/img/api", "preview-letecka.png", "preview-zakladni.png", "preview-turisticka.png", "preview-letecka0203.png", "preview-letecka0406.png", "preview-historicka.png", "preview-zimni.png", "preview-letni.png", "preview-zemepisna.png");
download_img ("$img_url/img/api", "ccw.png", "cw.png", "cw-smooth.png", "cw-smooth-hover.png");
download_img ("$img_url/img/api/zoom", "plus.png", "minus.png", "bird.png", "slider.png", "top.png", "middle.png", "bottom.png");
download_img ("$img_url/img/api/layer-switch", "outer-glow.png", "uncheck-border.png", "button.png", "l-arr.png", "r-arr.png"); # old: "prev.gif", "next.gif",
download_img ("$img_url/img/api/compass", "compass-n.png", "compass-e.png", "compass-s.png", "compass-w.png");
download_img ("$img_url/img/api/card", "close.png", "tail.png", "card-l.png", "card-r.png", "card-t.png", "card-b.png", "card-lb.png", "card-rb.png", "card-rt.png", "card-lt.png");
download_img ("$img_url/img/api/marker", "drop-red.png", "drop-blue.png", "drop-yellow.png", "drop-shadow.png");
download_img ("$img_url/css/api", "api.css", "card.css");  # original: api.css?$version, card.css?$version

# fix paths in CSS files
foreach my $css_file ("css/api/api.css", "css/api/card.css")
{
  my $css_content = read_file($css_file);
  $css_content =~ s|\((/img/api)|(../..$1|g;
  save_file($css_file, $css_content);
}

# comment unused stuff in smap.js
# -- doesn't work correctly, because some lines don't start with SMap.Coords
# my $smap = read_file("smap.js");
# $smap =~ s|^(SMap\.Coords\..*)$|//$1|mg;
# save_file("smap2.js", $smap);

################################################################################

# download image (filename)
sub download_img
{
  my $url_start = shift;
  my $path = $url_start =~ s|^.*\.cz/||r;

  foreach (@_)
  {
    my $filename = $_;
    download ("$url_start/$filename", "$path/$filename") unless -e "$path/$filename";
    print  "$url_start/$filename" . "\n";
  }
}

# download (url, filename)
sub download
{
  my $url = shift;
  my $filename = shift;
  getstore($url, "$filename") unless -e $filename;  
}

# read_file (filename)
sub read_file
{
  open (FILE, "<:utf8", shift) or die $!;
  local $/;
  my $str = <FILE>;
  close FILE;
  $str;
}

# save_file (filename, content)
sub save_file
{
  open (MYFILE, ">:utf8", shift) or die $!;
  print MYFILE shift;
  close (MYFILE);
}