// info: might use proj4js library in the future (can convert between projections)

/* custom map definitions */
var default_preview_path = "../../../Images/Maps/";

SMap.CONFIG["ZM10_ID"] = 
{
  zoom: [3, 16],
  label: "ZM10",
  title: "Základní mapa 10k",
  preview: default_preview_path + "ZM10.jpg",
  url: "",
  options: {prefetch: 0, tileSize: 256, gcDelay: (1000 * 3600 * 1)},
  copyright: {"1-": "ČÚZK"},
  projection: SMap.projUTM33,

  buildUrl: function(t /*tile*/)
  {
    if      (t.zoom >= 13) var mapType = "GR_ZM10";
    else if (t.zoom >= 11) var mapType = "GR_ZM50";
    else if (t.zoom >= 9)  var mapType = "GR_MCR500";
    else if (t.zoom >= 0)  var mapType = "GR_CR4";
    
    if      (t.zoom >= 13) var mapDir = "WMS_ZM10_PUB";
    else if (t.zoom >= 11) var mapDir = "WMS_ZM50_PUB";
    else if (t.zoom >= 0)  var mapDir = "WMS_PREHLEDKY";

    // http://geoportal-zm3.cuzk.cz/WMS_ZM10_PUB/service.svc/get?SERVICE=WMS&REQUEST=GetMap&VERSION=1.3.0&LAYERS=GR_ZM10&FORMAT=image%2Fpng8&WIDTH=256&HEIGHT=256&BBOX=458208,5548320,458464,5548576&CRS=EPSG%3A32633&STYLES=&TRANSPARENT=TRUE
    return ("http://geoportal-zm" + Math.floor(Math.random() * 4) + ".cuzk.cz" + "/" + mapDir + "/service.svc/get?"
      + "SERVICE=WMS&REQUEST=GetMap&VERSION=1.3.0" + "&LAYERS=" + mapType + "&FORMAT=" + encodeURIComponent("image/png8") 
      + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize + "&BBOX=" + t.getBBOX(this.getMap()) 
      + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode()) + "&STYLES=&TRANSPARENT=FALSE");  
  }
};

// http://mapy.vugtk.cz/mapserver/index_wms.php
SMap.CONFIG["Muller_ID"] = 
{
  zoom: [10, 15],
  label: "Müllerova mapa",
  title: "Müllerova mapa Čech a Moravy (1720)",
  preview: default_preview_path + "Mullerova mapa.png",
  url: "",
  options: {prefetch: 0, tileSize: 512},
  copyright: {"1-": "VÚGTK"},
  
  // nepoužívá ve skutečnosti ArcGIS, použit trik aby fungovalo S-JTSK
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 512,
    "cols": 512,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 55,
    "origin": {"x": -33699800, "y": 33699800},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 128.01625603251208, "scale": 483840},
      "1": {"resolution": 64.00812801625604, "scale": 241920},
      "2": {"resolution": 32.00406400812802, "scale": 120960},
      "3": {"resolution": 16.00203200406401, "scale": 60480},
      "4": {"resolution": 8.001016002032005, "scale": 30240},
      "5": {"resolution": 4.000508001016002, "scale": 15120},
      //"6": {"resolution": 2.000254000508001, "scale": 7560},
    }
  },
  {
    "xmin": -1966019.01672004,
    "ymin": -1828752.51746725,
    "xmax": 723602.115135592,
    "ymax": -278689.121977079,
    "spatialReference": {"wkid": 102067}
  }, 10),

  buildUrl: function(t /*tile*/)
  {
    return ("http://mapy.vugtk.cz/cgi-bin/mapserv?bbox=" + t.getBBOX(this.getMap()) 
    + "&width=" + t.tileSize + "&height=" + t.tileSize + "&map=/var/www/map_data/wms.map&srs=" 
    + encodeURIComponent("epsg:2065") + "&request=GetMap&version=1.1.1&layers=muller,mullermorava&format=" 
    + encodeURIComponent("image/jpeg") + "&styles=");      
       
  }
};

SMap.CONFIG["Orto_CZ_ID"] = 
{
  zoom: [7, 19],
  label: "Ortofoto ČR",
  title: "Ortofoto ČR",
  preview: default_preview_path + "Orto_CZ.png",
  url: "",
  options: {prefetch: 0, tileSize: 256},
  buildUrl: function(t /*tile*/)
  {
    return "http://ags.cuzk.cz/ArcGIS/rest/services/ortofoto/MapServer/tile/" + (t.zoom - 7) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": "Podkladová data ČÚZK"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 256,
    "cols": 256,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 55,
    "origin": {"x": -33699800, "y": 33699800},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 1024.1300482600966, "scale": 3870720},
      "1": {"resolution": 512.0650241300483, "scale": 1935360},
      "2": {"resolution": 256.03251206502415, "scale": 967680},
      "3": {"resolution": 128.01625603251208, "scale": 483840},
      "4": {"resolution": 64.00812801625604, "scale": 241920},
      "5": {"resolution": 32.00406400812802, "scale": 120960},
      "6": {"resolution": 16.00203200406401, "scale": 60480},
      "7": {"resolution": 8.001016002032005, "scale": 30240},
      "8": {"resolution": 4.000508001016002, "scale": 15120},
      "9": {"resolution": 2.000254000508001, "scale": 7560},
      "10": {"resolution": 1.0001270002540006, "scale": 3780},
      "11": {"resolution": 0.5000635001270003, "scale": 1890},
      "12": {"resolution": 0.25003175006350015, "scale": 945}
    }
  },
  {
    "xmin": -1966019.01672004,
    "ymin": -1828752.51746725,
    "xmax": 723602.115135592,
    "ymax": -278689.121977079,
    "spatialReference": {"wkid": 102067}
  }, 7)
};

/* nefunguje od asi 12-2014 */
SMap.CONFIG["Orto_50_ID"] = 
{
  zoom: [6, 19],
  label: "Ortofoto 50. léta",
  title: "Ortofoto 50. léta",
  preview: default_preview_path + "Orto_50.jpg",
  url: "",
  options: {prefetch: 0, tileSize: 256/*, defaultProjection: SMap.projUTM33*/},
  buildUrl: function(t /*tile*/)
  {
    return "http://geoportal.gov.cz/ArcGIS/rest/services/CENIA/cenia_rt_ortofotomapa_historicka/MapServer/tile/" + (t.zoom - 6) + "/" + t.y + "/" + t.x + "?token=Mn49ZeGjfwv30XHn6IU65jr3NOYs875okWB2cPvRLvNZl8mKd_xXPMNGZNh_dxFg2qGqQc3asCorQKzH7v4b_c7rqFCA-bro4qHIhJ184Xc.";
  },  
  
  copyright: {"1-": "CENIA 2010"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 256,
    "cols": 256,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 75,
    "origin": {"x": -920000.0, "y": -920000.0},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 2048.260096520193, "scale": 7741440},
      "1": {"resolution": 1024.1300482600966, "scale": 3870720},
      "2": {"resolution": 512.0650241300483, "scale": 1935360},
      "3": {"resolution": 256.03251206502415, "scale": 967680},
      "4": {"resolution": 128.01625603251208, "scale": 483840},
      "5": {"resolution": 64.00812801625604, "scale": 241920},
      "6": {"resolution": 32.00406400812802, "scale": 120960},
      "7": {"resolution": 16.00203200406401, "scale": 60480},
      "8": {"resolution": 8.001016002032005, "scale": 30240},
      "9": {"resolution": 4.000508001016002, "scale": 15120},
      "10": {"resolution": 2.000254000508001, "scale": 7560},
      "11": {"resolution": 1.0001270002540006, "scale": 3780},
      "12": {"resolution": 0.5000635001270003, "scale": 1890},
      "13": {"resolution": 0.2500317500635002, "scale": 945}
    }
  },
  {
    "xmin": -975345.6758081501,
    "ymin": -1283724.921699355,
    "xmax": -384561.6758081501,
    "ymax": -865996.921699355,
    "spatialReference": {"wkid": 102067}
  }, 6)    
};

// http://ags.cuzk.cz/ArcGIS/rest/services/zm/MapServer
// JS: http://ags.cuzk.cz/ArcGIS/rest/services/zm/MapServer?f=json
SMap.CONFIG["ZM10_SJTSK_ID"] = 
{
  zoom: [8, 18],
  label: "ZM10  Turbo",
  title: "Základní mapa 10k (S-JTSK verze - rychlejší)",
  preview: default_preview_path + "ZM10.jpg",
  options: {prefetch: 0, tileSize: 256/*, defaultProjection: SMap.projUTM33*/},
  buildUrl: function(t /*tile*/)
  {
    return "http://ags.cuzk.cz/ArcGIS/rest/services/zm/MapServer/tile/" + (t.zoom - 8) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": "Podkladová data ČÚZK"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 256,
    "cols": 256,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 90,
    "origin": {"x": -33699800, "y": 33699800},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 1024.1300482601, "scale": 3870720},
      "1": {"resolution": 512.065024130048, "scale": 1935360},
      "2": {"resolution": 256.032512065024, "scale": 967680},
      "3": {"resolution": 128.016256032512, "scale": 483840},
      "4": {"resolution": 64.008128016256, "scale": 241920},
      "5": {"resolution": 32.004064008128, "scale": 120960},
      "6": {"resolution": 16.002032004064, "scale": 60480},
      "7": {"resolution": 8.001016002032, "scale": 30240},
      "8": {"resolution": 4.000508001016, "scale": 15120},
      "9": {"resolution": 2.000254000508, "scale": 7560},
      "10": {"resolution": 1.000127000254, "scale": 3780}
    }
  },
  {
    "xmin": -1966019.01672004,
    "ymin": -1828752.51746725,
    "xmax": 723602.115135592,
    "ymax": -278689.121977079,
    "spatialReference": {"wkid": 102067}
  }, 8)
};

// http://oldmaps.geolab.cz
// http://archivnimapy.cuzk.cz/
SMap.CONFIG[SMap.DEF_HISTORIC] = {
	zoom: [5, 14],
	label: "II. voj. mapování",
	title: "II. vojenské mapování (1836–1852)",
	preview: "preview-historicka.png",
  options: {prefetch: 0, tileSize: 256, gcDelay: (1000 * 3600 * 1)},
	url: "http://m#.mapserver.mapy.cz/army2/",
  
  buildUrl: function(t /*tile*/)
  {
    if (t.zoom <= 13)
      return(this._buildURLOrig(t));

    return ("http://geoportal.gov.cz/ArcGIS/services/CENIA/cenia_rt_II_vojenske_mapovani/MapServer/WMSServer?"
      + "BBOX=" + t.getBBOX(this.getMap()) + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize
      + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode())
      + "&Layers=0&version=1.3.0&service=WMS&format=" + encodeURIComponent("image/png8") + "&request=GetMap&styles=");
  },  
  
	copyright: 
  {
		"-": ["2nd Military Survey, Austrian State Archive", "Datový podklad MŽP ČR", "Laboratoř geoinformatiky UJEP"]
	}  
};

// http://geoportal.gov.cz/web/guest/wms/
// http://geoportal.gov.cz/arcgis/rest/services/CENIA/cenia_rt_III_vojenske_mapovani/MapServer
SMap.CONFIG["VojMapIII_ID"] = 
{
  zoom: [5, 14],
  label: "III. voj. mapování",
  title: "III. vojenské mapování (1876-1878)",
  preview: default_preview_path + "III. vojenske mapovani.png",
  url: "",
  options: {prefetch: 0, tileSize: 512, gcDelay: (1000 * 3600 * 1)},
  projection: SMap.projUTM33,

  buildUrl: function(t /*tile*/)
  {
    return ("http://geoportal.gov.cz/ArcGIS/services/CENIA/cenia_rt_III_vojenske_mapovani/MapServer/WMSServer?"
      + "BBOX=" + t.getBBOX(this.getMap()) + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize
      + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode())
      + "&Layers=0&version=1.3.0&service=WMS&format=" + encodeURIComponent("image/png8") + "&request=GetMap&styles=");
  },
	copyright: 
  {
		"-": ["3rd Military Survey, Austrian State Archive", "Datový podklad MŽP ČR", "Laboratoř geoinformatiky UJEP"]
	}  
};

SMap.CONFIG["Vojenska_ID"] = 
{
  zoom: [6, 18],
  label: "Vojenská mapa",
  title: "Vojenská mapa",
  preview: default_preview_path + "Vojenska mapa.png",
  url: "",
  options: {prefetch: 0, tileSize: 256, gcDelay: (1000 * 3600 * 1)},
  copyright: {"1-": "GeoPortal.gov / ČÚZK"},
  
  buildUrl: function(t /*tile*/)
  {
    return "http://geoportal.gov.cz/ArcGIS/rest/services/CENIA/cenia_rt_RETM/MapServer/tile/" + (t.zoom - 6) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": "Cenia"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 256,
    "cols": 256,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 75,
    "origin": {"x": -920000.0, "y": -920000.0},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 2048.260096520193, "scale": 7741440},
      "1": {"resolution": 1024.1300482600966, "scale": 3870720},
      "2": {"resolution": 512.0650241300483, "scale": 1935360},
      "3": {"resolution": 256.03251206502415, "scale": 967680},
      "4": {"resolution": 128.01625603251208, "scale": 483840},
      "5": {"resolution": 64.00812801625604, "scale": 241920},
      "6": {"resolution": 32.00406400812802, "scale": 120960},
      "7": {"resolution": 16.00203200406401, "scale": 60480},
      "8": {"resolution": 8.001016002032005, "scale": 30240},
      "9": {"resolution": 4.000508001016002, "scale": 15120},
      "10": {"resolution": 2.000254000508001, "scale": 7560},
      "11": {"resolution": 1.0001270002540006, "scale": 3780},
      "12": {"resolution": 0.5000635001270003, "scale": 1890}
    }
  },
  {
    "xmin": -975345.6758081501,
    "ymin": -1283724.921699355,
    "xmax": -384561.6758081501,
    "ymax": -865996.921699355,
    "spatialReference": {"wkid": 102067}
  }, 6)  
//   projection: SMap.projUTM33,
// 
//   buildUrl: function(t /*tile*/)
//   {
//     return ("http://geoportal.gov.cz/ArcGIS/services/CENIA/cenia_rt_RETM/MapServer/WMSServer?"
//       + "BBOX=" + t.getBBOX(this.getMap()) + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize
//       + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode())
//       + "&Layers=0&version=1.3.0&service=WMS&format=" + encodeURIComponent("image/png8") + "&request=GetMap&styles=");
//   }
};

SMap.CONFIG["IZS_ID"] = 
{
// http://giscr.hzspk.cz/arcgis/rest/services/giscr/MapServer/tile/1/256/243
// http://giscr.hzspk.cz/arcgis/rest/services/giscr/MapServer/tile/0/128/121
 
  zoom: [8, 17],
  label: "IZS",
  title: "Mapa IZS",
  preview: default_preview_path + "IZS.png",
  options: {prefetch: 0, tileSize: 512, gcDelay: (1000 * 3600 * 1)},
  buildUrl: function(t /*tile*/)
  {
    return "http://giscr.hzspk.cz/arcgis/rest/services/giscr/MapServer/tile/" + (t.zoom - 8) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": ["HZS ČR (giscr.hzspk.cz)", "ČÚZK", "OpenStreetMap"]},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 512,
    "cols": 512,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 92,
    "origin": {"x": -3.36998E7, "y": 3.36998E7},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 529.167725002117, "scale": 2000000.0},
      "1": {"resolution": 264.583862501058, "scale": 1000000.0},
      "2": {"resolution": 132.291931250529, "scale": 500000.0},
      "3": {"resolution": 52.9167725002117, "scale": 200000.0},
      "4": {"resolution": 26.4583862501058, "scale": 100000.0},
      "5": {"resolution": 13.2291931250529, "scale": 50000.0},
      "6": {"resolution": 5.29167725002117, "scale": 20000.0},
      "7": {"resolution": 2.64583862501058, "scale": 10000.0},
      "8": {"resolution": 1.32291931250529, "scale": 5000.0},
      "9": {"resolution": 0.529167725002117, "scale": 2000.0}
    }
  },
  {
    "xmin": -3492095.358275245,
    "ymin": -3230781.3606962427,
    "xmax": 2407504.3466071645,
    "ymax": 1854772.3786539468,
    "spatialReference": {"wkid": 102067}
  }, 8)
};

// http://mapy.geoportal.gov.pl/imap/
// alternative Poland: http://mapa.ump.waw.pl/ump-www/form.html
// alternative Poland: http://mapa.szukacz.pl/

// nové linky (8.2.2014) - už nefungují:
//  http://mapy.geoportal.gov.pl/wss/service/puburl/guest/kompozycjaG2_BDO/MapServer/tile/3/2/2?rfh=1
//  http://mapy.geoportal.gov.pl/wss/service/puburl/guest/kompozycjaG2_VMAPL2/MapServer/tile/8/103/137?rfh=1
//  http://mapy.geoportal.gov.pl/wss/service/imgurl/guest/ORTO/MapServer/tile/9/258/341?rfh=1

// další oprava: 18.8.2014:
// - zprovozněno orto
// - vypnuto topo, protože je průhledné a z nějakého důvodu se nepřekresluje

// vypnuto: 24.12.2014
// - token je nyní proměnlivý

SMap.CONFIG["Poland_ID"] = 
{
  zoom: [/*6*/15, 18],
  label: "Polsko Orto",
  title: "Polsko Orto",
  preview: default_preview_path + "Poland.jpg",
  options: {prefetch: 0, tileSize: 512, gcDelay: (1000 * 3600 * 1)},
  buildUrl: function(t /*tile*/)
  {
    if (t.y < 0 || t.x < 0)
      return "";

    var maptype = "kompozycjaG2_BDO";
    var zoom = t.zoom - 6;

    if (zoom >= 9)
    {
      maptype = "ORTO";
    }
    
    else if (zoom >= 6)
    {
      maptype = "kompozycjaG2_VMAPL2";
    }       
    
    // nové (8.2.2014)
    // znovu opraveno: 18.8.2014
    // vypnuto: 24.12.2014
    return "http://mapy.geoportal.gov.pl/gprest/services/" + maptype + "/MapServer/tile/" + (t.zoom - 6) + "/" + t.y + "/" + t.x + "?token=2iv7I6Rquk_9YRNRImxWPmo-G4vimdasJxmsHEFgUyo9CLdlzICRyIvr4pPswgmpMAxKPVLXB7L_TDbnrCajqQ..&rfh=1";
  },

  copyright: {"1-": "geoportal.gov.pl"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 512,
    "cols": 512,
    "dpi": 96,
    "format": "PNG",
    "compressionQuality": 50,
    "origin": {"x": 100000, "y": 850000},
    "spatialReference": {"wkid": 2180},
    "lods": 
    [
      {"level": 0,  "resolution": 2116.670900008467,   "scale": 8000000},
      {"level": 1,  "resolution": 1058.3354500042335,  "scale": 4000000},
      {"level": 2,  "resolution": 529.1677250021168,   "scale": 2000000},
      {"level": 3,  "resolution": 264.5838625010584,   "scale": 1000000},
      {"level": 4,  "resolution": 132.2919312505292,   "scale": 500000},
      {"level": 5,  "resolution": 66.1459656252646,    "scale": 250000},
      {"level": 6,  "resolution": 26.458386250105836,  "scale": 100000},
      {"level": 7,  "resolution": 13.229193125052918,  "scale": 50000},
      {"level": 8,  "resolution": 6.614596562526459,   "scale": 25000},
      {"level": 9,  "resolution": 2.6458386250105836,  "scale": 10000},
      {"level": 10, "resolution": 1.3229193125052918,  "scale": 5000},
      {"level": 11, "resolution": 0.5291677250021167,  "scale": 2000},
      {"level": 12, "resolution": 0.26458386250105836, "scale": 1000}
    ]
  },
  {
    "xmin": -14741.4130999995,
    "ymin": 88709.35549999961,
    "xmax": 1081100.4786,
    "ymax": 1228812.3941525,
    "spatialReference": {"wkid": 2180}
  }, 6)
};

SMap.CONFIG[SMap.DEF_RELIEF] = 
{
	zoom: [3, 17],
	options: {animTime: 0, fadeTime: 0,	prefetch: 0, alpha: true/*, 
    noReprojection: function(map){return (map.getProjection().getCode() != "EPSG:4326");}*/},
	url: "http://m#.mapserver.mapy.cz/relief/",

  buildUrl: function(t /*tile*/)
  {
    if (/*t.zoom <= 15 && */this.getMap().getProjection() === SMap.projUTM33)
    {
      this._options.opacity = 1;
      return(this._buildURLOrig(t));
    }

    this._options.opacity = 0.35;

    return ("http://geoportal.gov.cz/ArcGIS/services/CENIA/cenia_stinovani/MapServer/WMSServer?"
      + "BBOX=" + t.getBBOX(this.getMap()) + "&WIDTH=" + this._options.tileSize + "&HEIGHT=" + this._options.tileSize
      + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode())
      + "&Layers=0&version=1.3.0&service=WMS&format=" + encodeURIComponent("image/png") + "&request=GetMap&styles=");
  },  
  
	copyright: 
  {
		"3-15": "Seznam.cz, a.s.",
    "16-": "Podkladová data ČÚZK"
	}
};

// Mapy.cz DEF_OPHOTO - transparent sub-layer version
SMap.CONFIG["MapyCZ_OPHOTO_Sub"] = 
{
	zoom: SMap.CONFIG[SMap.DEF_OPHOTO].zoom,
	url: SMap.CONFIG[SMap.DEF_OPHOTO].url,
  options: {animTime: 0, fadeTime: 0, prefetch: 0, alpha: true, opacity: 0.3},
	copyright: SMap.CONFIG[SMap.DEF_OPHOTO].copyright
};

SMap.CONFIG["OrtoFoto_ID"] = {
  options: {opacity: 0.5},
  
  // original
	zoom: [3, 18],
	label: "Letecká",
	preview: "preview-letecka.png",
	url: "http://m#.mapserver.mapy.cz/ophoto/",
	copyright: {
		"1-6": "NASA Earth Observatory",
		"7-10": ["GEODIS BRNO, s.r.o", "USGS & NASA. Datasource: Global Land Cover Facility"],
		"11-": "GEODIS BRNO, s.r.o"
	}
};

SMap.CONFIG["Vrstevnice_ID"] = 
{
  zoom: [5, 20],
  url: "",
  options: {prefetch: 0, tileSize: 256, gcDelay: (1000 * 3600 * 1), alpha: true, 
    noReprojection: function(map){return (map.getProjection().getCode() != "EPSG:4326");}},
  copyright: {"1-": "GeoPortal.gov / ČÚZK"},

  buildUrl: function(t /*tile*/)
  {
    var code = this.getMap().getProjection().getCode();

    // info: http://directory.spatineo.com/service/3806/
    // Vrstevnice základní (GL_CA010)	
    // Vrstevnice zdůrazněná (GL_CA011)	
    // Vrstevnice doplňková (GL_CA012)

    // we need resolution 1200x420 (which is currently impossible) to prevent white background in WGS84 mode
    this._options.opacity = (code == "EPSG:4326") ? 0.3 : 0.4;
    
    // higher opacity for OSM maps (forests there decreases contour visibility)
    if (this.getMap().CurrentMapId == "OSM_ID")
      this._options.opacity = 0.7;
    
    var layers = "GL_CA011,GL_CA012";
    
    if (code == "EPSG:32633" && t.zoom >= 15)
      layers += ",GL_CA010"; 	

    return ("http://geoportal.cuzk.cz/WMS_ZABAGED_PUB/service.svc/get?"
      + "SERVICE=WMS&REQUEST=GetMap&VERSION=1.3.0" + "&LAYERS=" + encodeURIComponent(layers)
      + "&FORMAT=" + encodeURIComponent("image/png") 
      + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize + "&BBOX=" + t.getBBOX(this.getMap()) 
      + "&CRS=" + encodeURIComponent(code) + "&STYLES=&TRANSPARENT=TRUE");
  }
};

SMap.CONFIG["Katastr"] = 
{
  url: "",
  options: {animTime: 0, fadeTime: 0, prefetch: 0, alpha: true, tileSize: 256, noReprojection: function(map){return true;}},
  copyright: {"1-": "Podkladová data ČÚZK"},

  buildUrl: function(t /*tile*/)
  {
    // info: http://www.cuzk.cz/Dokument.aspx?PRARESKOD=998&MENUID=0&AKCE=DOC:10-WMS_PRO_KM
    // capabilities: http://services.cuzk.cz/wms/wms.asp?service=WMS&version=1.1.1&request=GetCapabilities
    // DEF_BUDOVY, DEF_PARCELY --> červené/modré nápisy (čitelnější pro nižší rozlišení)
    // KN - katastr černý, KN_I - katastr bílý
  
    var code = this.getMap().getProjection().getCode();
  
    // lower zooms
    if ((code == "EPSG:32633" /* UTM33 */ && t.zoom <= 16) || (code != "EPSG:32633" && t.zoom <= 18))
      var mapType = "DEF_PARCELY";
    // higher zooms
    else
     var mapType = "KN_I";
    
    if (this.getId() != "IZS_ID")
      mapType += ",DEF_BUDOVY"; 

    mapType += ",hranice_parcel_barevne";//,prehledky"; 

    // http://services.cuzk.cz/wms/wms.asp?&LAYERS=KN&FORMAT=image%2Fpng&TRANSPARENT=true&SERVICE=WMS&VERSION=1.1.1&REQUEST=GetMap&STYLES=&EXCEPTIONS=application%2Fvnd.ogc.se_inimage&SRS=EPSG%3A900913&BBOX=1711981.9297627,6539317.7771327,1712058.366791,6539394.2141609&WIDTH=256&HEIGHT=256
    return ("http://services.cuzk.cz/wms/wms.asp?"
      + "SERVICE=WMS&REQUEST=GetMap&VERSION=1.1.1" + "&LAYERS=" + encodeURIComponent(mapType) + "&FORMAT=" + encodeURIComponent("image/png") 
      + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize + "&BBOX=" + t.getBBOX(this.getMap(), "1.1.1") 
      + "&SRS=" + encodeURIComponent(code) + "&STYLES=&TRANSPARENT=true&EXCEPTIONS=" + encodeURIComponent("application/vnd.ogc.se_inimage")); 
  }
};

// http://geo.enviroportal.sk/services/?id=1
// 8.2.2014: nefunguje, bylo by třeba dodělat projSTJSK
SMap.CONFIG["ZM10_Slovakia_ID"] = 
{
  zoom: [5, 17],
  label: "ZM10 Slovensko",
  title: "Základná mapa 1:10 000",
  preview: default_preview_path + "ZM10 Slovensko.png",
  url: "",
  options: {prefetch: 0, tileSize: 512, gcDelay: (1000 * 3600 * 1)},
  copyright: {"1-": "SAZP.sk"},
  projection: SMap.projSTSK, /* neexistuje, nefunguje pro UTM33 a Mercator */

  buildUrl: function(t /*tile*/)
  {
    // this map is off by ~150, try to move it to the right location
    var tl = t.topLeftCoords(this.getMap()).toUTM33();
    var br = t.bottomRightCoords(this.getMap()).toUTM33();

    var x = 128;
    var y = 55;
    
    tl[0] += x;
    br[0] += x;
    tl[1] += y;
    br[1] += y;

    var bbox = tl + "," + br;

//     return ("http://nipi.sazp.sk/arcgis/services/nipi/rasters/MapServer/WMSServer?"
//       + "LAYERS=2&STYLES=&FORMAT=" + encodeURIComponent("image/png")
//       + "&SERVICE=WMS&VERSION=1.1.1&REQUEST=GetMap&EXCEPTIONS=" + encodeURIComponent("application/vnd.ogc.se_inimage")
//       + "&SRS=" + encodeURIComponent(this.getMap().getProjection().getCode()) 
//       + "&BBOX=" + /*t.getBBOX(this.getMap(), "1.1.1")*/ bbox + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize);

    return ("http://tiles.geop.sazp.sk/base/service?"
      + "LAYERS=sazp_zbgis10r&TRANSPARENT=FALSE&STYLES=&FORMAT=" + encodeURIComponent("image/jpeg")
      + "&SERVICE=WMS&VERSION=1.1.1&REQUEST=GetMap&EXCEPTIONS=" + encodeURIComponent("application/vnd.ogc.se_inimage")
      + "&SRS=" + encodeURIComponent(this.getMap().getProjection().getCode()) 
      + "&BBOX=" + /*t.getBBOX(this.getMap(), "1.1.1")*/ bbox + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize);  
  }
};

//http://tiles.geop.sazp.sk/base/service?LAYERS=sazp_zbgis10r&TRANSPARENT=FALSE&SERVICE=WMS&VERSION=1.1.1&REQUEST=GetMap&STYLES=&FORMAT=image%2Fjpeg&SRS=EPSG%3A102067&BBOX=-469050.624,-1160536.32,-468538.56,-1160024.256&WIDTH=256&HEIGHT=256

SMap.CONFIG["OSM_ID"] = 
{
  zoom: [2, 17],
  label: "OSM",
  title: "Open Street Maps",
  preview: default_preview_path + "OSM.png",
  url: "http://tile.openstreetmap.org/",
  options: {query: "{zoom}/{x}/{y}.png"},
  copyright: {"1-": "Open Street Maps"},
  projection: SMap.projMercator
};

SMap.CONFIG["OSMCyclo_ID"] = 
{
  zoom: [2, 17],
  label: "OSM Cyclo",
  title: "OpenCycleMap",
  preview: default_preview_path + "OSM Cyclo.png",
  url: "http://tile.opencyclemap.org/cycle/",
  options: {query: "{zoom}/{x}/{y}.png"},
  copyright: {"1-": "Open Street Maps"},
  projection: SMap.projMercator
};

// // http://mapa.ump.waw.pl/ump-www/form.html
// SMap.CONFIG["UMP_Poland_ID"] = 
// {
//   zoom: [2, 18],
//   label: "UMP Polsko",
//   title: "UMP Polsko",
//   preview: default_preview_path + "UMP Poland.png",
//   url: "http://2.tiles.ump.waw.pl/ump_tiles/",
//   options: {query: "{zoom}/{x}/{y}.png"},
//   copyright: {"1-": "UMP"},
//   projection: SMap.projMercator
// };

SMap.CONFIG["FreemapSK_ID"] = 
{
  zoom: [5, 16],
  label: "Freemap SK",
  title: "Freemap.sk",
  preview: default_preview_path + "FreemapSK.png",
  
  // a. --> can be a/b/c/d
  // T - turistická, A - autoatlas, C - cyklo, K - běžkařská
  // url for K: http://t4.freemap.sk/K/
  
  url: "http://a.freemap.sk/data/layers/presets/T/",  
  options: {query: "{zoom}/{x}/{y}.jpeg"},
  copyright: {"1-": "Freemap.sk"},
  projection: SMap.projMercator
};

SMap.CONFIG["GSatellite_ID"] = 
{
  zoom: [2, 20],
  label: "Google Satellite",
  title: "Google Satellite Maps",
  preview: default_preview_path + "Google Satellite.jpg",
  
  // note: version (v=???) sometimes changes, so fix it from time to time
  url: "http://khm1.google.com/kh/v=166&",
  options: {query: "x={x}\&y={y}\&z={zoom}"},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["GSatelliteSub_ID"] = 
{
  zoom: SMap.CONFIG["GSatellite_ID"].zoom,
  url: SMap.CONFIG["GSatellite_ID"].url,
  options: SMap.CONFIG["GSatellite_ID"].options,
  buildUrl: function(t)
  {
    if (this.getMap().CurrentMapId == "GSatellite_ID")
      this._options.opacity = 1;
      
    // transparent version
    else
    {
      this._options.opacity = 0.3;   
    }
  
    return(this._buildURLOrig(t));  
  },
  copyright: SMap.CONFIG["GSatellite_ID"].copyright,
  projection: SMap.CONFIG["GSatellite_ID"].projection
};

SMap.CONFIG["GMaps_ID"] = 
{
  zoom: [2, 17],
  label: "Google Maps",
  title: "Google Maps",
  preview: default_preview_path + "Google Maps.jpg",
  url: "http://mt2.google.com/vt/hl=cs&",
  options: {query: "x={x}&y={y}&z={zoom}"},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["GHybrid_ID"] = 
{
  // note: version (h@???) sometimes changes, so fix it from time to time
  // use m@ instead of h@ to display satellite maps
  url: "http://mt2.google.com/vt/lyrs=h@292000000&hl=cs&",
  options: {query: "x={x}&y={y}&z={zoom}", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["GTerrainSubLayer_ID"] = 
{
  zoom: [2, 15],
  url: "http://mt2.google.com/vt/lyrs=t@900&",
  options: {query: "x={x}&y={y}&z={zoom}", opacity: 0.5},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["ToolServer_ID"] = 
{
  zoom: [2, 15],
  url: "http://toolserver.org/~cmarqu/hill/",
  options: {query: "{zoom}/{x}/{y}.png", opacity: 1},
  copyright: {"1-": "Wikimedia Toolserver"},
  projection: SMap.projMercator
};

SMap.CONFIG["GTerrain_ID"] = 
{
  zoom: [2, 15],
  label: "Google Terrain",
  title: "Google Terrain",
  preview: default_preview_path + "Google Terrain.png",
  //url: "http://mt2.google.com/vt/lyrs=t@130,r@207000000&hl=cs&",
  url: "http://mt2.google.com/vt/lyrs=t@" + SMap.CONFIG["GTerrainSubLayer_ID"].url.match(/t@(\d+)/)[1] + ",r@" + SMap.CONFIG["GHybrid_ID"].url.match(/h@(\d+)/)[1] + "&hl=cs&",
  options: {query: "x={x}&y={y}&z={zoom}"},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["GStreetView_ID"] = 
{
  // lmc:photos_outside_streetview_134,svv --> street view + images
  // lmc:panoramio,svv --> street view + panoramio images
  // lmc:,svv --> street view only
  zoom: [2, 20],
  url: "http://mt0.google.com/mapslt?lyrs=lmc:,svv&w=256&h=256&hl=cs&style=40,18&",
  options: {query: "x={x}&y={y}&z={zoom}", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["GeocachesMap_ID"] = 
{
  zoom: [2, 20],
  url: "http://tiles01.geocaching.com/map/map.png?",
  //options: {query: "x={x}&y={y}&z={zoom}&ep=1", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
  options: {query: "x={x}&y={y}&z={zoom}&ep=1", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true, reprojectionZoomLower: true},
  copyright: {"1-": "Groundspeak.com"},
  projection: SMap.projMercator
};

// SMap.CONFIG["aMapy_ID"] = 
// {
//   zoom: [13, 16],
//   label: "aMapy",
//   title: "aMapy",
//   preview: default_preview_path + "aMapy.png",
//   url: "http://maps11.i0.cz/mps/ch_turis/",
//   options: {query: "{zoom}/{x}/{x}_{y}.gif"},
//   copyright: {"1-": "aMapy.centrum.cz"},
//   projection: SMap.projMercator
// };
// 
// SMap.CONFIG["aMapyTur_ID"] = 
// {
//   zoom: [13, 16],
//   url: "http://maps11.i0.cz/mps/ch_v-tur/",
//   options: {query: "{zoom}/{x}/{x}_{y}.gif", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
//   copyright: {"1-": "aMapy Centrum"},
//   projection: SMap.projMercator
// };
// 
// SMap.CONFIG["aMapyCyklo_ID"] = 
// {
//   zoom: [13, 16],
//   url: "http://maps11.i0.cz/mps/ch_v-cyk/",
//   options: {query: "{zoom}/{x}/{x}_{y}.gif", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
//   copyright: {"1-": "aMapy Centrum"},
//   projection: SMap.projMercator
// };

SMap.CONFIG["MTBMap_ID"] = 
{
  zoom: [2, 16],
  label: "MTB Map",
  title: "MTB Map",
  preview: default_preview_path + "MTB Map.png",
  url: "http://tile.mtbmap.cz/mtbmap_tiles/", // www.mtbmap.cz or tile.mtbmap.cz
  options: {query: "{zoom}/{x}/{y}.png"},
  copyright: {"1-": ["<a href=http://MTBMap.cz>MTBMap.cz</a>", "Martin Tesař", "OpenStreetMap"]},
  projection: SMap.projMercator
};

// fill in missing zoom range
SMap.CONFIG[SMap.DEF_TRAIL].zoom = [3, 18];
SMap.CONFIG[SMap.DEF_BIKE].zoom = [3, 18];
SMap.CONFIG[SMap.DEF_HYBRID].zoom = [3, 18];

// following fixes a bug, that would freeze Opera/IE (it would set path to file://)
SMap.CONFIG[SMap.DEF_SUMMER].url = SMap.CONFIG.protocol + SMap.CONFIG[SMap.DEF_SUMMER].url;

window.otherMapsJS_Loaded = true;