translations["_polygon_info"] = 
{
  "English":
    "::: Basic principles :::\n" +
    "Here you can create and edit polylines, polygon, tracks and groups of points. You can turn this mode off by clicking on \"Track\" below on the left.\n" +
    "\n" +
    "From now on, when I say track, I mean any and all of the above (unless stated otherwise). Grafically distinct from the other are only polygons which are filled. You can convert whatever to a polygon by clicking on the very first point (marked by a green circle with a white border). At any time, you can have only one track opened.\n" +
    "\n" +
    "Track can be divided into segments. Segments are not connected between each other. Segments in polygon mode are islands. Points are considered segments with a length of one.\n" +
    "\n" +
    "!! Each track has its own unlimited history stack. You can go back by pressing CTRL + Z.\n" +
    "\n" +
    "::: Interface :::\n" +
    "On the right, you can see on the first line the entire track length, followed by a total area (when we are in polygon mode), and then finally the total number of points and the number of segments behing the slash (if there is more than 1). Deactivated segments (see below) are not counted toward total length and area. In case the text overflows (because of lots of points etc.), you can hover the mouse over the area and temporarily display everything.\n" +
    "\n" +
    "On the next line, you can change an active track. Several empty are predefined before you start. The option next to it lets you select export format. You need to save it to a file manually, because it can't be done from within JavaScript. If you edit a large number of points (thousands), it can take long to generate output, so be patient. Also, any change and redraw of the map regenerates the output, so turn it off after using it and select either \"----\", which generates no output or \"GSAK\", which generates only coordinates.\n" +
    "\n" +
    "Third line features buttons for opening a file, opening a text and help. The third option is clear. This first on is also simple. Supported formats for loading are currently GPX/PLT/WPT/KML (basic support) and also GSAK/Geoget lines/polygons (or generally any sets of coordinates, where each is on a separate line). Second button lets you read files by directly pasting their text content and also to paste GSAK polygons/polylines.\n" +
    "\n" +
    "When you hover over a point, you can see some of its parameters: name, description, elevation, date and time (whichever of these are available). Number of segment is also displayed, as is index of the point withint the segment and withint the the entire track. You can disable showing these by pressing U (which is persistent across sessions). When it's turned off, you can temporarily turn it on by pressing SHIFT (and the hovering over points).\n" +
    "\n" +
    "Pressing space hides temporarily all points and other elements and leaves only bare track.\n" +
    "\n" +
    "There are arrows on track lines, which show track direction.\n" +
    "\n" +
    "When you start a new track from scratch (ie. not by loading a file) a helper line will be shown when drawing (which connects last point in track with current mouse position). This behavior can be turned on and off by pressing key \"M\".\n" +
    "\n" +
    "::: Adding new points :::\n" +
    "\n" +
    "Left clicking on the map will add new points to the end. Pressing ALT at the same time creates them before the beginning instead. Pressing SHIFT creates new point as a new segment start.\n" +
    "\n" +
    "You are not limited to adding points to the end or before the beginning. You can add them after or before (with ALT) any point you choose. Just ALT + left click that point and its icon will change to blue circle with a white border. Now points are automatically added before or after that. You can cancel this mode by ALT + left clicking that point again or by pressing escape.\n" +
    "\n" +
    "These two principles (setting alternative end and using SHIFT and ALT modifiers) apply not only to manually creating new points one by one, but also to the two methods described below and to cut/copy/paste (described even more below).\n" +
    "\n" +
    "Another way to insert points to the middle is by left clicking or dragging a transparent white point, which is located between two points (if they are far enough).\n" +
    "\n" +
    "You can quickly add points by dragging middle mouse button. This method is not available in IE8 and older.\n" +
    "\n" +
    "Another method is just clicking the middle mouse button and then moving the mouse around. One advantage of this method is that you don't need to have the mouse button pressed while you are moving the mouse. The other is that you are free to drag the map while this mode is active and even zoom in and out. Another way to activate this method is by pressing 'T'. You can deactivate this method by left or middle click and also by pressing T or escape. If you want to temporarily prevent adding points and move the mouse to a new location, press CTRL. Pressing the SHIFT at the same time will start a new segment when you release the keys.\n" +
    "\n" +
    "Clicking on the end will convert its icon to a white circle with red border. This means that adding new points using the above methods is turned off. You can cancel this special mode by clicking the end again.\n" +
    "\n" +
    "::: Moving and deleting individual points :::\n" +
    "\n" +
    "You can move points by left dragging them. Note that this operation may affect many other points, which are not visible at current zoom level. Points invisible at current zoom level are moved on a straight line between newly moved points and the two points around it. Pressing SHIFT tries to rotate/scale them instead to match previous curves of the track - but this may lead to unexpected results at times.\n" +
    "\n" +
    "Single points can be deleted by right clicking them. All not visible points around them (up until the next two visible points around, but not including) are deleted.\n" +
    "\n" +
    "::: Colors of points and tracks :::\n" +
    "\n" +
    "Points are colored based on what they are.\n" +
    "\n" +
    "- white: standard point\n" +
    "- transparent white: this point can be clicked or dragged and new point will be added there (so is not really a part of the track)\n" +
    "- green: start of a segment\n" +
    "- green with a white border: start of a track\n" +
    "- orange: end of a segment (or a single point)\n" +
    "- orange with a white border: end of a track\n" +
    "- blue with a white border: alternative end (see section on adding points)\n" +
    "- white with a red border: alternative track end (marks state, where we can't add new points to the track)\n" +
    "- yellow: selected point\n" +
    "- yellow with a red border: selected point, which is also a special point (segment/track start/end, alternative end)\n" +
    "- smallish red: origin of a rotation/scale\n" +
    "\n" +
    "Lines:\n" +
    "- red: active track or segment\n" +
    "- orange: inactive segment\n" +
    "- blue: inactive track\n" +
    "- yellow: selected points (lines around them)\n" +
    "\n" +
    "::: Working with tracks :::\n" +
    "\n" +
    "Active track is red (except for deactivated segments, which are orange and selected parts, which are yellow). Inactive tracks are blue (including any deactivated segments).\n" +
    "\n" +
    "- TAB: iterate over tracks\n" +
    "- CTRL + click on a track (or ALT + right click on a track - you need to use this combination in Opera): activate the track\n" +
    "- insert: create a new empty track and make it active\n" +
    "- SHIFT + delete: delete current track (can't be reversed by CTRL + Z)\n" +
    "- SHIFT + CTRL + ALT + delete: delete all tracks (leaves one empty)\n" +
    "- SHIFT + CTRL + ALT + J: merges all tracks into one\n" +
    "\n" +
    "You can also switch tracks within sidebar on the right. There you can also load files and import text - these actions will result in adding new track(s).\n" +
    "\n" +
    "::: Working with segments :::\n" +
    "\n" +
    "Start of a segment is marked by a green circle. End of a segment is marked by an orange circle.\n" +
    "\n" +
    "- SHIFT + CTRL + left click on a segment (not a segment point): activate or deactivate that segment (deactivated segment can't be selected and has orange color); in Opera you need to use another combination - ALT + CTRL + right click\n" +
    "- SHIFT + CTRL + ALT + left (or alternatively right) click on a segment: activate this segment, deactivate all others\n" +
    "- SHIFT + TAB: like the method above, but iterates over segments\n" +
    "- escape: activates all segments (which is default)\n" +
    "\n" +
    "- SHIFT + left click a point: disconnecting a track there and creating a new segment; if the clicked point already is an end of track, then the segments are joined instead\n" +
    "- double click a point: same as above, but more convenient\n" +
    "- SHIFT + CTRL + left click an end of segment: joins all selected segments (or more specifically, joins all segments to the previous segment, if they have at least one point selected)\n" +
    "- SHIFT + CTRL + ALT + left click an end of segment: join all segments\n" +
    "- SHIFT + J: another way to join all segments\n" +
    "- SHIFT + CTRL + J: join selected segments using method described above\n" +
    "- SHIFT + right click a point: delete all points within a segment, which the point is a part of\n" +
    "\n" +
    "::: Selecting points :::\n" +
    "\n" +
    "There are multiple ways to select and deselect points. Selected points are yellow, so are lines between them.\n" +
    "\n" +
    "- CTRL + A: select all points\n" +
    "- I: inverse selection\n" +
    "- Escape: cancel selection\n" +
    "- left or right drag + SHIFT: create new selection (and cancel any previous one)\n" +
    "- left or right drag + ALT: subtract from selection\n" +
    "- left or right drag + SHIFT + ALT: add to selection\n" +
    "- left or right drag + SHIFT + ALT + CTRL: intersection of previous selection and the current one; the rectangle version of this (see below) doesn't work in Opera\n" +
    "\n" +
    "Left drag always draws rectangle (which is quicker). Right drag draws any shape (which is more accurate)\n" +
    "\n" +
    "::: Moving selection :::\n" +
    "\n" +
    "- CTRL + left drag: moves selection anywhere by dragging\n" +
    "- arrows: move points by 1 pixel in desired direction (doesn't work within GSAK)\n" +
    "- SDFE: same as above (but working within GSAK)\n" +
    "- SHIFT + arrows/SDFE: move point by 10 pixels at a time\n" +
    "\n" +
    "::: Rotating selection :::\n" +
    "\n" +
    "- CTRL + SHIFT + left drag: rotate selected points around origin (which is the point where you started dragging); rotation origin is marked by a red circle during rotation\n" +
    "- CTRL + left/right arrow: rotate selected point by 1 degree (origin is the center of selection); doesn't work within GSAK\n" +
    "- CTRL + S/F: same as above, but works within GSAK\n" +
    "- CTRL + SHIFT + left/right arrow or S/F: rotation by 10 degrees at a time\n" +
    "\n" +
    "::: Scaling selection :::\n" +
    "\n" +
    "- CTRL + ALT + left drag: scale selected points around origin (which is the point where you started dragging); scale origin is marked by a red circle during scaling; mouse move up to increase size and down to decrease size; this doesn't work in Opera, use combinations below instead\n" +
    "- CTRL + top/bottom arrow: increase/decrease size by 1% (origin is the center of selection); doesn't work within GSAK\n" +
    "- CTRL + E/D: same as above, but works within GSAK\n" +
    "- CTRL + SHIFT + top/bottom arrow or E/D: scale by 10% at a time\n" +
    "\n" +
    "::: Flipping selection :::\n" +
    "\n" +
    "- CTRL + SHIFT + middle click: make horizontal flip, then on next click vertical, on next click both horizontal and vertical and on fourth click return to original state; center of flip is where you click the mouse; if you move the mouse away, you will reset counter and you will start with horizontal flip again\n" +
    "\n" +
    "::: Deleting selection :::\n" +
    "\n" +
    "- delete: deletes all selected points\n" +
    "\n" +
    "::: Cut, copy, paste selection :::\n" +
    "\n" +
    "These are the only functions, that allow you to move points between tracks. They are applied on selected points. Clipboard content is totally independent of history stack, so can't be restored by CTRL + Z. Also, there is only one clipboard for all tracks (ie copying something within one track will overwrite any selection made within a different track)\n" +
    "\n" +
    "- CTRL + C: copy selected points (non-continous areas will be copied as separate segments; e.g. if you have selected points 2,3,4 and 5,6,7 in a track without segment breaks, your pasted selection will by separated by a segment break)\n" +
    "- CTRL + SHIFT + C: same as above, but overrides the described behavior and non-continuous areas will be connected\n" +
    "- CTRL + X: cuts selected points (copies them + deletes them from current track)\n" +
    "- CTRL + SHIFT + X: same as above (but with same behavior override like with CTRL + SHIFT + C)\n" +
    "- CTRL + V: pastes points copied previously by one of the above functions; position of points doesn't change; points are pasted after end or after alternative origin (if one is set - see above)\n" +
    "- CTRL + ALT + V: pastes points before beginning (or before alternative origin - if set)\n" +
    "- CTRL + SHIFT (+ ALT) + V: same as above, but pastes selection as a new segment  \n" +
    "\n" +
    "::: Reverse a track :::\n" +
    "\n" +
    "Reverses orded of points in a track (what was start will be an end and vice-versa).\n" +
    "\n" +
    "- SHIFT + R: reverses a track\n" +
    "- SHIFT + CTRL + R: reverses only selected parts (use preferrably on segments, otherwise it may lead to unpredictable results)\n" +
    "\n" +
    "::: Limitations :::\n" +
    "\n" +
    "- don't use it for loading tracks with 10k+ points or waypoint files with 3k+ points - or prepare for slowdown (or worse)\n" +
    "- you can solve the above be either zooming in or even better - cutting out part and editing it as a separate track (and then pasting it back) - read cut, copy, paste section for this\n" +
    "- you need to save resulting output to a file manually (JavaScript limitation)\n" +
    "- some browsers may steal some key combinations, but there is usually some way to reconfigure them or there are more ways to achieve the same\n" +
    "- Firefox always shows context menu on SHIFT + right click, can't do anything about it\n" +
    "- in Maxthon 2, you need to disable two following options within settings: Mouse Control -> Enable Mouse Gestures, Float Button -> Quick Save images by clicking while holding CTRL key; disabling the former allows you to use right drag, disabling the latter allows you to use combinations with CTRL and left mouse button (there are quite a few of them)\n" +
    "- in Maxthon 3, you need to disable those two same options as in Maxthon 2, but located elsewhere: Mouse Gestures -> Enable Mouse Gestures, Web Content -> Quick Save images by clicking while holding the CTRL key; also, as mentioned below, middle mouse button actions don't work in default mode - but can be enabled by switching to IE mode\n" +
    "- Safari based browsers (including above mentioned Maxthon 3) do not support any action involving middle mouse button\n" +
    "- in Opera, aside from problems described elsewhere, the minimap flickers regularly while the track mode is active\n",
  "Czech":
    "::: Základní principy :::\n" +
    "Zde můžete vytvářet a editovat linie, tracky, polygony a skupiny bodů. Tento mód můžete opustit kliknutím na tlačítko \"Track\" vlevo dole (které je nyní červené).\n" +
    "\n" +
    "Pod pojmem track budeme dále, pokud není řečeno jinak, rozumět cokoli a vše z výše uvedeného. Polygony se graficky liší jen v tom, že jsou vyšrafované. Zapnout a vypnout tento mód lze klikem na první bod tracku. V jednu chvíli můžete mít aktivní jen jeden track (viz menu vpravo).\n" +
    "\n" +
    "Track se může dělit na segmenty. To jsou linie, které nemají mezi sebou spojnici. V případě polygonu segment tvoří ostrov. Samostatné body jsou technicky považovány za segment o délce jednoho bodu.\n" +
    "\n" +
    "!! Každý track má svoji vlastní historii. Téměř jakoukoli akci můžete vrátit pomocí CTRL + Z.\n" +
    "\n" +
    "::: Interface :::\n" +
    "Vpravo nahoře máte celkovou délku tracku (mezery mezi segmenty se nepočítají). V případě polygonu pak i celkovou plochu. Vedle toho máte počet bodů a případně za lomítkem i počet segmentů (pokud jich je víc než jeden). Deaktivované segmenty (viz níže) se nepočítají do celkové délky nebo plochy. V případě přetečení textu v této oblasti (například při velkém množství bodů a segmentů) nejsou všechny údaje vidět, nicméně po najetí myší se vše dočasně zobrazí.\n" +
    "\n" +
    "Na druhém řádku si můžete přepínat mezi tracky. Pár jich tam je předpřipraveno už při startu. Vedle toho si můžete zvolit exportní formát. Uložit do souboru je nutno manuálně, neb z prostředí JavaScriptu zatím ukládat soubory nejde. Pozor, generování může zabrat nějaký čas (pokud máte tisíce bodů), tak buďte trpěliví. Navíc se výstup generuje po každé změně na mapě, tak si po uložení výstupu přepněte na něco jiného (třeba \"----\", což negeneruje žádný výstup nebo \"GSAK\", což generuje jen souřadnice).\n" +
    "\n" +
    "Na třetím řádku si můžete otevřít soubor (podporované formáty jsou GPX/PLT/WPT/KML (základní podpora) a také linie či polygony GSAKu a GeoGetu). Druhá volba vám umožňuje importovat text souboru přímo. Třetí možnost je snad jasná, dostali jste se sem kliknutím na ono tlačítko :).\n" +
    "\n" +
    "Pokud si najedete myší na bod, zobrazí se vám některé informace o něm, pokud jsou dostupné: název, popis, nadmořskou výška, datum a čas. Dále se zobrazí pořadí segmentu a pořadí bodu jak v rámci segmentu, tak i v rámci tracku (v závorce). Pokud máte jen jeden segment, zobrazí se jen pořadí bodu v rámci tracku. Zobrazování této \"bubliny\" si můžete vypnout/zapnout trvale pomocí U (defaultně je to zaplé). Pokud je to vyplé, tak to bude fungovat dočasně i po dobu stisku SHIFT.\n" +
    "\n" +
    "Pokud stisknete mezerník, skryje se vše kromě holého tracku. Občas se hodí, když vám ho zakrývají body.\n" +
    "\n" +
    "Na tracku se objevují šipky - ty ukazují směr (tedy který bod je dřívější a který pozdější).\n" +
    "\n" +
    "Pokud začínáte od nuly (tedy ne z otevřeného souboru), tak se vám po nakreslení prvního bodu zobrazuje pomocná čára vedoucí k aktuální poloze myši. Tuto je možno vypnout či zapnout pomocí klávesy M.\n" +
    "\n" +
    "::: Barvy bodů a čar :::\n" +
    "\n" +
    "Body mohou mít různou barvu, podle toho co jsou zač:\n" +
    "- bílá: standardní bod\n" +
    "- transparentní bílá: pomocný přesouvatelný bod\n" +
    "- zelená: začátek segmentu\n" +
    "- zelená s bílým okrajem: začátek tracku\n" +
    "- oranžová: konec segmentu\n" +
    "- oranžová s bílým okrajem: konec tracku\n" +
    "- modrá s bílým kolečkem: alternativní konec (více viz sekce o přidávání nových \n" +
    "bodů)\n" +
    "- bílá s červeným kolečkem: konec tracku (značí, že nelze přidávat nové body)\n" +
    "- žlutá: označený bod\n" +
    "- žlutá s červeným okrajem: označený speciální bod (začátek/konec segmentu/tracku nebo alternativní konec)\n" +
    "- červená: pomocný bod, označuje střed rotace/zmenšování/zvětšování po dobu operace\n" +
    "\n" +
    "Linie také mohou mít různou barvu:\n" +
    "- červená: aktivní track/segment\n" +
    "- oranžová: neaktivní segment\n" +
    "- modrá: neaktivní track\n" +
    "- žlutá: kolem vybraných bodů\n" +
    "\n" +
    "::: Přidávání nových bodů :::\n" +
    "\n" +
    "Přidání nového bodu je snadné. Stačí kliknout na požadované místo v mapě. Toto přidá bod na konec tracku. Přidání bodu před začátek je téměř stejně snadné - stačí držet stisknutý ALT. Stisknutí SHIFTu pak vždy daný bod přidá jako začátek nového segmentu.\n" +
    "\n" +
    "Nejste omezeni jen na přidávání bodů na konec nebo před začátek, můžete je přidávat i za nebo před libovolný vámi zvolený bod. Stačí na takovýto bod kliknout s přidrženým ALT. Pak se vám tento bod zobrazí jako modré kolečko s bílým okrajem. Takovýto bod se pak bere jako výchozí bod pro výše zmíněnou operaci a i pro dvě níže zmíněné metody (a navíc cut/copy/paste zmíněné mnohem níže).\n" +
    "\n" +
    "Ještě jedna metoda jak přidávat body doprostřed je tažením pomocného bílého transparentního bodu (nebo kliknutím na něj levým tlačítkem).\n" +
    "\n" +
    "Body se nemusí přidávat jen klikáním po jednom, ale jdou přidávat i hromadně. Pokud budete táhnout středním tlačítkem, budou se automaticky přidávat body až dokud ho nepoustíte. Tato metoda z důvodů konfliktu s metodou níže nefunguje v IE8.\n" +
    "\n" +
    "Třetí metoda přidávání bodů je stisknutí středního tlačítka (stisknutí, nikoli tažení jako u metody výše). Pak se budou přidávat body automaticky dokud někam nekliknete. Výhody této metody jsou dvě - nemusíte držet stisknuté tlačítko a můžete (narozdíl od předchozí metody) i pohybovat s mapou a dokonce i zoomovat. Další způsob jak aktivovat tuto metodu je pomocí klávesy T. Vypnout tuto meto lze levým či středním klikem, stisknutím T nebo pomocí escape. Pokud chcete během této metody dočasně vypnout přidávání bodů a posunout myš jinam, stiskněte CTRL. Pokud zároveň i stisknete SHIFT, tak na novém bodě začnete nový segment.\n" +
    "\n" +
    "Kliknutí na poslední bod tracku (tedy oranžový s bílým okrajem) vypne přidávání bodů podle výše zmíněných metod (kromě metody přidávání bodu doprostřed). Tím zamezíte nechtěnému ukliknutí a hodí se to pro editaci hotového tracku, kde nechcete přidávat už nic na konec.. Pokud je tato metoda aktivována, změní se ikonka konce tracku na bílé kolečko s červeným okrajem. Deaktivace této metody probíhá stejným způsobem.\n" +
    "\n" +
    ":: Přesun a smazání jednotlivých bodů ::\n" +
    "\n" +
    "Přesunout jednotlivé body je možno tažením levého tlačítka myši. Zde je ale nutno zmínit, že může zároveň dojít i k přesunu mnoha dalších blízkých bodů. Ne totiž všechny body jsou vždy zobrazeny - pokud je na spojité linii více blízkých bodů, tak se zobrazí jen jeden (kromě začátků a konců segmentů - ty se zobrazí vždy). Tažením tohoto bodu tak přesouváte vše mezi vámi taženým bodem a dvěma viditelnými body okolo. Toto chování vám umožňuje snadno editovat tracky, které obsahují velké množství bodů. Co se s těmi dalšími body přesně stane? Vyrovnají se (podle původní vzdálenosti) na spojnici mezi novým umístěním a dvěma okolními body (jejichž poloha se nemění). Pokud při tažením zároveň podržíte SHIFT, tak se provede pokus o rotaci a zvětšení/zmenšní těchto bodů, aby se věrně kopíroval předchozí stav - nicméně toto chování může něky vést k nepříliš hezkému výsledku.\n" +
    "\n" +
    "Smazání jednotlivého bodu probíhá pravým kliknutím na něj. Aplikuje se stejné chování jako výše, jen s tím rozdílem, že všechny body na spojnici se také smažou.\n" +
    "\n" +
    "::: Práce s tracky :::\n" +
    "\n" +
    "Aktivní track je vybarven červeně (krom neaktivních segmentů - vybarvené oranžově, a označených částí - vybarvené žlutě). Neaktivní tracky jsou vybarveny celé modře.\n" +
    "\n" +
    "- TAB: přepíná se z tracku na track (přeskakuje ty, kde nic není)\n" +
    "- CTRL + klik na track (nebo ALT + pravý klik na track - nutno použít v Opeře): aktivuje track\n" +
    "- insert: vytvoří prázdný track a přepne se na něj\n" +
    "- SHIFT + delete: smaže track (nelze vrátit zpět)\n" +
    "- SHIFT + CTRL + ALT + delete: smaže všechny tracky (zůstane jen jeden prázdný)\n" +
    "- SHIFT + CTRL + ALT + J: sloučí všechny tracky do jednoho\n" +
    "\n" +
    "Tracky lze přepínat i v menu napravo. V tom lze i otevírat nové soubory (nebo je importovat v textové podobě) - a ty se také přidají jako tracky.\n" +
    "\n" +
    "::: Práce se segmenty :::\n" +
    "\n" +
    "Začátek segmentu je označen zeleným kolečkem. Konec pak oranžovým kolečkem.\n" +
    "\n" +
    "- SHIFT + CTRL + levý klik na segment (nikoli na bod, ale na čáru): aktivuje nebo deaktivuje tento segment (deaktivovaný segment je oranžový, nezobrazují se na něm body a nelze označit pomocí níže uvedených funkcí); v Opeře je z technických důvodů nutno použít jinou kombinaci - ALT + CTRL + pravý klik\n" +
    "- SHIFT + CTRL + ALT + levý (nebo alternativně pravý) klik na segment: aktivuje segment, deaktivuje ostatní segmenty\n" +
    "- SHIFT + TAB: stejné jako metoda výše, ale skáče postupně po segmentech z jednoho na druhý\n" +
    "- SHIFT + levý klik na bod: rozpojí track v daném bodě a vytvoří segment se začátkem v příštím bodě; pokud je bod koncem segmentu, tak se místo rozpojení v daném místě track spojí\n" +
    "- dvojklik na bod: to samé, ale pohodlnější\n" +
    "- SHIFT + CTRL + levý klik na poslední bod segmentu: spojí všechny označené segmenty (přesněji: připojí všechny segmentu v k předchozímu segmentu, pokud je alespoň jeden bod segmentu označený)\n" +
    "- SHIFT + CTRL + ALT + levý klik na poslední bod segmentu: spojí všechny segmenty\n" +
    "- SHIFT + J: jednodušší metoda jak spojit všechny segmenty\n" +
    "- SHIFT + CTRL + J: spojí všechny označené segmenty (stejné jako metoda výše)\n" +
    "- SHIFT + pravý klik na bod: smaže segment, jehož byl bod součástí\n" +
    "\n" +
    "::: Výběr bodů :::\n" +
    "\n" +
    "Existuje mnoho způsobů jak vybrat body nebo naopak body odebrat z výběru. Označené body jsou žluté. Spojnice mezi nimi také.\n" +
    "\n" +
    "- CTRL + A: označí všechny body\n" +
    "- I: invertuje výběr (co bylo označené nyní není a naopak)\n" +
    "- Escape: zruší výběr\n" +
    "- pravé nebo levé tažení + SHIFT: vytvoří nový výběr (a zruší předcházející)\n" +
    "- pravé nebo levé tažení + ALT: odečte z výběru\n" +
    "- pravé nebo levé tažení + SHIFT + ALT: přidá k výběru\n" +
    "- pravé nebo levé tažení + SHIFT + ALT + CTRL: provede průnik s předchozím výběrem; obdélníková verze (viz níže) této kombinace nefunguje v Opeře\n" +
    "\n" +
    "Tažení levým tlačítkem myší kreslí obdélník (což je rychlejší). Tažení pravým tlačítkem vám dovolí kreslit libovolný tvar (což je přesnější).\n" +
    "\n" +
    "::: Posun výběru :::\n" +
    "\n" +
    "- CTRL + levé tažení: přesouvá výběr tažením\n" +
    "- šipky: přesune výběr požadovaným směrem o 1 pixel (nefunguje v GSAKu)\n" +
    "- SDFE: to samé, ale funguje v GSAKu\n" +
    "- SHIFT + arrows/SDFE: move point by 10 pixels at a time\n" +
    "\n" +
    "::: Rotace výběru :::\n" +
    "\n" +
    "- CTRL + SHIFT + levé tažení: rotuje vybrané body tažením myši; centrum rotace je označeno po dobu rotace červeným puntíkem a nachází se tam, kde jste začli táhnout myší\n" +
    "- CTRL + levá/pravá šipka: rotace o 1% (nefunguje v GSAKu)\n" +
    "- CTRL + S/F: rotace o 1% (funguje v GSAKu)\n" +
    "- CTRL + SHIFT + levá/pravá šipka nebo S/F: rotace o 10%\n" +
    "\n" +
    "::: Zvětšení/zmenšení výběru :::\n" +
    "- CTRL + ALT + levé tažení: zvětšuje nebo zmenšuje vybrané body (v tom smyslu, že je posunuje blíže nebo dále od bodu, kde jste začli táhnout myší - tento bod je označen červeným puntíkem); posun myší nahoru znamená zvětšení, posun dolů zmenšení; tato kombinace nefunguje v Opeře, tam použijte jednu z níže uvedených možností\n" +
    "- CTRL + horní/dolní šipka: zvětšení/zmenšení o 1%, středem je zde střed výběru (nefunguje v GSAKu) \n" +
    "- CTRL + E/D šipka: to samé, ale funguje v GSAKu\n" +
    "- CTRL + SHIFT + horní/dolní šipka nebo E/D: zvětšení/zmenšení o 10%\n" +
    "\n" +
    "::: Obrácení výběru (flip) :::\n" +
    "- CTRL + SHIFT + střední klik: první klik vám označené body převrátí horizontálně (kolem osy Y), druhý klik pak vertikálně (kolem osy X), třetí klik kolem obou os a čtvrtý vás vráti do původního stavu; střed os je zde místo kam klikáte; pokud po jednom kliku posunete myš pryč, začínáte odznovu (tedy s horizontálním převrácením) \n" +
    "\n" +
    "::: Smazání výběru :::\n" +
    "\n" +
    "- delete: smaže všechny vybrané body\n" +
    "\n" +
    "::: Vyjmutí, kopírování, vložení výběru (cut, copy, paste) :::\n" +
    "\n" +
    "Tyto funkce jako jediné umí přesouvat body mezi jednotlivými tracky. Na stav virtuální schránky (tedy co je aktuálně zkopírováno) se nevztahuje historie a nelze tedy vrátit zpět. Navíc jsou zkopírované body společné pro všechny tracky (tedy zkopírování v jednom tracku přepíše body ve schránce, které byly zkopírovány v jiném tracku).\n" +
    "\n" +
    "- CTRL + C: zkopíruje vybrané body do virtuální schránky (nespojité oblasti budou zkopírovány jako samostatné segmenty - pokud máte například vybrány body 2,3,4 a 6,7 ze spojitého tracku, tak se vám zkopírují jako dva nové segmenty; toto chování zaručuje, že vám nikde nevzniknou nové nevhodně umístěné spojnice mezi body)\n" +
    "- CTRL + SHIFT + C: to samé, ale bez přerušování nespojitých zkopírovaných částí\n" +
    "- CTRL + X: vyjmutí (tedy identické chování jako CTRL + C, ale navíc smazání původních bodů)\n" +
    "- CTRL + SHIFT + X: stejné jako CTRL + SHIFT + C (jen navíc se smazáním vybraných bodů)\n" +
    "- CTRL + V: vloží body zkopírované jednou z předchozích metod (body jsou vloženy na identické souřadnice odkud byly zkopírovány, ale v rámci tracku se vloží na konec - případně na alternativní konec, pokud je nastaven - viz výše)\n" +
    "- CTRL + ALT + V: to samé, ale vloží body před začátek (nebo před alternativní konec, pokud je nastaven)\n" +
    "- CTRL + SHIFT (+ ALT) + V: stejné jako výše, ale body jsou vloženy jako nový segment\n" +
    "\n" +
    "::: Obrácení tracku (reverse) :::\n" +
    "\n" +
    "Obrátí track (tedy co byl začátek bude konec a naopak).\n" +
    "\n" +
    "- SHIFT + R: obrátí celý track\n" +
    "- SHIFT + CTRL + R: obrátí jen označené části (použijte hlavně na segmenty, jindy může vést k neočekávaným výsledkům\n" +
    "\n" +
    "::: Omezení :::\n" +
    "- nesnažte se načíst tracky s 10k+ body a seznamy bodů s řekněme 3k+ body - nebo se připravte na pomalost\n" +
    "- pokud tak přesto učiníte, pomalost můžete obejít označením části, následným CTRL+X a zkopírováním do jiného tracku, kde už vás nadbytek bodů nebude zatěžovat; editované body pak můžete do původního tracku zpět zkopírovat\n" +
    "- výsledek snažení je prezentován v podobě textu, do souboru ho JavaScript uložit neumí - takže si to do souboru musíte uložit sami a vhodně si ho pojmenovat\n" +
    "- některé prohlížeče mají ve zvyku si krást pro sebe klávesové zkratky - to lze buď vyřešit v menu prohlížeče nebo vám pomůže prostý fakt, že většinu věcí lze dělat několika způsoby\n" +
    "- Firefox vždy zobrazí kontextové menu po stisknutí pravého tlačítka a SHIFTu - s tím nic udělat nelze\n" +
    "- v Maxthonu 2 je pro správnou funkci tažení pravým tlačítkem nutno v nastavení vypnout gesta myši (Ovládání myši -> Povolit akce myši); také je nutno pro správnou funkci klávesových zkratek s CTRL a levým klikem/tažením vypnout v nastavení tuto položku: Plovoucí tlačítko -> Rychlé uložení obrázků při kliknutí a současném držení CTRL\n" +
    "- v Maxthonu 3 je třeba vypnout stejná dvě nastavení, jen trochu jinde: Gesta myší -> Povolit gesta myší, Nastavení stránky -> Rychlé uložení obrázků pomocí kliknutí při zmáčknuté klávese CTRL; pro Maxthon 3 se vztahuje i níže zmíněná poznámka, takže je pro funkčnost středního tlačítka nutno se přepnout do módu IE\n" +
    "- Safari a další prohlížeče na něm založené (třeby i výše zmíněný Maxthon 3) nepodporují jakékoli akce vyžadující střední tlačítko myši\n" +
    "- v Opeře, kromě problémů popsaných jinde, nefunguje korektně minimapa, když jste v módu Track (bliká při každém překreslení)\n"
};
    
translations["_total_length"] = {"English": "Len", "Czech": "Délka"};
translations["_polygon_area"] = {"English": "Area", "Czech": "Plocha"};
translations["_total_points"] = {"English": "Points", "Czech": "Bodů"};
translations["_poly_load_file"] = {"English": "File", "Czech": "Soubor"};
translations["_poly_import_from_text"] = {"English": "Import", "Czech": "Import"};
translations["_poly_help"] = {"English": "Help", "Czech": "Nápověda"};
translations["_import_text_button"] = {"English": "Import track/polygon", "Czech": "Importuj trasu/polygon"};
translations["_elevation"] =  {"English": "Elevation", "Czech": "Nadmořská výška"};
translations["Index"] =  {"Czech": "Index"};

translations["_delete_track"] =  
{
  "English": "Do you really want to delete the track? This action can't be reversed!",
  "Czech": "Chcete track opravdu smazat? Tato akce nelze vrátit zpět!"
};

translations["_delete_all_tracks"] =  
{
  "English": "Do you really want to delete all tracks? This action can't be reversed!",
  "Czech": "Chcete opravdu smazat všechny tracky? Tato akce nelze vrátit zpět!"
};

translations["_merge_all_tracks"] =  
{
  "English": "Do you really want to merge all tracks into one? This action can't be reversed!",
  "Czech": "Chcete opravdu sloučit všechny tracky do jednoho? Tato akce nelze vrátit zpět!"
};
              
/**********************************************************/
/*                   Polygon - main class                 */
/**********************************************************/
   
function Polygon(map, button, settings)
{
  this.polylines = [];
  this.activeId = -1;
  this.polygonModeOn = false;
  this.polylineCounter = 0; /* for name in select box */
  
  this.map = map;
  this.button = button;
  this.settings = settings;

  var that = this;
  
  // handle clicking on "Polygon" button
  EventUtil.addHandler(button, "click", function()
  {
    that.polygonModeOn ? that.exit() : that.init();
  });
  
  // create sidebar
  this.textArea = new TextArea(this);   

  // create default empty polylines
  for (var i = 0; i < 5; i++)
    this.addPolyline({name: "Poly" + ++this.polylineCounter, Formats: new Formats("")});

  this.activatePolyline(0);
}

Polygon.prototype.init = function()
{
  this.polygonModeOn = true;
  this.button.style.color = "red";
  var that = this;
  
  // nothing activated? then activate first polyline (if there are any)
  if (this.activeId == -1 && this.polylines.length)
    this.activeId = 0;  
  
  if (this.activeId != -1)
    this.activatePolyline(this.activeId);
  
//   // run help box on first run
//   if (!this.settings.polygon_first_run)
//   {
//     this.settings.polygon_first_run = true;
//     ui("copybox", {text: tr("_polygon_info"), width: 600, height: 200});
//   }
  
  // show text area
  this.textArea.show();

  /**** left click on polyline - change active polyline ****/
  this.onPolylineClick = this.map.getSignals().addListener(window, "geometry-click", function(e)
  {
    // CTRL + left click - change active track
    // alternative for Opera: ALT + right click
    if (!e.data.event.ctrlKey && (e.data.event.button != JAK.Browser.mouse.right || !e.data.event.altKey))
      return;

    // get segment + polyline
    var segmentId = e.target.segmentId;
    var polylineId;

    for (var i = 0; i < that.polylines.length; i++)
    {
      if (that.polylines[i] === e.target.that)
        polylineId = i;
    }
    
    // if we clicked on helper-line (activated by M), we get undefined here
    // -- so we don't do anything (M needs to be deactivated first, otherwise it's impossible to click the points)
    if (typeof polylineId === 'undefined')
      return;

    // activate polyline
    that.activatePolyline(polylineId);
    
    // send for further processing
    that.polylines[polylineId].onGeometryClick(e.data.event, segmentId);

    // cleanup
    EventUtil.preventDefault(e.data.event);
    EventUtil.stopPropagation(e.data.event);
    
    // old IE would select all text on the page --> prevent that
    if (JAK.Browser.client == "ie" && JAK.Browser.version <= 8)
      document.selection.empty();
  });

  /**** left click on map - add point / move-rotate selection ****/
  this.onMapClick = this.map.getSignals().addListener(window, "map-click", function(e)
  {
    if (window.contextMenuActive)
      return;
  
    e = e.data.event;

    // proceed only on left mouse button click (Chrome sends this event also on middle button click)
    // IE8 sends wrong JAK.Browser.mouse
    if (e.button != JAK.Browser.mouse.left && (JAK.Browser.client != "ie" || JAK.Browser.version > 8))
      return;
  
    // prevent CTRL - conflicts with track selection (CTRL + click on track/polygon)
    // when in GeoSetter mode, CTRL is necesarry for clicks (but conflicts with track selection)
    if (!!e.ctrlKey != !!window.isGeoSetter)
      return;
    
    // don't react when contextmenu is open
    if (that.activeId != -1 && !window.contextMenuActive)
      that.polylines[that.activeId].onMapClick(e);
  });

  /**** middle click on the map  ****/
  this.onMapMiddleClick = EventUtil.addHandler(this.map.getContainer().parentNode, "mouseup", function(e, target)
  {
    if (e.button != JAK.Browser.mouse.middle || that.activeId == -1 || window.contextMenuActive || JAK.Browser.client == "safari")
      return;

    that.polylines[that.activeId].onMapMiddleClick(e);
  });

  /**** map redraw - redraw active polyline ****/
  // makes minimap in Opera flicker on rectangle move
  this.onMapRedraw = this.map.getSignals().addListener(window, "map-redraw", function(e, elm)
  {
    if (that.activeId != -1)
      that.polylines[that.activeId].onMapRedraw(e);
  });

  /**** map lock/unlock - prevent redraw in this mode ****/
  this.onMapLock = m.getSignals().addListener(window, "map-lock", function(e)
  {
    if (that.activeId != -1)
      that.polylines[that.activeId].mapIsLocked = true;
  });
  
  this.onMapUnLock = m.getSignals().addListener(window, "map-unlock", function(e)
  {
    if (that.activeId != -1)
      that.polylines[that.activeId].mapIsLocked = false;
  })    
  
  /**** marker left click (conflicts with dblclick) ****/
  this.onMarkerLeftClick = this.map.getSignals().addListener(window, "marker-click", function(e)
  {
    if (e.data.event.button != JAK.Browser.mouse.left && (JAK.Browser.client != "ie" || JAK.Browser.version > 8))
      return;  

    if (that.activeId != -1)
      that.polylines[that.activeId].onMarkerLeftClick(e);
  });
  
  /**** marker double click (conflicts with click)  ****/
  this.onMarkerLeftDblClick = this.map.getSignals().addListener(window, "marker-dblclick", function(e)
  {
    if (e.data.event.button != JAK.Browser.mouse.left && (JAK.Browser.client != "ie" || JAK.Browser.version > 8))
      return;  
    
    if (that.activeId != -1)
      that.polylines[that.activeId].onMarkerLeftDblClick(e);
  });    
  
  /**** marker dragged - move it ****/
  this.onMarkerDrag = this.map.getSignals().addListener(window, "marker-drag-stop", function(e)
  {
    if (that.activeId != -1)
      that.polylines[that.activeId].onMarkerDrag(e);  
  });
  
  /**** handle keys (moving selection, history) ****/
  this.onKeyDown = EventUtil.addHandler(document.documentElement, "keydown", function (e, target)
  {
    if (contains_class(document.body, "lightbox_on"))
      return;
  
    var key = String.fromCharCode(e.keyCode).toUpperCase();

    // handle TAB (switch between tracks)
    if (e.keyCode == 9 && !e.shiftKey && !e.ctrlKey && !e.altKey)
    {
      that.lastTabIndex = that.lastTabIndex || that.activeId;
      var startIndex = that.lastTabIndex;
      
      do
      {
        that.lastTabIndex = (that.lastTabIndex + 1 >= that.polylines.length) ? 0 : ++that.lastTabIndex;
        
        // found next one
        if (that.polylines[that.lastTabIndex].points.length)
        {
          that.activatePolyline(that.lastTabIndex);
          that.map.setCenterZoom.apply(that.map, that.map.computeCenterZoom(that.polylines[that.lastTabIndex].points));
          break;
        }

      } while (that.lastTabIndex != startIndex);

      EventUtil.preventDefault(e);
      EventUtil.stopPropagation(e);
    }
    
    // SHIFT + delete --> delete active track
    else if (e.keyCode == 46 && e.shiftKey && !e.ctrlKey && !e.altKey && that.activeId != -1)
    {
      if (!(that.polylines[that.activeId].history.length > 1 /* some history */
      || that.polylines[that.activeId].points.length)        /* or some points present */
      || confirm(tr("_delete_track")))                       /* if so, then ask */
        that.deletePolyline(that.activeId);
    }
    
    // SHIFT + CTRL + ALT + delete --> delete all tracks
    else if (e.keyCode == 46 && e.shiftKey && e.ctrlKey && e.altKey)
    {
      if (confirm(tr("_delete_all_tracks")))
      {
        for (var i = that.polylines.length - 1; i >= 0; i--)
          that.deletePolyline(i);
      }    
    }
    
    // SHIFT + CTRL + ALT + J --> join all tracks (and delete old ones as well)
    else if (key == "J" && e.shiftKey && e.ctrlKey && e.altKey && that.polylines.length >= 1)
    {
      if (confirm(tr("_merge_all_tracks")))
      {
        // create new layer
        that.addPolyline({name: "Joined", Formats: new Formats("")});
        that.activatePolyline(that.polylines.length - 1);
        var joined = that.polylines[that.polylines.length - 1];        

        while(that.polylines.length > 1)
        {
          var poly = that.polylines[0];
          
          // if a layer is a polygon, set the mode of the joined layer to it
          if (poly._isPolygon())
            joined._setPolygon(true);
          
          // set first point as a segment start
          if (poly.points.length && joined.points.length)
            poly.points[0].custom.segmentStart = true;
          
          // concatenate points  
          joined.points = joined.points.concat(poly.points);
          
          // delete old layer
          that.deletePolyline(0);
        }
      }    
    }    
    
    // insert --> create a new track and switch to it
    else if (e.keyCode == 45 /*&& e.shiftKey*/ && !e.ctrlKey && !e.altKey)
    {
      that.addPolyline({name: "MyPoly" + ++that.polylineCounter, Formats: new Formats("")}); 
    }        
  
    else if (that.activeId != -1)
      that.polylines[that.activeId].onKeyDown(e, target);    
  });
  
  this.onKeyUp = EventUtil.addHandler(document.documentElement, "keyup", function (e, target)
  {
    if (that.activeId != -1 && !contains_class(document.body, "lightbox_on"))
      that.polylines[that.activeId].onKeyUp(e, target);    
  });

  this.onKeyPress = EventUtil.addHandler(document.documentElement, "keypress", function (e, target)
  {
    if (that.activeId != -1 && !contains_class(document.body, "lightbox_on"))
      that.polylines[that.activeId].onKeyPress(e, target);    
  });
  
  this.onBlur = EventUtil.addHandler(window, "blur", function (e, target)
  {
    if (that.activeId != -1)
      that.polylines[that.activeId].onBlur(e, target);    
  });
      
  this.onFocus = EventUtil.addHandler(window, "focus", function (e, target)
  {
    if (that.activeId != -1)
      that.polylines[that.activeId].onFocus(e, target);    
  });
  
  /**** track mouse move ****/
  this.onMouseMoveHandler = JAK.Events.addListener(this.map.getContent(), "mousemove", this, function(e, target)
  {
    if (that.activeId != -1)
      that.polylines[that.activeId].onMouseMove(e, target);  
  })
  
  /**** select points ****/
  var selOptionsDefault = {customHandler: encapsulateCall("onPolygonSelectionStop"), customFailDrag: encapsulateCall("onPolygonSelectionStopFail"),
    customRedraw: encapsulateCall("onPolygonSelection"), customStartDrag: encapsulateCall("onPolygonSelectionStart"), thickness: 4};

  this.selectionControls = [];
  var selControls = [];
  var selRectangleMouse = JAK.Browser.mouse.left;
  var selPolygonMouse = JAK.Browser.mouse.right;

  selControls.push({mouseButton: selRectangleMouse, shift: true, alt: true, cursor: "cell", customId: "polygon_Rectangle_AddToSelection"});
  selControls.push({mouseButton: selRectangleMouse, shift: true, cursor: "cell", customId: "polygon_Rectangle_Select"});
  selControls.push({mouseButton: selRectangleMouse, alt: true, customId: "polygon_Rectangle_DeSelect"});  
  selControls.push({mouseButton: selRectangleMouse, shift: true, alt: true, ctrl: true, customId: "polygon_Rectangle_SelectXOR"});

  selControls.push({mouseButton: selPolygonMouse, shift: true, alt: true, cursor: "cell", customId: "polygon_Polygon_AddToSelection"});
  selControls.push({mouseButton: selPolygonMouse, shift: true, cursor: "cell", customId: "polygon_Polygon_Select"});
  selControls.push({mouseButton: selPolygonMouse, alt: true, customId: "polygon_Polygon_DeSelect"});  
  selControls.push({mouseButton: selPolygonMouse, shift: true, alt: true, ctrl: true, customId: "polygon_Polygon_SelectXOR"});
     
  for (var i = 0; i < selControls.length; i++)
  {
    SMap.Util.mergeObject(selOptionsDefault, selControls[i]);
    this.selectionControls.push(new SMap.Control.Selection(selControls[i]));
    this.map.addControl(this.selectionControls[this.selectionControls.length - 1]);  
  }
     
  /**** move points (use selection for this) ****/
  function encapsulateCall(name)
  {
    return function()
    {
      if (that.activeId != -1)
        that.polylines[that.activeId][name](this);
    }    
  }
  
  this.selectionControls.push(new SMap.Control.Selection({ctrl: true, mouseButton: JAK.Browser.mouse.left,
    customHandler: encapsulateCall("onCtrlDragStop"), customRedraw: encapsulateCall("onCtrlDrag"), customStartDrag: encapsulateCall("onCtrlDragStart")}));    

  this.map.addControl(this.selectionControls[this.selectionControls.length - 1]);
  
  /**** rotate points (use selection for this) ****/
  this.selectionControls.push(new SMap.Control.Selection({ctrl: true, shift: true, mouseButton: JAK.Browser.mouse.left,
    customHandler: encapsulateCall("onCtrlShiftDragStop"), customRedraw: encapsulateCall("onCtrlShiftDrag"), customStartDrag: encapsulateCall("onCtrlShiftDragStart")}));    

  this.map.addControl(this.selectionControls[this.selectionControls.length - 1]);
  
  /**** scale points (use selection for this) ****/
  this.selectionControls.push(new SMap.Control.Selection({ctrl: true, alt: true, mouseButton: JAK.Browser.mouse.left,
    customHandler: encapsulateCall("onCtrlAltDragStop"), customRedraw: encapsulateCall("onCtrlAltDrag"), customStartDrag: encapsulateCall("onCtrlAltDragStart")}));    

  this.map.addControl(this.selectionControls[this.selectionControls.length - 1]);
  
  /**** draw points just by dragging middle mouse button (allow version adding points before - ALT) ****/
  // turn it off for IE8 and older (causes problems)
  // disable for Safari based browsers - doesn't distinguish left and middle clicks
  // require CTRL pressed for Opera
  if ((JAK.Browser.client != "ie" || JAK.Browser.version > 8) && JAK.Browser.client != "safari")
  {
    for (var i = 0; i < 4; i++)
    {
      this.selectionControls.push(new SMap.Control.Selection({alt: !!(i % 2), shift: (i < 2), ctrl: (JAK.Browser.client == "opera"), mouseButton: JAK.Browser.mouse.middle,
        customId: ("onDragDraw_" + ((i % 2) ? "Alt" : "NoAlt") + ((i < 2) ? "_Shift" : "_NoShift")),
        customHandler: encapsulateCall("onDragDrawStop"), customRedraw: encapsulateCall("onDragDraw"), customStartDrag: encapsulateCall("onDragDrawStart")}));
    
      this.map.addControl(this.selectionControls[this.selectionControls.length - 1]);
    }
  }

  // broadcast signal
  this.map.getSignals().makeEvent("polygon-mode-init", this);
}

Polygon.prototype.exit = function()
{
  this.polygonModeOn = false;
  this.button.style.color = "";

  // remove listeners/controls
  this.map.getSignals().removeListener(this.onPolylineClick);
  this.map.getSignals().removeListener(this.onMapClick);
  this.map.getSignals().removeListener(this.onMapRedraw);
  this.map.getSignals().removeListener(this.onMapLock);
  this.map.getSignals().removeListener(this.onMapUnLock);
  this.map.getSignals().removeListener(this.onMarkerLeftClick);
  this.map.getSignals().removeListener(this.onMarkerLeftDblClick);
  this.map.getSignals().removeListener(this.onMarkerDrag);
  
  JAK.Events.removeListener(this.onMouseMoveHandler);

  EventUtil.removeHandler(this.onMapMiddleClick);
  EventUtil.removeHandler(this.onKeyDown);
  EventUtil.removeHandler(this.onKeyUp);
  EventUtil.removeHandler(this.onKeyPress);
  EventUtil.removeHandler(this.onBlur);
  EventUtil.removeHandler(this.onFocus);
  
  while (this.selectionControls.length)
  {
    var control = this.selectionControls.pop();
    
    // destructor doesn't get called for some reason, so call it manually
    control.$destructor();
    this.map.removeControl(control);
  }
  
  // deactivate polyline  
  this.deactivatePolyline(this.activeId);

  // hide sidebar
  this.textArea.hide();
  
  // broadcast signal
  this.map.getSignals().makeEvent("polygon-mode-exit", this);    
}

Polygon.prototype.deactivatePolyline = function(id)
{
  this.polylines[id].deactivate();
  
  this.textArea.updateSelectPolygonBox(this.polylines, -1);
}

Polygon.prototype.activatePolyline = function(id)
{
  // turn off old polyline
  if (this.activeId != -1 && this.polylines.length)
    this.deactivatePolyline(this.activeId);

  this.activeId = id;
  this.polylines[this.activeId].activate();
  
  this.textArea.updateSelectPolygonBox(this.polylines, this.activeId);
}

Polygon.prototype.deletePolyline = function(id)
{
  // deactivate and remove layer
  this.deactivatePolyline(id);
  
  this.polylines[id].destroy();
  this.polylines.remove(id);
  
  if (this.activeId >= this.polylines.length)
    this.activeId = 0;
  
  // too few tracks left? create a new empty one  
  if (this.polylines.length <= 0)
    this.addPolyline({name: "Poly" + ++this.polylineCounter, Formats: new Formats("")});  

  this.activatePolyline(this.activeId);
  
  if (this.polylines[this.activeId].points.length)
    this.map.setCenterZoom.apply(this.map, this.map.computeCenterZoom(this.polylines[this.activeId].points));
  
  this.textArea.updateSelectPolygonBox(this.polylines, this.activeId);
}

Polygon.prototype.addPolyline = function(options)
{
  // turn off old polyline
  if (this.polylines.length && this.activeId != -1)
    this.deactivatePolyline(this.activeId);

  var polyline = new Polyline(this, options || {});
  this.polylines.push(polyline);

  polyline.init();
  this.activatePolyline(this.polylines.length - 1);
  
  this.textArea.updateSelectPolygonBox(this.polylines, this.activeId);
}

/**********************************************************/
/*                       TextArea                         */
/**********************************************************/
                                       
function TextArea($super)
{
  this.$super = $super;
  this.map = this.$super.map;
  this.mapadiv = this.map.getContainer();

  this.format = testing ? "GSAK" : "none";
  var that = this;

  // ** main div **
  this.mainDiv = document.createElement("div");
  this.mainDiv.id = "PolygonDiv";
  this.mainDiv.innerHTML = "" 
    + "<div id='line_total_length'></div>" 
    + "<div id=polygon_options>" 
      + "<span>" + tr("Name") + "</span>"
      + "<select id=polygon_current_name></select>"
      + "<span>" + tr("Export") + "</span>"
      + "<select id=polygon_export_format>"
        + "<option value=none>------</option>"
        + "<option value=GSAK" + (testing ? " selected" : "") + ">GSAK</option>"
        + "<option value=GPX_Track>GPX (Track)</option>"
        + "<option value=GPX_Route>GPX (Route)</option>"
        + "<option value=GPX_Waypoints>GPX (Waypoints)</option>"
        + "<option value=PLT>PLT</option>"
        //+ "<option value=RTE>RTE</option>" 
        + "<option value=WPT>WPT</option>"
       // + "<option value=KML>KML</option>"
      + "</select>"
    + "</div>"
    + "<div id=polygon_buttons>"
      + "<span id=poly_file_import class=button>" + tr("_poly_load_file") + "</span>"
      + "<span id=poly_text_import class=button>" + tr("_poly_import_from_text") + "</span>"
      + "<span id=poly_help class=button>" + tr("_poly_help") + "</span>"
    +  "</div>"
    + "<div id=textarea_parent><textarea id='polygon_textarea'></textarea></div>" 
    + "<div id=copy_button class=button>" + tr((JAK.Browser.client == "ie") ? "Copy" : "Select") + "</div>";

  this.mapadiv.parentNode.insertBefore(this.mainDiv, this.mapadiv.nextSibling);
  this.textArea = document.getElementById("polygon_textarea");
  this.lineLengthDiv = document.getElementById("line_total_length");
  this.optionsDiv = document.getElementById("polygon_options");
  this.selectPolygonBox = document.getElementById("polygon_current_name");
  this.selectFormatBox = document.getElementById("polygon_export_format");
  
  this.importFileButton = document.getElementById("poly_file_import");
  this.importTextButton = document.getElementById("poly_text_import");
  this.helpButton = document.getElementById("poly_help");

  // set textarea height
  this.mapadiv.clientHeight; /* IE7-8: may fix possible invalid values on first access */
  this.textArea.parentNode.style.height = (this.mapadiv.clientHeight - (20 + 20 + 18)) + "px"; 

  // prevent any keystrokes within the text area to bubble
  EventUtil.addHandler(this.textArea, "keydown", function(e) {EventUtil.stopPropagation(e);});
  EventUtil.addHandler(this.textArea, "keyup", function(e) {EventUtil.stopPropagation(e);});
  EventUtil.addHandler(this.textArea, "keypress", function(e) {EventUtil.stopPropagation(e);});
   
  // ** copy to clipboard button **
  this.copyButton = document.getElementById("copy_button");
  
  EventUtil.addHandler(this.copyButton, "click", function(e)
  {
    that.textArea.select();
    
    if (JAK.Browser.client == "ie")
      window.clipboardData.setData("Text", that.textArea.value)
  });
  
  // change polyline on different option select
  EventUtil.addHandler(this.selectPolygonBox, "change", function(e, target)
  {
    that.$super.activatePolyline(target.selectedIndex);
        
    // center map on track (if there are any points)
    var points = that.$super.polylines[target.selectedIndex].points;
    
    if (points.length)
      that.map.setCenterZoom.apply(that.map, that.map.computeCenterZoom(points));
  });
  
  // get format
  EventUtil.addHandler(this.selectFormatBox, "change", function(e, target)
  {
    that.format = target.value;
    
    // refresh text area
    if (that.$super.activeId != -1)
      that.writePolyline(that.$super.polylines[that.$super.activeId]);
  });
  
  // handle buttons
  EventUtil.addHandler(this.importFileButton, "click", function(e, target)
  {
    loadFile();
  });

  EventUtil.addHandler(this.importTextButton, "click", function(e, target)
  {
    ui("copybox", {text: "", width: 600, height: 200, select: true, closeButtonText: tr("_import_text_button"),
      getText: function(text)
      {
        if (text.length)
        {
          var file = new Formats(text);
          
          if (file.type)
          {
            for (var i = 0; i < file.Formats.length; i++)
              file.Formats[i].sendToPolygon();          
          }
        }
      }
    });
  });
  
  EventUtil.addHandler(this.helpButton, "click", function(e, target)
  {
    ui("copybox", {text: tr("_polygon_info"), width: 600, height: 200});
  });
  
  // set textare height on window resize
  EventUtil.addHandler(window, "resize", function(e, target)
  {
    that.mapadiv.clientHeight; /* IE7-8: may fix possible invalid values on first access */
    that.textArea.parentNode.style.height = (that.mapadiv.clientHeight - (20 + 20 + 18)) + "px"; 
  });    
};

/* this resizes and moves text area in case we full-screen map within listing */
TextArea.prototype.syncViewPort = function()
{
  this.mapadiv.parentNode.insertBefore(this.mainDiv, this.mapadiv.nextSibling);
  
  // set textarea height
  this.mapadiv.clientHeight; /* IE7-8: may fix possible invalid values on first access */
  this.textArea.parentNode.style.height = (this.mapadiv.clientHeight - (20 + 20 + 18)) + "px"; 
}

TextArea.prototype.show = function()
{
  add_class(document.documentElement, "polygon_on");
  this.map.syncPort();
  window.createDefaultMapControls();
}

TextArea.prototype.hide = function()
{
  remove_class(document.documentElement, "polygon_on");
  this.map.syncPort();
  window.createDefaultMapControls();
}

TextArea.prototype.writePolyline = function(polyline)
{
  timer_start("textarea");

  // write points
  var text = "";
  var segments = polyline.getSegments();
 
  // process format (PLT, GPX, etc.)
  var options = {isPolygon: polyline._isPolygon()};
  
  if (this.format != "none")
    text += polyline.Formats.exportFormat(this.format, segments, options);
  
  this.textAreaSet(text);
                             
  // write line length + number of points / segments
  var distance = polyline.getLength(segments);

  if (distance < 1000)
    var distString = distance.toFixed(2) + " m";
  else
    var distString = (distance / 1000).toFixed(3) + " km";

  // write area (if polygon)
  if (polyline._isPolygon())
  {
    // get area in ha
    var area = polyline.getArea() / (100 * 100);
    var unit = "ha";

    // convert to km2    
    if (area > 1000)
    {
      area /= 10 * 10;
      unit = "km2";
    }
    
    // convert to m2
    else if (area < 1)
    {
      area *= (100 * 100);
      unit = "m2";
    }
    
    area = area.toFixed(2);
  }
  
  this.lineLengthDiv.innerHTML = tr("_total_length") + ": " + distString
    + (polyline._isPolygon() ? (" (" + /*tr("_polygon_area") + ": "*/ + area + " " + unit + ")") : "") 
    + ", " + tr("_total_points") + ": " + polyline.points.length + (segments.length >= 2 ? ("/" + segments.length) : "");  

  // display it as title in case it overflows
  this.lineLengthDiv.title = this.lineLengthDiv.innerHTML;
  //timer_end("textarea");  
}

TextArea.prototype.textAreaSet = function(text)
{
  this.textArea.value = text; 
}

TextArea.prototype.textAreaClear = function()
{
  this.textArea.value = ""; 
}

TextArea.prototype.updateSelectPolygonBox = function(polylines, id)
{
  // info: http://www.javascriptkit.com/jsref/select.shtml

  // remove all options
  while (this.selectPolygonBox.childNodes.length)
    this.selectPolygonBox.removeChild(this.selectPolygonBox.childNodes[0]);
  
  // re-generate options
  for (var i = 0; i < polylines.length; i++)
  {
    // modern browsers (last parameter null)
    try
      {this.selectPolygonBox.add(new Option(polylines[i].name), null);}
    
    // IE7-8beta2 (last parameter missing)
    catch(ex)
      {this.selectPolygonBox.add(new Option(polylines[i].name));}
  }
  
  // select current polyline option
  if (id != -1)
    this.selectPolygonBox.options[id].selected = true;
  
  // select box doesn't update until DOM change (IE, any version), so force it
  if (JAK.Browser.client == "ie")
  {
    var tempElm = document.createElement("span");
    document.documentElement.appendChild(tempElm);
    window.setTimeout(function(){document.documentElement.removeChild(tempElm);}, 200);
  }
}

/**********************************************************/
/* Polyline - contains one line (or polygon - closed line)*/
/**********************************************************/

function Polyline($super, options)
{
  this.$super = $super;
  this.map = this.$super.map;
  this.points = options.points || [];
  this.name = options.name || "polygon";  /* name in select box */
  this.closed = options.closed || false;   /* allow adding points to the end */
  this.active = false;
  this.Formats = options.Formats || null; /* class that can read/export formats */
  this._setPolygon(options.isPolygon);
  
  for (var i = 0; i < this.points.length; i++)
    this.points[i].custom = this.points[i].custom || {};
  
  // draw line to where the mouse is (if we start from scratch only)  
  this.lineToMousePos = !this.points.length;  
};

Polyline.prototype.init = function()
{
  /* polygon/polyline layer */
  this.layer = new SMap.Layer.Geometry("polylineLayer");
  this.map.addLayer(this.layer);
  this.layer.enable();
  
  /* geometry layer for extra elements (like arrows) */
  this.helperLayer = new SMap.Layer.Geometry("polylineHelperLayer");
  this.map.addLayer(this.helperLayer);
  this.helperLayer.enable();

  /* points (markers) */
  this.markerLayer = new SMap.Layer.Marker();
  this.map.addLayer(this.markerLayer).enable();
  this.markerLayer.enable();

  this.history = [];
  this._saveHistory();
  
  var that = this;
  this.onMarkerRightClick = function(e, target) {that._onMarkerRightClick.call(that, e, target);}
  
  // center map (if there are any points)
  if (this.points.length)
    this.map.setCenterZoom.apply(this.map, this.map.computeCenterZoom(this.points));   
};

Polyline.prototype.exit = function()
{
  this.history = [];
  this.$super.textArea.textAreaClear();

  this.markerLayer.removeAll();
  this.map.removeLayer(this.markerLayer);
  this.map.removeLayer(this.layer);
  this.map.removeLayer(this.helperLayer);
  delete this.markerLayer;
  delete this.layer;
  delete this.helperLayer;
}

/* drag + CTRL - move selected points */
Polyline.prototype.onCtrlDragStart = function(e)
{
  this._saveHistory();
  this.lastSelectedDelta = null;  
}

Polyline.prototype.onCtrlDrag = function(e)
{
  var delta = e._point2.clone().minus(e._point1);
  
  var selected = this.getSelected();
  
  if(this.lastSelectedDelta && selected.length)
  {
    this.movePoints(selected, delta.clone().minus(this.lastSelectedDelta));
    this.drawAll(this.points.length > 300);    
  }
  
  this.lastSelectedDelta = delta;
}

Polyline.prototype.onCtrlDragStop = function(e)
{
  // redraw to update text area
  this.drawAll();
}

/* drag + CTRL + SHIFT - rotate selected points */
Polyline.prototype.onCtrlShiftDragStart = function(e)
{
  this._saveHistory();
  this.selectedDragOrigin = null;
  this.lastAzimuth = 0;
}

Polyline.prototype.onCtrlShiftDrag = function(e)
{
  var selected = this.getSelected();
  
  if(this.selectedDragOrigin && selected.length)
  {
    var azimuth = this.selectedDragOrigin.azimuth(e._point2.toCoords(this.map));
    this.rotatePoints(selected, azimuth - (this.lastAzimuth || azimuth), this.selectedDragOrigin);
    this.lastAzimuth = azimuth;
    this.drawAll(this.points.length > 300);    
    
    // create marker at origin
    var markerDiv = JAK.mel("div", {className: "rotateOriginMarker"});
    var marker = new SMap.Marker(this.selectedDragOrigin, null, {url: markerDiv, anchor: {left: 4, top: 4}});
    this.markerLayer.addMarker(marker);
  }
  else
  {
    this.selectedDragOrigin = e._point1.toCoords(this.map);
  }
}

Polyline.prototype.onCtrlShiftDragStop = function(e)
{
  // remove center marker
  this.drawAll();
}

/* drag + CTRL + ALT - scale selected points from origin */
Polyline.prototype.onCtrlAltDragStart = function(e)
{
  this._saveHistory();
  this.selectedDragOrigin = null;
  this.selectedDragLastMouseOn = null;
}

Polyline.prototype.onCtrlAltDrag = function(e)
{
  var selected = this.getSelected();
  
  if(this.selectedDragOrigin && selected.length)
  {
    // get Y difference between last point and this point and enlarge if positive, make smaller if negative 
    var delta = 0.02;
    var difFromLast = e._point2.toCoords(this.map).toPixel(this.map).y - this.selectedDragLastMouseOn.toPixel(this.map).y;
    var scale = 1 + delta * (difFromLast < 0 ? 1 : -1);  
  
    this.scalePoints(selected, scale, this.selectedDragOrigin);
    this.drawAll(this.points.length > 300);    
    
    this.selectedDragLastMouseOn = e._point2.toCoords(this.map);
    
    // create marker at origin
    var markerDiv = JAK.mel("div", {className: "scaleOriginMarker"});
    var marker = new SMap.Marker(this.selectedDragOrigin, null, {url: markerDiv, anchor: {left: 4, top: 4}});
    this.markerLayer.addMarker(marker);       
  }
  else
  {
    this.selectedDragLastMouseOn = this.selectedDragOrigin = e._point1.toCoords(this.map);
  }
}

Polyline.prototype.onCtrlAltDragStop = function(e)
{
  // remove center marker
  this.drawAll();
}

// Polyline.prototype.onFlipStart = function(e, target)
// {
// }
// 
// Polyline.prototype.onFlip = function(e)
// {
// }
// 
// Polyline.prototype.onFlipStop = function(e)
// {
// }

/* drag + CTRL + ALT - draw new points just by dragging the middle button (ALT activates "insert before" mode) */
Polyline.prototype.onDragDrawStart = function(e, target)
{
  this.lastDragDrawCoords = null;
  this.dragDrawAddedPoints = 0;

  // deal with first run
  this.dragDrawFirstRun = 0;
  this.dragDrawFirstE = null;

  this.shiftPending = false;
}

Polyline.prototype.onDragDraw = function(e, options)
{
  // don't add points while map is dragged
  if (this.mapIsLocked)
    return;  

  options = options || {};
  var eventPt = e._point2;

  // use this when run in free mouse move mode (without pressed mouse button) - we get different e
  if (!e._point2)
  {
    // start with SHIFT - new segment on first run
    if (e.shiftKey && !this.dragDrawFirstRun)
      this.shiftPending = true;
      
    // when CTRL goes up and SHIFT is pressed start new segment
    // - to make it reliable, allow SHIFT going up first
    if (options.ctrlUp && e.shiftKey)
      this.shiftPending = true;
      
    if (options.shiftUp && e.ctrlKey)
      this.shiftPending = true;

    // don't create new points when CTRL is pressed (but add point on CTRL-up)
    if (e.ctrlKey && !options.ctrlUp) 
      return;

    eventPt = new SMap.Coords.fromEvent(e, this.map).toPixel(this.map);
    e.customId = (e.altKey) ? "_Alt" : "";
    //e.customId += (e.shiftKey) ? "_Shift" : "";
  }

  // on first run, just save the point and draw it on second run,
  // because this may be just click and not a draw
  if (!this.dragDrawFirstRun++)
  {
    this.dragDrawFirstE = e;
    
    if (e.shiftKey)
      this.shiftPending = true;

    return;
  }
  
  if (this.dragDrawFirstRun == 2)
  {
    this._saveHistory();
    this.onDragDraw(this.dragDrawFirstE);
  }

  //**********
  // parameters
  var minimumMouseMove = 15;
  var saveHistoryInterval = 10;

  // get coordinates
  var point = eventPt.toCoords(this.map);
  point.custom = point.custom || {};

  // draw points after moving mouse more than minimum amount of pixels
  var minimumMouseMove = 15;
  
  if (this.lastDragDrawCoords)
  {
    var distance = this.lastDragDrawCoords.distance(point.toPixel(this.map));
  
    if (distance < minimumMouseMove)
      return;
  }

  this.lastDragDrawCoords = point.toPixel(this.map);
  
  // save history in regular intervals (after adding certain number of points)
  if (this.dragDrawAddedPoints++ >= saveHistoryInterval)
  {
    this._saveHistory();
    this.dragDrawAddedPoints = 0;
  }
  
  // make the point start of a segment (if shift is pushed)
  if ((e.customId.match(/_Shift/) && this.dragDrawFirstRun == 3) || this.shiftPending)
  {
    point.custom.segmentStart = true;
    this.shiftPending = false;
  }
  
  // insert point
  this._insertPoint(point, undefined, e.customId.match(/_Alt/));
  
  // redraw
  this.drawAll(this.points.length > 300);
}

Polyline.prototype.onDragDrawStop = function(e)
{
}

Polyline.prototype.startFreeDrawMode = function(event)
{
  this.freeDrawMode = true;
  this.map.disableMarkerDragging();
  this.onDragDrawStart(event);
}  

Polyline.prototype.cancelFreeDrawMode = function()
{
  // create some delay to prevent immediate click on marker after finishing drawing
  this.map.enableMarkerDragging();
  
  if (this.freeDrawMode)
  {
    this.freeDrawMode = false;
    return true;  
  }

  return false;
}

/* click on a map - add point */
Polyline.prototype.onMapClick = function(e)
{
  var point = SMap.Coords.fromEvent(e, this.map);

  if (this.cancelFreeDrawMode())
    return;

  // don't create new points if end point is within hidden region
  if(this._isPointsOriginInHiddenSegment(null, e.altKey))
    return;

  // standard - add point to the end, whether standard or alternative (ALT - before start)
  if (!e.shiftKey/* && !e.ctrlKey*/)
  {
    this._saveHistory();
    this._insertPoint(point, undefined, e.altKey);
    this.drawAll();
  }
  
  // SHIFT - create new segment
  else if (e.shiftKey/* && !e.ctrlKey*//* && !e.altKey*/)
  {
    this._saveHistory();
    point.custom = point.custom || {};
    point.custom.segmentStart = true;
    this._insertPoint(point, undefined, e.altKey);
    this.drawAll();
  }  
}

/* middle click on a map */
Polyline.prototype.onMapMiddleClick = function(e)
{
  if (this.cancelFreeDrawMode())
    return;

  // free draw mode (SHIFT starts it with new segment, ALT switches appending mode to before, CTRL pauses drawing)
  if (!e.ctrlKey /*&& !e.shiftKey && !e.altKey*/ && JAK.Browser.client != "opera")
  {
    this.startFreeDrawMode();
    //this.onMapClick(e);
  }

  if (e.ctrlKey && e.shiftKey && !e.altKey)
  {
    this._saveHistory();
    
    // get origin (axis center)
    var origin = new SMap.Coords.fromEvent(e, this.map);
    
    // reset flip settings on first run or moving mouse away from last origin
    if (typeof this.flipSettings === 'undefined' 
      || !this.lastFlipOrigin || !this.lastFlipOrigin.equals(origin))
      this.flipSettings = 0;
    
    this.flipSettings %= 4;
    
    this.lastFlipOrigin = origin;
  
    // each time function is called we advance to the next possibility (out of 4 possible combinations)
    var x = false, y = false;;
    
    // horizontal flip
    if (this.flipSettings == 0) 
      x = true, y = false;
    // reset horizontal flip, set vertical flip
    else if (this.flipSettings == 1) 
      x = true, y = true;
    // horizontal + vertical flip
    else if (this.flipSettings == 2)
      x = true, y = false;
    // original    
    else if (this.flipSettings == 3)
      x = true, y = true;      
    
    this.flipSettings++;
  
    this.flipPoints(this.getSelected(), origin, x, y);
  
    // redraw
    this.drawAll();  
  }
}

/* map redraw - redraw our polyline */
Polyline.prototype.onMapRedraw = function(e)
{
  this.drawAll(); 
}

/* click on geometry - possibly activate/deactivate segment */
Polyline.prototype.onGeometryClick = function(e, segmentId)
{
  if (!e.ctrlKey && (e.button != JAK.Browser.mouse.right))
    return;

  this._saveHistory();
  
  var changed = false;
  
  // SHIFT + CTRL + ALT - display only one selected segment
  if (e.shiftKey && e.ctrlKey && e.altKey)
  {
    changed = this.showOnlyOneSegment(segmentId);
  }
  
  // SHIFT + CTRL - switch state of segment (on/off)
  // alternative version for Opera (which zooms out SVG element on ctrl+left/right click
  // and zooms in SVG elements on ctrl+left/right click): right click + CTRL + ALT
  else if ((e.button == JAK.Browser.mouse.left && e.shiftKey && e.ctrlKey && !e.altKey)
    || (e.button == JAK.Browser.mouse.right && !e.shiftKey && e.ctrlKey && e.altKey))
  {
    var clickedSegment = this.getSegments()[segmentId];
    changed = this.showHideSegments(this.isSegmentHidden(clickedSegment), clickedSegment);
  }

  // if no change, revert history
  changed ? this.drawAll() : this._restoreHistory();
}


Polyline.prototype.isSegmentHidden = function(segment)
{
  return(!!segment[0].custom.hideSegment);
}

Polyline.prototype.showOnlyOneSegment = function(id)
{
  var segments = this.getSegments();
  var changed = false;
  
  for (var i = 0; i < segments.length; i++)
  {
    changed = this.showHideSegments(id === i, segments[i]) || changed;  
  }

  return changed;
}

/* display or hides segments */
Polyline.prototype.showHideSegments = function(showHide, segments)
{
  segments = segments ? [segments] : this.getSegments(); 
  var hide = !showHide;
  var changed = false;
  
  for (var i = 0; i < segments.length; i++)
  {
    var old = !!segments[i][0].custom.hideSegment;
    changed = changed || (old != hide);
    segments[i][0].custom.hideSegment = hide;
    
    // deselect points on hiding segment
    if (hide && hide != old)
      this.deSelectPoints(segments[i]);
  }

  return changed;
}

/* get all track segments */
Polyline.prototype.getSegments = function(points)
{
  points = points || this.points;
  
  if (!points.length)
    return [];

  var segments = [[]];
  
  for (var i = 0; i < points.length; i++)
  {
    var p = points[i];
    
    // segment start? then add new segment
    if (p.custom.segmentStart && segments[segments.length - 1].length)
      segments.push([]);
    
    // append point to the last segment
    segments[segments.length - 1].push(p);
  }
  
  return segments;
}

Polyline.prototype._getVisibleHiddenSegments = function(visible)
{
  var segments = this.getSegments();
  
  if (!segments.length)
    return [];

  var visible = [];
  
  for (var i = 0; i < segments.length; i++)
  {
    if (!!segments[i][0].custom.hideSegment == !visible)
      visible.push(segments[i]);
  }

  return visible;
}

Polyline.prototype.getVisibleSegments = function()
{
  return(this._getVisibleHiddenSegments(true));
}

Polyline.prototype.getHiddenSegments = function()
{
  return(this._getVisibleHiddenSegments(false));
}

/* converts segments to points */
Polyline.prototype.flattenSegments = function(segments)
{
  var points = [];
  
  for (var i = 0; i < segments.length; i++)
    points = points.concat(segments[i]);

  return points;
}

/* get segment ID from point ID */
Polyline.prototype.getSegmentIDFromPointID = function(id, segments)
{
  var segments = segments || this.getSegments();
  var total = 0;
  
  for (var i = 0; i < segments.length; i++)
  {
    total += segments[i].length;

    if (id < total)
      return i;
  }
  
  return -1;
}

Polyline.prototype._getDataFromMarker = function(e, target)
{
  // ** get marker **
  
  // from marker event
  if (!target)
  {
    var marker = e.target;
    target = marker.getContainer()[SMap.LAYER_MARKER];
  }
  
  // from marker div
  // - check is there to fix occassional bug where marker id is invalid
  // (activate this bug by redrawing minimap on layer-enable and intense point drawing using T)
  else if (this.markerLayer._markers[target.markerId])
  {
    var marker = this.markerLayer._markers[target.markerId].marker;
  }
  
  else
    return null;

  // get point index
  var index = (typeof target["data-index"] === 'undefined') ? -1 : target["data-index"];
  var indexHalf = (typeof target["data-index-half"] === 'undefined') ? -1 : target["data-index-half"];

  // return null if invalid
  if (index < 0 && indexHalf < 0)
    return null;

  // transparent point
  if (index < 0)
    return {type: "half", indexHalf: indexHalf, point: marker.getCoords()};
  // full point
  else
    return {type: "full", index: index, point: marker.getCoords()};
}


/* marker dragged - move it */
Polyline.prototype.onMarkerDrag = function(e)
{
  var marker = this._getDataFromMarker(e);
  
  if (!marker)
    return;

  // half marker - add point
  if (marker.type == "half")
  {
    this._saveHistory();
    this._insertPoint(marker.point, marker.indexHalf + 1);
  }
          
  // normal marker - move it
  // non-visible points will either be straightened to a straight line or (SHIFT) rotated/scaled to fit the move
  else if (marker.type == "full")
    this._replacePoint(marker.index, marker.point, contains_class(this.map.getContainer(), "key_down_shift") ? "rotateScale" : ""); 

  this.drawAll();
}

/* react on right clicking a marker (delete point) */
Polyline.prototype._onMarkerRightClick = function(e, target)
{
  var marker = this._getDataFromMarker(e, target);

  if (!marker || e.ctrlKey || e.altKey)
    return;

  // right click - remove point
  if (marker.type == "full" && !e.shiftKey)
  {
    EventUtil.stopPropagation(e);
    EventUtil.preventDefault(e);  
  
    this._saveHistory();
    this._removePoint(marker.index);
    this.drawAll();
  }
  
  // SHIFT + right click - remove segment
  else if (marker.type == "full" && e.shiftKey)
  {
    EventUtil.stopPropagation(e);
    EventUtil.preventDefault(e);
  
    this._saveHistory();
    var id = this.getSegmentIDFromPointID(marker.index);
    this.removePoints(this.getSegments()[id]);
    this.drawAll();
  }
}

/* react on left clicking a marker (close polygon - if clicked on the first element) */
Polyline.prototype.onMarkerLeftClick = function(e, target)
{
  var marker = this._getDataFromMarker(e, target);
  e = e.data.event;

  if(!marker || this.freeDrawMode)
    return;

  // half marker - add point (left click)
  if (marker.type == "half" && !e.shiftKey && !e.ctrlKey && !e.altKey)
  {
    this._saveHistory();
    this._insertPoint(marker.point, marker.indexHalf + 1);
    this.drawAll();
  }

  // close / open polygon on clicking on the first point (left click)
  else if (marker.type == "full" && marker.index == 0 && this.points.length >= 3 && !e.shiftKey && !e.ctrlKey && !e.altKey)
  {
    this._saveHistory();
    this._setPolygon(!this._isPolygon());
    this.drawAll();
  }
  
  // init / remove closed state (can't add new points to the end) on clicking the last point (SHIFT + left-click)
  else if (marker.type == "full" && (marker.index == this.points.length - 1) && !e.shiftKey && !e.ctrlKey && !e.altKey)
  {
    this._saveHistory();
    this._removeNewPointsOrigin();
    this.closed = !this.closed;
    this.drawAll();
  }
  
  // mark marker as origin - new clicks on map will add points after it, not after track end (ALT + left-click)
  else if (marker.type == "full" && !e.shiftKey && !e.ctrlKey && e.altKey)
  {
    this._saveHistory();
    
    // if clicked on is identical to original, then remove it
    if (this.points[marker.index] === this.addNewPointsOrigin)
    {
      this._removeNewPointsOrigin();
      this.drawAll();
    }
    // standard - add
    // - restore history if no change
    else if (!this._addNewPointsOrigin(this.points[marker.index]))
      this._restoreHistory();
      
    this.drawAll();
  }  
  
  // join / disconnect segments on segment end click (SHIFT + left click) 
  else if (marker.type == "full" && e.shiftKey && (marker.index < this.points.length - 1))
  {
    var isSegmentEnd = this.points[marker.index + 1].custom.segmentStart;

    // SHIFT+CTRL+ALT --> join all segments
    if (e.ctrlKey && e.altKey && isSegmentEnd)
    {
      this.joinAllSegments();
    }
    
    // SHIFT+CTRL --> join segments that have at least one point selected
    if (e.ctrlKey && !e.altKey && isSegmentEnd)
    {
      this.joinAllSegments(true);
    }    
    
    // standard
    else if (!e.ctrlKey && !e.altKey)
    {
      this._saveHistory();
      this.points[marker.index + 1].custom.segmentStart = !isSegmentEnd;
      this.drawAll();  
    }   
  }
}

Polyline.prototype.onMarkerLeftDblClick = function(e, target)
{
  // note: dblclick on first point doesn't fire - is cancelled by function above

  var marker = this._getDataFromMarker(e, target);
  e = e.data.event;

  // dbl click without any modifier keys - same as SHIFT+click (join/disconnect segments)
  if (marker.type == "full" && (marker.index < this.points.length - 1) 
    && !e.ctrlKey && !e.altKey && !e.shiftKey)
  {
    this._saveHistory();
    var isSegmentEnd = this.points[marker.index + 1].custom.segmentStart;
    this.points[marker.index + 1].custom.segmentStart = !isSegmentEnd;
    this.drawAll();
    
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);  
  }
}

Polyline.prototype.onMarkerMouseEnter = function(e, target)
{
  // exit if already generated
  if (target.alreadyCreated)
    return;

  var that = target.that;

  // get marker div
  var markerDiv = that._getDataFromMarker(e, target);
  
  // invalid marker id (may happen - rarely)?
  if (!markerDiv)
    return;

  var point = markerDiv.point;
  
  marker = that.markerLayer._markers[target.markerId].marker; /* marker object */
    
  // create bubble
  if (!marker.bubble)
  {
    var bubble = new SMap.Bubble({minWidth: 180, background: "#f0ffc6", timeout: 0});
    marker.decorate(SMap.Marker.Feature.Bubble, bubble);
  }
  
  add_class(marker.bubble.dom, "polygonMarkerBubble");

  target.alreadyCreated = true;

  // *** create bubble info ***
  var text = "";
  
  // get name (if any)
  if (point.custom.name)
    text += "<span class=track_point_name>" + point.custom.name + "</span><br>";
    
  // get description (if any)
  if (point.custom.desc)
    text += "<span class=track_point_desc>" + point.custom.desc + "</span><br>";

  // get coordinates
  text += "<span class=track_coords>" + point.format("WGS84", "min") + "</span><br>";

  // get indexes
  var segments = that.getSegments();
  var id = markerDiv.index;
  var segId = that.getSegmentIDFromPointID(markerDiv.index, segments);
  var idFromSegmentStart = id - that.getIndexFromPoint(segments[segId][0])

  text += "<span class=track_point_indexes>";
  
  if (point.custom.isPoint || segments.length <= 1)
    text += tr("Index") + ": " + (id + 1);
  else
    text += tr("Index") + ": " + (idFromSegmentStart + 1) + " (" + (id + 1) + ")<br>" + tr("Segment") + ": " + (segId + 1);
  
  text += "</span><br>";

  // get time
  if (!isNaN(point.custom.timestamp))
  {
    var time = new Date(point.custom.timestamp);
    text += "<span class=track_date>" + time.toLocaleDateString() + "</span>";
    text += "  <span class=track_time>" + time.toLocaleTimeString() + "</span><br>";
  }
  
  // get elevation
  if (!isNaN(point.custom.elevation))
  {
    text += "<span class=track_elevation>" + tr("_elevation") + ": " + point.custom.elevation.toFixed(1) + " m</span><br>";
  }  

  marker.bubble.setHTML(text);
}

Polyline.prototype.getSelected = function(points)
{
  points = points || this.points;
  var selected = [];
  
  for (var i = 0; i < points.length; i++)
  {
    if (points[i].custom.isSelected)
    {
      var p = points[i];
      p.custom.curIndex = i;
      selected.push(p);
    }
  }

  return selected;
}

Polyline.prototype.getIndexFromPoint = function(point)
{
  for (var i = 0; i < this.points.length; i++)
  {
    if (this.points[i] === point)
      return i;
  }
  
  return null;
}

Polyline.prototype.movePoints = function(points, delta /* SMap.pixel */)
{
  // get distance and azimuth of the move
  var center = new SMap.Pixel(0, 0).toCoords(this.map); /* center of map */
  delta = delta.toCoords(this.map);                     /* moved center */
  var distance = center.distance(delta);
  var azimuth =  center.azimuth(delta);
  //log(distance);

  for (var i = 0; i < points.length; i++)
  {
    var p = points[i];
    var newP = p.projectPoint(azimuth, distance);
    this.updateCoords(p, newP.lat(), newP.lon());
  }
}

Polyline.prototype.rotatePoints = function(points, angle, origin)
{
  // get origin point (center of rotation)
  var origin = origin || this.map.computeCenterZoom(points)[0];

  for (var i = 0; i < points.length; i++)
  {
    var p = points[i];
    var newP = origin.projectPoint(origin.azimuth(p) + angle, origin.distance(p));
    this.updateCoords(p, newP.lat(), newP.lon());
  }
}

Polyline.prototype.scalePoints = function(points, scale, origin)
{
  // get origin point (center of rotation)
  origin = origin || this.map.computeCenterZoom(points)[0];

  for (var i = 0; i < points.length; i++)
  {
    var p = points[i];
    var newP = origin.projectPoint(origin.azimuth(p), origin.distance(p) * scale);
    this.updateCoords(p, newP.lat(), newP.lon());
  }
}

Polyline.prototype.flipPoints = function(points, origin, horizontal, vertical)
{
  horizontal = horizontal ? 1 : - 1;
  vertical = vertical ? 1 : - 1;
  
  origin = origin || this.map.computeCenterZoom(points)[0];
  var originLat = origin.lat();
  var originLon = origin.lon();
  
  for (var i = 0; i < points.length; i++)
  {
    var p = points[i];

    var pLat = p.lat();
    var pLon = p.lon();      
    pLat = originLat + (originLat - pLat) * vertical;
    pLon = originLon + (originLon - pLon) * horizontal;
    this.updateCoords(p, pLat, pLon);
  }
}

Polyline.prototype.removePoints = function(points)
{
  for (var i = 0; i < points.length; i++)
    this.points.remove(this.getIndexFromPoint(points[i]));
  
  if (this.points.length < 3)
    this._setPolygon(false);
}

Polyline.prototype._selectDeselectPoints = function(points, showHide)
{
  if (!points.length)
    return false;

  var changed = false;
  showHide = !!showHide;
  
  for (var i = 0; i < points.length; i++)
  {
    changed = changed || (!!points[i].custom.isSelected != showHide);
    points[i].custom.isSelected = showHide;
  }
  
  return changed;
}

Polyline.prototype.selectPoints = function(points)
{
  return(this._selectDeselectPoints(points, true));
}

Polyline.prototype.deSelectPoints = function(points)
{
  return(this._selectDeselectPoints(points, false));
}

// get polyline total length
Polyline.prototype.getLength = function(segments)
{
  var segments = segments || this.getSegments();
  var distance = 0;

  for (var i = 0; i < segments.length; i++)
  {
    var seg = segments[i];
    
    if (this.isSegmentHidden(seg))
      continue;    
  
    for (var j = 0, len = seg.length; j < len - 1; j++)
      distance += seg[j].distance(seg[j + 1], {quick: (this.points.length > 300)}); /* lot of points --> use quicker formula */
      
    // if polygon, get distance to first segment point as well
    if (this._isPolygon() && seg.length)
      distance += seg[0].distance(seg[seg.length - 1], {quick: (this.points.length >300)});
  }

  return distance;
}

// get polyline (polygon) total area
// info: http://gis.stackexchange.com/questions/711/how-can-i-measure-area-from-geographic-coordinates
// info: http://trac.osgeo.org/openlayers/browser/trunk/openlayers/lib/OpenLayers/Geometry/LinearRing.js?rev=10116#L233
// - doesn't work correctly on polygons, where lines are overlapping
Polyline.prototype.getArea = function()
{
  var area = 0.0;

  // iterate over segments
  var segments = this.getSegments();
  
  for (var i = 0; i < segments.length; i++)
  {
    var seg = segments[i];
    
    if (this.isSegmentHidden(seg))
      continue;
    
    // get pairs of WGS coordinates
    var coords = [];
    
    for (var j = 0; j < seg.length; j++)
      coords.push(seg[j]);
    
    // add starting point to the end  
    if (seg.length)
      coords.push(seg[0]);
    
    // no action if 2 points or less  
    var len = coords.length;
    
    if (len <= 2)
      continue;
    
    // compute area  
    var subarea = 0.0;
    var rad = Math.PI / 180.0;

    for(var k = 0; k < len - 1; k++)
    { 
      p1 = coords[k]; 
      p2 = coords[k + 1];
      subarea += (p2.lon() - p1.lon()) * rad * (2 + Math.sin(p1.lat() * rad) + Math.sin(p2.lat() * rad)); 
    } 
    
    // append to total area
    area += Math.abs(subarea * 6378137.0 * 6378137.0 / 2.0);  
  }

  return area;
}

/* handle keys (moving selection, history) */
Polyline.prototype.onKeyDown = function(e, target)
{
  var key = String.fromCharCode(e.keyCode).toUpperCase();
  
  // CTRL+Z: restore history
  if (key == 'Z' && e.ctrlKey && !e.altKey)
  {
    this._restoreHistory(e.shiftKey ? true : false);
    EventUtil.preventDefault(e);
  }
    
  // TAB: iterate over track segments or points
  if (e.keyCode == 9 && (e.ctrlKey || e.shiftKey) && !e.altKey)
  {
    // SHIFT + TAB - iterate over track segments
    if (e.shiftKey && !e.ctrlKey)
    {
      this.lastTabIndex = this.lastTabIndex || 0;
      var startIndex = this.lastTabIndex;
      var segments = this.getSegments();
  
      this.lastTabIndex = (this.lastTabIndex + 1 >= segments.length) ? 0 : ++this.lastTabIndex;

      if (segments.length && segments[this.lastTabIndex].length)
      {
        this._saveHistory();
        var changed = this.showOnlyOneSegment(this.lastTabIndex);
        changed ? (this.map.setCenterZoom.apply(this.map, this.map.computeCenterZoom(segments[this.lastTabIndex]))) : this._restoreHistory();
      }
    }
    
    // CTRL (+ SHIFT - increases speed) + TAB - iterate over points
    else if (e.ctrlKey && e.shiftKey)
    {
      this.lastPointTabIndex = this.lastPointTabIndex || 0;
      var startIndex = this.lastPointTabIndex;
      var delta = e.ctrlKey ? 25 : 1;

      this.lastPointTabIndex = (this.lastPointTabIndex + delta >= this.points.length) ? 0 : (this.lastPointTabIndex + delta);
      
      if (this.points.length)
        this.map.setCenter(this.points[this.lastPointTabIndex]);
    }    

    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);
  }
  
  // escape (deselect all selected + show all hidden segments 
  //   + remove alternative origin + remove free draw mode)
  else if (e.keyCode == 27 /* escape */)
  {
    this._saveHistory();
    var changed = this.deSelectPoints(this.getSelected());
    changed = this.showHideSegments(true) || changed;
    changed = this._removeNewPointsOrigin() || changed;
    changed = this.cancelFreeDrawMode() || changed;
    changed ? this.drawAll() : this._restoreHistory();
  } 
  
  else if (key == "E" || key == "S" || key == "D" || key == "F" || (e.keyCode >= 37 && e.keyCode <= 40) /* arrows */
    || e.keyCode == 46 /* delete */)
  {
    var x = 0, y = 0, angle = 0, scale = 0;

    // info: arrows don't work inside of GSAK, so use alternative keys as well
    //    38
    // 37 40 39
    //
    // keyup - 1x
    // keydown - repeatedly
    // 
    // delete: 46
    // escape: 27    

    // up arrow (no: move, CTRL: scale up) 
    if (key == "E" || e.keyCode == 38)
      e.ctrlKey ? scale = 0.01 : y = -1;
      
    // down arrow (no: move, CTRL: scale down) 
    else if (key == "D" || e.keyCode == 40)
      e.ctrlKey ? scale = -0.01 : y = 1;
      
    // left arrow (no: move, CTRL: rotate left) 
    else if (key == "S" || e.keyCode == 37)
      e.ctrlKey ? angle = -1 : x = -1;
      
    // right arrow (no: move, CTRL: rotate right) 
    else if (key == "F" || e.keyCode == 39)
      e.ctrlKey ? angle = 1 : x = 1;

    // move quicker with SHIFT pressed
    if (e.shiftKey)
    {
      var delta = 10;
      x *= delta;
      y *= delta;
      angle *= delta;
      scale *= delta;      
    }

    // get selected points
    var selected = this.getSelected();

    if (!selected.length)
      return;

    // save state
    this._saveHistory();

    // prevent default action
    EventUtil.stopPropagation(e);
    EventUtil.preventDefault(e);

    // -- modify points --
    // move
    if (x || y)
      this.movePoints(selected, new SMap.Pixel(x, y));
      
    // rotate
    else if (angle)
      this.rotatePoints(selected, angle);

    // scale
    else if (scale)
      this.scalePoints(selected, 1 + scale);
      
    // delete (delete all selected)
    else if (e.keyCode == 46 && !e.shiftKey && !e.ctrlKey && !e.altKey)
      this.removePoints(selected);

    // remove polygon mode, if too few points
    if (this.points.length <= 2)
      this._setPolygon(false);

    this.drawAll();
  }
  
  // space - temporarily hide all markers
  else if (e.keyCode == 32)
  {
    add_class(document.body, "noShowTrackMarkers");
    
    // Firefox requires cancelling here as well
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);    
  }
  
  /*** saving/cutting/pasting ponts ***/
  // - use keydown instead of keypress (always reliable)
  // for reference, working keypress events are this:
  // IE9-10 - base key + SHIFT + CTRL + ALT
  // IE7-8 - base key
  // Chrome -  base key + SHIFT
  // Firefox - base key + SHIFT + CTRL + ALT
  
  // CTRL + A --> select all points
  else if (key == "A" && e.ctrlKey && !e.shiftKey && !e.altKey)
  {
    this._saveHistory();
    var points = this.flattenSegments(this.getVisibleSegments());
    this.selectPoints(points) ? this.drawAll() : this._restoreHistory();
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);  
  }  
  
  // CTRL + C --> copy selected points
  // CTRL + X --> cut selected points
  else if ((key == "C" || key == "X") && e.ctrlKey && /*!e.shiftKey &&*/ !e.altKey)
  {
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);
      
    var selected = this.getSelected();

    if (!selected.length)
      return;
      
    this._saveHistory();

    // unless SHIFT pressed: create segments on beginnings of non-continuous areas
    if (!e.shiftKey)
    {
      var continuousIndexes = this.getContinuousAreas(selected, {returnIndexes: true});
      selected = this._restorePoints(this._backupPoints(selected));
      
      // create segments
      for (var i = 1; i < continuousIndexes.length; i++)
        selected[continuousIndexes[i]].custom.segmentStart = true;
    }

    // remove points on CTRL + X
    if (key == "X")
      this.removePoints(this.getSelected());    
    
    this.$super.copyPastePoints = this._backupPoints(selected);
    this.drawAll();
  }
  
  // CTRL + V --> paste selected points
  // - modifier ALT pastes them before, SHIFT creates new segment    
  else if (key == "V" && e.ctrlKey)
  {
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);

    var points = this.$super.copyPastePoints;

    if (!points || !points.length)
      return;
    
    this._saveHistory();
    points = this._restorePoints(points);

    // push before? then reverse the array first
    if (e.altKey)
      points.reverse();
    
    // SHIFT - creates new segment
    if (e.shiftKey)
    {
      points[0].custom = points.custom || {};
      points[0].custom.segmentStart = true;
    }    

    // insert points
    for (var i = 0; i < points.length; i++)
      this._insertPoint(points[i], undefined, e.altKey);
    
    // make all pasted points selected
    this.selectPoints(points);
    
    this.drawAll();
  }
  
  // R + SHIFT + CTRL -> reverse selected points; R + SHIFT --> reverse entire track
  else if (key == "R" && e.shiftKey && !e.altKey)
  {
    var points = !e.ctrlKey ? this.points : this.getSelected();
    
    if (points.length >= 2)
    { 
      this._saveHistory();
      this.reversePoints(points);
      this.drawAll();
    }
    
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);
  }
  
  // J + SHIFT + CTRL -> join segments with at least one selected point; J + SHIFT --> join all segments
  else if (key == "J" && e.shiftKey && !e.altKey)
  {
    this.joinAllSegments(e.ctrlKey);    
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);
  }
  
  // I -> inverse selection
  else if (key == "I" && !e.shiftKey && !e.altKey && !e.ctrlKey)
  {
    var points = this.flattenSegments(this.getVisibleSegments());
    
    if (points.length)
    {
      this._saveHistory();
      
      for (var i = 0; i < points.length; i++)
        points[i].custom.isSelected = !points[i].custom.isSelected;
    
      this.drawAll();
    }
  }
  
  // T - activate "free draw mode" (ALT + SHIFT are used as modifiers)
  else if (key == "T" && !e.ctrlKey)
  {
    EventUtil.preventDefault(e);
    this.freeDrawMode ? this.cancelFreeDrawMode() : this.startFreeDrawMode();
  }
  
  // M - draw help line from end point to mouse position
  else if (key == "M" && !e.ctrlKey && !e.shiftKey && !e.altKey)
  {
    this.lineToMousePos = !this.lineToMousePos;
    
    if (!this.lineToMousePos)
      this.lineToMousePosDelete();
  }  
}

Polyline.prototype.onKeyUp = function(e, target)
{
  var key = String.fromCharCode(e.keyCode).toUpperCase();
  
  // space unhide markers hidden on keydown
  if (e.keyCode == 32)
  {
    remove_class(document.body, "noShowTrackMarkers");
  }
  
  // CTRL in free draw mode creates point
  else if (e.keyCode == 17 && this.freeDrawMode && this.lastMouseMoveEvent)
  {
    this.onDragDraw(this.lastMouseMoveEvent, {ctrlUp: true});
  }
  
  else if (e.keyCode == 16 && this.freeDrawMode)
  {
    this.onDragDraw(this.lastMouseMoveEvent, {shiftUp: true});
  }  
}

Polyline.prototype.onKeyPress = function(e, target)
{
  var keyCode = EventUtil.getCharCode(e);
  var key = String.fromCharCode(keyCode).toUpperCase();

  // space - temporarily hide all markers (prevent default action)
  if (e.keyCode == 32)
  {
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);
  }
}

Polyline.prototype.onBlur = function(e, target)
{
  remove_class(document.body, "noShowTrackMarkers");
}

Polyline.prototype.onFocus = function(e, target)
{
  remove_class(document.body, "noShowTrackMarkers");
}

Polyline.prototype.onMouseMove = function(e, target)
{
  this.lastMouseMoveEvent = e;
  
  if (this.freeDrawMode)
  {
    this.onDragDraw(e);
  }
  
  else
  {
    this.lineToMousePosDraw(SMap.Coords.fromEvent(e, this.map), e);
  }
}

Polyline.prototype.lineToMousePosDelete = function()
{
  if (this.lineToMousePosGeomLayer)
    this.lineToMousePosGeomLayer.removeAll();
}

Polyline.prototype.lineToMousePosDraw = function(p2, e)
{
  if (!this.lineToMousePos || !this.points.length || this.closed || this.mapIsLocked || e.keyShift || e.keyAlt || e.keyCtrl)
    return false;

  // create geom layer on first run
  if (!this.lineToMousePosGeomLayer)
  {
    this.lineToMousePosGeomLayer = new SMap.Layer.Geometry();
    this.map.addLayer(this.lineToMousePosGeomLayer).enable();
  }  

  // clear it
  this.lineToMousePosDelete();

//   // create line from last point (or new points origin) to mouse position
//   var p1 = this.addNewPointsOrigin || this.points[this.points.length - 1];
// 
//   var options = {color: "red", width: 3, outlineWidth: 0, opacity: 0.85};
//   this.lineToMousePosGeom = new SMap.Geometry(SMap.GEOMETRY_POLYLINE, null, [p1, p2], options);
//   this.lineToMousePosGeomLayer.addGeometry(this.lineToMousePosGeom);



  // create line from last point (or new points origin) to mouse position
  var p1 = this.addNewPointsOrigin || this.points[this.points.length - 1];
  
  // the following fixes problem, when we were unable to click on lines, because the lineToMouse was on top
  // -- so we make the line somewhat shorter (so that there is nothing on top)
  var subtractDist = 2;
  var newDist = Math.max(p1.pixelDistance(p2) - subtractDist, 0);

  // draw the line
  var options = {color: "red", width: 3, outlineWidth: 0, opacity: 0.85};
  this.lineToMousePosGeom = new SMap.Geometry(SMap.GEOMETRY_POLYLINE, null, [p1, p1.pixelProject(p1.pixelAzimuth(p2), newDist)], options);
  this.lineToMousePosGeomLayer.addGeometry(this.lineToMousePosGeom);
  
  return true;
}

/* selection function - we draw polygon and select points based on it */
Polyline.prototype.onPolygonSelectionStart = function(e, target, selection)
{
  if (this.selectionId)
    return;

  this.selectionId = e.customId;
  
  this.selectionPolygon = [];
  
  this.selectionPolygonLayer = new SMap.Layer.Geometry("polylineHelperLayer");
  this.map.addLayer(this.selectionPolygonLayer);
  this.selectionPolygonLayer.enable();
  this.selectionType = e.customId.match(/_(.*?)_/)[1]; /* Rectangle, Polygon */
  this.selectionMode = e.customId.replace(/^.*_/, "");
  //log("start");
  var colors = {"AddToSelection": "green", "Select": "yellow", "DeSelect": "red", "SelectXOR": "#FFA500" /* orange: IE7-8 fix */}
  this.selectionColor = colors[this.selectionMode];
}

Polyline.prototype.onPolygonSelection = function(e)
{
  if (this.selectionId != e.customId)
    return;
    
  // draw polygon
  if (this.selectionType == "Polygon")
  {
    this.selectionPolygon.push(e._point2.clone().toCoords(this.map));
  }
  
  // draw rectangle
  else if (this.selectionType == "Rectangle")
  {
    e._backupRedraw();
    e._dom.container.style.background = this.selectionColor;
    
    this.selectionPolygon = [];
    var p1 = e._point1.clone();
    var p2 = e._point2.clone();
    var p3 = new SMap.Pixel(p2.x, p1.y);
    var p4 = new SMap.Pixel(p1.x, p2.y);
    this.selectionPolygon.push(p1.toCoords(this.map));
    this.selectionPolygon.push(p4.toCoords(this.map));
    this.selectionPolygon.push(p2.toCoords(this.map));
    this.selectionPolygon.push(p3.toCoords(this.map));
  }

  if (this.selectionType != "Rectangle")
  {
    this.selectionPolygonLayer.removeAll();  
    var options = {color: this.selectionColor, outlineWidth: 4, outlineColor: "blue", outlineOpacity: 0.3, opacity: 0.3}; 
    var selPol = new SMap.Geometry(SMap.GEOMETRY_POLYGON, null, this.selectionPolygon, options);
    this.selectionPolygonLayer.addGeometry(selPol);
  }
}

// we have 2 functions here - one is called on drag success and one on drag fail,
// calling _decideSelection on drag fail makes CTRL+click combinations fail
Polyline.prototype.onPolygonSelectionStop = function(e)
{
  if (this.selectionId != e.customId)
    return;
  
  this._decideSelection(this.selectionMode, this.selectionPolygon);
  this.onPolygonSelectionStopFail(e);
}

Polyline.prototype.onPolygonSelectionStopFail = function(e)
{
  if (this.selectionId != e.customId)
    return;

  this.selectionId = null;
  this.selectionPolygonLayer.removeAll();  
  this.map.removeLayer(this.selectionPolygonLayer);
  delete this.selectionPolygonLayer;
}

Polyline.prototype._decideSelection = function(mode, points)
{
  mode = mode || "AddToSelection";
  this._saveHistory();
  var segments = this.getSegments();

  // AddToSelection: add all points in range to existing selection
  // Deselect: remove all points in range from existing selection
  // Select: replace any previous selection with points withing range
  // SelectXOR: intersection of previous selection and points within range
  for (var i = 0, seglen = segments.length; i < seglen; i++)
  {
    var seg = segments[i];
    
    for (var j = 0, len = seg.length; j < len; j++)
    {
      var point = seg[j];
      
      // ignore hidden segments
      if (!j && point.custom.hideSegment)
        break;      
      
      var isIn = false;
      
      if (point.inMap(this.map))
        isIn = this.pointInPolygon(points, point);

      // select or unselect point within range
      if (isIn)
      {
        point.custom.isSelected = (mode == "DeSelect" || (mode == "SelectXOR" && !point.custom.isSelected)) ? false : true;
      }
  
      // if add to selection or selection XOR, then deselect all points out of range
      else if (mode == "Select" || mode == "SelectXOR")
        point.custom.isSelected = false;        
    }
  
  }

  this.drawAll();
}

/* computes whether a point is within polygon */
// info: http://alienryderflex.com/polygon/
Polyline.prototype.pointInPolygon = function(polygon, point) 
{
  if (!polygon.length)
    return false;

  var polySides = polygon.length + 1;
  polygon.push(polygon[0]);
  var i, j = polySides - 1;
  
  var oddNodes = 0;
  point = point.toPixel(this.map);

  for (i = 0; i < polySides; i++)
  {
    var pi = polygon[i].toPixel(this.map);
    var pj = polygon[j].toPixel(this.map);    
  
    if ((pi.y < point.y && pj.y >= point.y
    ||   pj.y < point.y && pi.y >= point.y)
    && (pi.x <= point.x || pj.x <= point.x))
    {
      oddNodes ^= (pi.x + (point.y - pi.y) / (pj.y - pi.y) * (pj.x - pi.x) < point.x);
    }
    
    j = i;
  }

  polygon.pop();
  return oddNodes; 
}

/* functions for dealing with polygon mode (filled shape) */
Polyline.prototype._isPolygon = function()
{
  return(this.isPolygon);
}

Polyline.prototype._setPolygon = function(bool)
{
  this.isPolygon = !!bool; 
}

// remove origin for newly added points (now it will add to end again)
Polyline.prototype._removeNewPointsOrigin = function()
{
  if (this.addNewPointsOrigin)
  {
    this.addNewPointsOrigin = null;
    return true;
  }
  
  return false;
}

Polyline.prototype._addNewPointsOrigin = function(point)
{
  if (!point || this.addNewPointsOrigin === point)
    return false;
    
  this._removeNewPointsOrigin()
  this.addNewPointsOrigin = point;
  return true;
}

Polyline.prototype._isPointsOriginInHiddenSegment = function(segments, altKey)
{
  segments = segments || this.getSegments();
  
  if (!segments.length)
    return false;
  
  // get segment id
  var id = altKey ? 0 : segments.length - 1;
  
  if (this.addNewPointsOrigin)
  {
    var idAlt = this.getSegmentIDFromPointID(this.getIndexFromPoint(this.addNewPointsOrigin));
    id = (idAlt == -1) ? id : idAlt;
  }

  return (!!segments[id][0].custom.hideSegment);
}

// replaces latitude and longitude with new values (using new SMap.Coords would break the functions)
Polyline.prototype.updateCoords = function(p, newLat, newLon)
{
  p._lat = newLat;
  p._lon = newLon;
}

/* functions for exporting/importing point (without having to save any methods etc.) */
Polyline.prototype._backupPoints = function(points)
{
  var isArray = Array.isArray(points);
  points = isArray ? points : [points];
  var backup = [];
  
  for (var i = 0; i < points.length; i++)
  {
    var p = points[i];
    var newP = {lat: p.lat(), lon: p.lon(), custom: {}};
    
    for (var prop in p.custom)
      newP.custom[prop] = p.custom[prop];
      
    // p.custom.isSelected;
    // p.custom.segmentStart;
    // p.custom.hideSegment;
    // p.custom.elevation;
    // p.custom.timestamp;
    
    backup.push(newP);
  }
  
  return (isArray ? backup : backup[0]);
}

Polyline.prototype._restorePoints = function(backup)
{
  var isArray = Array.isArray(backup);
  backup = isArray ? backup : [backup];
  var points = [];

  for (var i = 0; i < backup.length; i++)
  {
    var oldP = backup[i];

    var p = new SMap.Coords(oldP.lat, oldP.lon);
    p.custom = {};
    
    for (var prop in oldP.custom)
      p.custom[prop] = oldP.custom[prop];    

    points.push(p);
  }
  
  return (isArray ? points : points[0]);  
}

/* history - save polyline state and allow reverting to previous state */
Polyline.prototype._saveHistory = function()
{
  //log("saved: " + new Date().getTime()  + " - " + arguments.callee.caller);
  var points = this._backupPoints(this.points);
  var addNewPointsOrigin = this.addNewPointsOrigin ? this.getIndexFromPoint(this.addNewPointsOrigin) : null;
  
  this.history.push({points: points, isPolygon: this._isPolygon(), closed: this.closed, 
    addNewPointsOrigin: addNewPointsOrigin, lineToMousePos: this.lineToMousePos});
  //log("saved: " + this.history.length);
}

Polyline.prototype._restoreHistory = function(restoreForward /* remains to be implemented */)
{
  if (!this.history.length)
    return;
  
  var newState = this.history.pop();

  // restore
  this.points = this._restorePoints(newState.points);
  this._setPolygon(newState.isPolygon);
  this.closed = newState.closed;
  this._addNewPointsOrigin(this.points[newState.addNewPointsOrigin]);
  this.lineToMousePos = newState.lineToMousePos;
  
  // redraw
  this.drawAll();
  //log("loaded: " + this.history.length);
}

Polyline.prototype.joinAllSegments = function(selectedOnly)
{
  var segments = this.getSegments();
  
  if (segments.length <= 1)
    return;

  this._saveHistory();

  // join all segments
  if (!selectedOnly)
  {
    for (var i = 1; i < segments.length; i++)
      segments[i][0].custom.segmentStart = false;
  }
  
  // join segments that have at least one point selected
  else
  {
    var changed = false;
  
    for (var i = 1; i < segments.length; i++)
    {
      var points = segments[i];
      
      for (var j = 0; j < points.length; j++)
      {
        if (points[j].custom.isSelected)
        {
          points[0].custom.segmentStart = false;
          changed = true;
          break;
        }
      }
    }
    
    if (!changed)
      this._restoreHistory();
  }
  
  this.drawAll();
}

Polyline.prototype.reversePoints = function(points)
{
  if (points.length <= 1)
    return false;

  var areas = this.getContinuousAreas(points, {ignoreSegmentStarts: true, getPointIndexesLengths: true});
  
  for (var i = 0; i < areas.length; i++)
  {
    var index = areas[i].index;
    var len = areas[i].length;

    // get segment ends
    for (var j = 0; j < this.points.length; j++)
    {
      if ((j == this.points.length - 1) /* track end */ 
        || this.points[j+1].custom.segmentStart /* segment start */)
        this.points[j].segmentEnd = true;
    }

    // get parts before/to_reverse/after
    var after = this.points.splice(index + len);
    var points = this.points.splice(index, len);
    var before = this.points; 
    
    // this fixes problem with track end being end and not-segmentStart being start
    // note: there are still issues, that make reversing not reversible
    var skipTrackEnd = (!after.length && !points[0].custom.segmentStart);
    
    // set segmentStarts
    for (var j = 0; j < points.length; j++)
    {
      if (j == points.length - 1 && skipTrackEnd)
        continue;

        points[j].custom.segmentStart = !!points[j].segmentEnd;
    }

    // join
    this.points = before.concat(points.reverse(), after);
    this.points[0].custom.segmentStart = false;

    // cleanup
    for (var j = 0; j < this.points.length; j++)
      this.points[j].segmentEnd = false;
  }
  
  return true;
}

/* extracts groups of points that directly follow each other */
Polyline.prototype.getContinuousAreas = function(points, options)
{
  options = options || {};
  var areas = [];          // segments
  var indexes = [];        // indexes within points
  var indexesLengths = []; // indexes + lengths within this.point
  
  // get indexes
  for (var i = 0; i < points.length; i++)
  {
    var index = this.getIndexFromPoint(points[i]);
    
    if (index === null)
      throw ("getIndexFromPoint error within getcontinuousAreas!");
    
    points[i].continuousAreaIndex = index;
  }

  // get areas' beginnings
  for (var i = 0; i < points.length; i++)
  {
    if (!i /* first point is always a break */ 
      || (points[i].custom.segmentStart && !options.ignoreSegmentStarts) /* segment break counts as new area too */
      || points[i].continuousAreaIndex != points[i - 1].continuousAreaIndex + 1) /* following points with not following index */
      {
        points[i].continuousAreaStart = true;
        indexes.push(i);
      }
  }
  
  // create areas
  for (var i = 0; i < points.length; i++)
  {
    if (!i || points[i].continuousAreaStart)
    {
      areas.push([]);
      
      // set also automatically segment start (if set in options)
      if (options.setSegmentStart)
        points[i].custom.segmentStart = true;
        
      // mark beginning with custom parameter
      if (options.markUsingParam)
        points[i][options.custom.markUsingParam] = true;  
    }

    areas[areas.length - 1].push(points[i]);  
  }
  
  // get indexes and lengths within this.points
  if (options.getPointIndexesLengths)
  {
    for (var i = 0; i < areas.length; i++)
      indexesLengths.push({index: areas[i][0].continuousAreaIndex, length: areas[i].length});  
  }  

  // cleanup
  for (var i = 0; i < points.length; i++)
  {
    delete points[i].continuousAreaIndex;
    points[i].continuousAreaStart ? delete points[i].continuousAreaStart : "";
  }

  if (options.returnIndexes)
    return indexes;
  else if (options.getPointIndexesLengths)
    return indexesLengths;
  else
    return areas;
}

/* add point */
Polyline.prototype._insertPoint = function(point, index, insertBefore)
{
  point.custom = point.custom || {};
  point.custom.elevation = point.custom.elevation || NaN;
  point.custom.timestamp = point.custom.timestamp || NaN;
  
  // if the track is closed and we don't have custom origin set, then don't add any new points and exit
  if (this.closed && !this.addNewPointsOrigin && typeof index === 'undefined')
    return;      
  
  // no index? then add it to the end or (ALT) beginning; or to custom origin
  if (typeof index === 'undefined')
  {
    index = this.getIndexFromPoint(this.addNewPointsOrigin);

    // no alternative origin? then add point to the end
    if (index === null)
      index = insertBefore ? 0 : this.points.length - 1;
      
    // set alternative origin point to the newly entered one
    else
    {
      this._addNewPointsOrigin(point);
    }
    
    // add point before (and adjust segment start)
    if (insertBefore && this.points.length)
    {
      // if next point is segmentStart, then move segmentStart to current point
      // if current point is segmentStart, then convert the next to segmentStart
      if (!!this.points[index].custom.segmentStart != !!point.custom.segmentStart)
      {
        this.points[index].custom.segmentStart = !!point.custom.segmentStart;
        point.custom.segmentStart = !point.custom.segmentStart;
      }

      //log(point.custom.segmentStart)
    }
    
    // add point after
    else
      index++;
  }

  // add point
  this.points.splice(index, 0, point);

  // if previous point is selected, select entered one as well (unless we started a new segment or we are going backwards)
  if (index && index < this.points.length && (this.points[index].custom.segmentStart != !!point.custom.segmentStart))
    this.points[index].custom.isSelected = !!this.points[index-1].custom.isSelected;  
}

/* replace point */
Polyline.prototype._replacePoint = function(index, newPoint, mode)
{
  this._saveHistory();
  newPoint.custom = newPoint.custom || {};
  newPoint.custom.elevation = newPoint.custom.elevation || NaN;
  newPoint.custom.timestamp = newPoint.custom.timestamp || NaN;  
  
  this._removePoint(index, true, newPoint, mode);
  
  // update point
  this.updateCoords(this.points[index], newPoint.lat(), newPoint.lon());  
}

// rotate and scale all points between two points (used when dragging a marker - moving a point)
Polyline.prototype._rotateScalePointsToFit = function(points, newPoint)
{
  if (points.length == 1)
    return;
  
  var azimuthNew = points[0].azimuth(newPoint);
  var azimuthOld = points[0].azimuth(points[points.length - 1]);
  var distanceNew = points[0].distance(newPoint, {quick: true});
  var distanceOld = points[0].distance(points[points.length - 1], {quick: true});
//   log((azimuthNew - azimuthOld) + "; " + azimuthNew + "; " + azimuthOld);
//   log((distanceNew / distanceOld + "; " + distanceNew + "; " + distanceOld));
//   log(points.length);
  
  this.rotatePoints(points, azimuthNew - azimuthOld, points[0]);
  this.scalePoints(points, distanceOld ? distanceNew / distanceOld : 0, points[0]);
}

// straighten all points between two given points (used when dragging a marker - moving a point)
Polyline.prototype._straightenPoints = function(points, newPoint)
{
  if (points.length == 1)
    return;
  
  var distanceTotal = 0;
  
  for (var i = 0; i < points.length - 1; i++)
    distanceTotal += points[i].distance(points[i + 1], {quick: (points.length > 100)});

  var distanceIncremental = 0;
  var azimuth = points[0].azimuth(newPoint);
  var distance = points[0].distance(newPoint, {quick: (points.length > 100)});

  for (var i = 0; i < points.length - 1; i++)
  {
    var projDist = (distanceTotal ? (distanceIncremental / distanceTotal) : 0) * distance;
    var newPoint = points[0].projectPoint(azimuth, projDist);
    distanceIncremental += points[i].distance(points[i+1], {quick: (points.length > 100)});
    this.updateCoords(points[i], newPoint.lat(), newPoint.lon());  
  }
}

/* remove point */
Polyline.prototype._removePoint = function(index, keepSelf, newPoint, mode)
{
  // save point (will be modified by rotate/scale functions
  var p = this.points[index];
  var oldP = {lat: p.lat(), lon: p.lon()};
  
  // points after (without marker displayed)
  var i = index + 1;

  if (index < this.points.length - 1)
  {
    while(!!this.points[i].hasMarker != true) i++;
    
    if (i != index + 1)
    {
      if (!keepSelf)
        this.points.remove(index + 1 /* first without marker */, i - 1 /* last without marker */);
      else if (mode == "rotateScale")
        this._rotateScalePointsToFit(this.points.slice(index /* our point */, i + 1 /* next with marker - is origin */).reverse(), newPoint);
      else
        this._straightenPoints(this.points.slice(index /* our point */, i + 1 /* next with marker - is origin */).reverse(), newPoint);        
    }
  }
  
  // restore point
  this.updateCoords(p, oldP.lat, oldP.lon);
  
  // points before (without marker displayed)
  var i = index - 1;
  
  if (index > 0)
  {
    while(!!this.points[i].hasMarker != true) i--;
    
    if (i != index - 1)
    {
      if (!keepSelf)
        this.points.remove(i + 1 /* first without marker */, index - 1 /* last without marker */);
      else if (mode == "rotateScale")    
        this._rotateScalePointsToFit(this.points.slice(i /* with marker before - origin */, index + 1/* our point */), newPoint);
      else    
        this._straightenPoints(this.points.slice(i /* with marker before - origin */, index + 1/* our point */), newPoint);
    }
  }
  
  // restore point again
  this.updateCoords(p, oldP.lat, oldP.lon);
  
  // keep or delete main point
  if (!keepSelf)
    this.points.remove(this.getIndexFromPoint(p));    
  
  // remove polygon mode, if too few points
  if (this.points.length <= 2)
    this._setPolygon(false);
    
  this.drawAll();
}

/* remove markers (use when deactivating layer) */
Polyline.prototype.removeMarkers = function()
{
  this.markerLayer.removeAll();
}

/* remove all points */
Polyline.prototype.removeAll = function()
{
  this.layer.removeAll();
  this.helperLayer.removeAll();
  this.removeMarkers();
}

/* draw all points */
Polyline.prototype.drawAll = function(noUpdateOfTextAreA)
{
  timer_start("draw_all");

  // don't redraw while map is locked (may fix bug in free draw mode)
  if (this.mapIsLocked)
    return;
    
  // when no points, turn off .closed
  if (!this.points.length)
    this.closed = false;
    
  // cleanup old layers
  this.removeAll();
  var segments = this.getSegments();

  // remove helper line
  this.lineToMousePosDelete();  

  // draw track / polygon
  this.layer.disable();
  
  for (var i = 0; i < segments.length; i++)
  {
    var hidden = !!segments[i][0].custom.hideSegment;
  
    // skip segments with one point only
    if (segments[i].length <= 1)
      continue;
    
    // polygon options
    if (this._isPolygon())
    {
      var options = {color: "#00f", width: 2, outlineWidth: 2};
      var optionsHidden = {color: "#FFA500" /* orange: IE7-8 fix */, width: 3, outlineWidth: 1, opacity: 0.2};
      var optionsDisabled = {color: "#00f", width: 2, outlineWidth: 2, outlineColor: "#FFA500" /* orange: IE7-8 fix */};       
    }
    
    // track options
    else
    {
      var hidden = !!segments[i][0].custom.hideSegment;
      var options = {color: "red", width: 3, outlineWidth: 0, opacity: 0.85};
      var optionsHidden = {color: "#FFA500" /* orange: IE7-8 fix */, width: 3, outlineWidth: 0, opacity: 0.6};
      var optionsDisabled = {color: "blue", width: 3, outlineWidth: 1, opacity: 0.85};      
    }

    options = this.active ? (hidden ? optionsHidden : options) : optionsDisabled;
    var geom = new SMap.Geometry(SMap[this._isPolygon() ? "GEOMETRY_POLYGON" : "GEOMETRY_POLYLINE"], null, segments[i], options);
    geom.segmentId = i;
    geom.that = this;
    this.layer.addGeometry(geom);
  }

  this.layer.enable();
  
  // draw only polygon if layer is inactive
  if (!this.active)
    return;  

  // generate markers
  var pixelDistLimit = 50;
  var totalParsed = 0;
  this.markerLayer.disable();
  this.helperLayer.disable();

  for (var i = 0, seglen = segments.length; i < seglen; i++)
  {
    var seg = segments[i];
    
    // skip segment if the first point has hideSegment attribute
    if (seg.length && !!seg[0].custom.hideSegment)
    {
      totalParsed += seg.length
      continue;
    }
    
    // prepare points
    for (var j = 0, len = seg.length; j < len; j++)
    {
      seg[j].isInMap = seg[j].inMap(this.map);
      seg[j].pixel = seg[j].toPixel(this.map);
      seg[j].hasMarker = true;
    }

    // create arrows and mark lines between selected points
    if (seg.length >= 2)
    {
      this._colorizeSelected(seg, i);
      this._addDirectionArrows(seg, i);
    }

    // go through points and create markers for them
    for (var j = 0, len = seg.length; j < len; j++)
    {
      var point = seg[j];

      // skip points outside of viewport    
      if (j < len - 2 && !point.isInMap)
        continue;
        
      // color markers based on being selected or segment/track start/end  
      var classAdd = point.custom.isSelected ? " selected" : "";
      var segmentEnd = (i != seglen - 1 && j == len - 1);
      classAdd += segmentEnd ? " segmentEnd" : "";
      classAdd += (i && !j && !segmentEnd) ? " segmentStart" : "";
      
      var isTrackEnd = (i == seglen - 1 && j == len - 1);
      classAdd += isTrackEnd ? " trackEnd" : "";
      classAdd += (isTrackEnd && this.closed) ? " trackClosedEnd" : "";
      classAdd += (point === this.addNewPointsOrigin) ? " addNewPointsOrigin" : "";
      classAdd += (!i && !j) ? " trackStart" : "";                
 
      // create halfway point
      var next = (j == len - 1) ? (this._isPolygon() ? seg[0] : null) : seg[j + 1];
  
      if (next && point.pixel.distance(next.pixel) > 2 * pixelDistLimit)
      {
        var pointMiddle = point.projectPoint(point.azimuth(next), point.distance(next) / 2); 
        this._createMarker(pointMiddle, {className: "PolygonMarkerHalfway" + classAdd, "data-index-half": (totalParsed + j)});
      }
  
      this._createMarker(point, {className: "PolygonMarker" + classAdd, "data-index": (totalParsed + j), bubble: true});
      
      // skip following points if they are too close
      var last = point;
  
      // note: check for distance to the next+1 because otherwise we would skip start of a big leap (and its halfway point as well)
      while (j < len - 3 && last.pixel.distance(seg[j+2].pixel) < pixelDistLimit /* pixel distance */
        && seg[j+1] !== this.addNewPointsOrigin)     /* always show alternative marker origin */
      {
        seg[++j].hasMarker = false;
      }
    }
    
    totalParsed += seg.length;  
  }
  
  this.markerLayer.enable();
  this.helperLayer.enable();
  
  // update text area on the right
  if (!noUpdateOfTextAreA)
    this.$super.textArea.writePolyline(this);
  
  //timer_end("draw_all");
}

Polyline.prototype._colorizeSelected = function(seg, segmentId)
{
  // if polygon, then add first point to the end, so our function sees it
  if (this._isPolygon())
    seg.push(seg[0]);

  // add direction arrows
  for (var j = 0, len = seg.length; j < len; j++)
  {
    if (!seg[j].custom.isSelected)
      continue;
      
    // skip segments with one point only
    if (seg[j].length <= 1)
      continue;      
    
    // get continuous area
    var selectedStartId = Math.max(j - 1, 0);
    var selectedEndId = j + 1;
    
    while(j < len - 1 && seg[j+1].custom.isSelected)
      j++;
    
    var points = seg.slice(selectedStartId, j + 2);
    
    var options = {color: "#FFA500" /* orange: IE7-8 fix */, width: 4, outlineWidth: 0, outlineColor: "green", opacity: 1};
    var geom = new SMap.Geometry(SMap.GEOMETRY_POLYLINE, null, points, options);
    geom.segmentId = segmentId;  /* help identify layer on geometry click */
    geom.that = this;
    this.helperLayer.addGeometry(geom);
  }
  
  if (this._isPolygon())
    seg.pop();  
}

Polyline.prototype._addDirectionArrows = function(seg, segmentId)
{
  if (this._isPolygon())
    seg.push(seg[0]);
    
  // add direction arrows
  var totalPixelDist = 0;
  var arrowInterval = 200;
  
  for (var j = 0, len = seg.length; j < len - 1; j++)
  {
    var dist = seg[j].pixelDistance(seg[j+1]);
    
    for (var k = Math.floor(totalPixelDist / arrowInterval + 1) * arrowInterval; k < totalPixelDist + dist; k += arrowInterval)
    {
      var dist2 = seg[j].pixelDistance(seg[j+1]);  
      var arrowAzimuth = seg[j].pixelAzimuth(seg[j+1]);
      var arrowPoint = seg[j].pixelProject(arrowAzimuth, (dist ? ((k - totalPixelDist) / dist) : 0) * dist2);
  
      var arrowAngle = 23;
      var arrowLength = 15;
      
      var arrowPt2 = arrowPoint.pixelProject(arrowAzimuth + 180 + arrowAngle, arrowLength);
      var arrowPt3 = arrowPoint.pixelProject(arrowAzimuth + 180 - arrowAngle, arrowLength);      
      
      
      if (!arrowPoint.inMap(this.map))
        continue;
      
      var isSelected = (seg[j].custom.isSelected || seg[j+1].custom.isSelected);
      var options = {color: isSelected ? "#FFA500" /* orange: IE7-8 fix */ : "red", width: 6, outlineWidth: 0, outlineColor: "red", opacity: 1}; 
      var geom = new SMap.Geometry(SMap.GEOMETRY_POLYGON, null, [arrowPoint, arrowPt2, arrowPt3], options);
      geom.segmentId = segmentId;  /* help identify layer on geometry click */
      geom.that = this;
      this.helperLayer.addGeometry(geom);      
    }
    
    totalPixelDist += dist; 
  }
  
  if (this._isPolygon())
    seg.pop();  
}

/* create marker (point) */
Polyline.prototype._createMarker = function(point, options)
{
  var markerDiv = JAK.mel("div", options);

  EventUtil.addHandler(markerDiv, "contextmenu", this.onMarkerRightClick);

  var marker = new SMap.Marker(point, null, {url: markerDiv, anchor: {left: 6, top: 6}});
  marker.decorate(SMap.Marker.Feature.Draggable);
  
  markerDiv.markerId = marker.getId();
  
  // bubble
  if (options.bubble)
  {
    EventUtil.addMouseHandler(markerDiv, "mouseenter", this.onMarkerMouseEnter);
    markerDiv.that = this;
  }
  
  this.markerLayer.addMarker(marker);
}

/* deactivate layer */
Polyline.prototype.deactivate = function()
{
  this.active = false;
  
  // redraw to change line color to non-active
  this.drawAll();
  
  // remove markers
  this.removeMarkers();
  
  // remove arrows, etc.
  this.helperLayer.removeAll();
  
  // cancel free draw mode (if running)
  this.cancelFreeDrawMode();
  
  // helper line
  this.lineToMousePosDelete();
}

/* activate layer */
Polyline.prototype.activate = function()
{
  this.active = true;
  this.drawAll();
}

/* destroy layer */
Polyline.prototype.destroy = function()
{
  this.deactivate();
  this.exit();
  
  if (JAK.Browser.client != "ie" || JAK.Browser.version >= 9)
    delete this;
}

/*############################################*/

if (!window.polygon)
  window.polygon = new Polygon(m, polygon_button, settings);



// http://cycleseven.org/gps-waypoints-routes-and-tracks-the-difference

  //ShowLMCButton("cliptext", "capt", "", "basePath + "LMCButton/lmcbutton.swf");
  
 // <td><script>ShowLMCButton('http://www.lettersmarket.com/');</script></td>


