function load_scale()
{
  window.scale = null;
  
  function setScale()
  {
    // create scale if not already existing
    if (!scale)
    {
      var noprint_div = document.querySelector(".noprint");
      scale = document.createElement("img");
      scale.className = "control-scale";
      noprint_div.appendChild(scale);
      
      // make it non-draggable
      scale.draggable = false;                                      /* IE10, modern browsers */

      EventUtil.addHandler(scale, "dragstart", function(e, target)  /* IE7-9, older browsers */
      {
        EventUtil.preventDefault(e);
      });      
    }
  

//     scale.src = "http://mapy.cz/scale?cx=" + m.getCenter().lon() + "&cy=" + m.getCenter().lat() + "&zoom=" + m.getZoom();
//     //alert(scale.src);
    var scaleCur = m.getScale();
    

    
    var scales = 
    {
      1: 163840000, 2: 81920000, 3: 40960000, 4: 20480000, 5: 10240000, 6: 5120000,
      7: 2560000, 8: 1280000, 9: 640000, 10: 320000, 11: 160000, 12: 80000,
      13: 40000, 14: 20000, 15: 10000, 16: 5000, 17: 2500, 18: 1250    
    }
    
    var min = 1e20;
    var nearestZoom;
    
    for (var zoom in scales)
    {
      var ratio = Math.abs(Math.log(scaleCur / scales[zoom]));
      
      if (ratio < min)
      {
        min = ratio;
        nearestZoom = zoom;
      }
    }

    scale.style.width = (220 /* scale image width */ * scales[nearestZoom] / scaleCur) + "px";
    
    //scale.src = basePath + "Images/Scale/" + nearestZoom + ".png";
    scale.src = "http://mapy.cz/scale?cx=15&cy=50&zoom=" + nearestZoom;
    
    // pro malá měřítka měřítko vypneme (bylo by moc velké)
    scale.style.display = (m.getScale() < 1000) ? "none" : "";
  }
  
  setScale();

  m.getSignals().addListener(window, "map-redraw", function(e, elm)
  {
    //if (m.getZoom() != 19)
      setScale();
  });
}

