// documentation for Street View:
// https://developers.google.com/maps/documentation/javascript/streetview#StreetViewService
// https://developers.google.com/maps/documentation/javascript/reference
// https://developers.google.com/maps/documentation/javascript/v2/reference

// todo: remove nonsense after remake 2013-12-14
// todo: 2015-02-23 - přestalo fungovat flashové street view :-(

var StreetViewDiv = null;
var StreetViewJSLoaded = false;
var StreetViewMap = null;
var markerStreetViewLayer = null;
var StreetViewMarker = null;
var StreetViewMarkerDiv = null;
var svSizeButton;
var svCloseButton;
var lastRotation = 0;
var flashBlocked = true;
var flashBlockedLastCoords = null;
StreetViewInit();

function restartStreetView(coords, moveSV)
{
  if (coords)
  {
    StreetViewMarker.setCoords(new SMap.Coords.fromGoogle(coords));
    
    if (moveSV)
    {
      StreetViewMap.afterMarkerDrag = true;
      //try{StreetViewMap.setLocationAndPOV(coords);} catch(ex){};     
    }
    
    flashBlockedLastCoords = coords;
  }
  
  //StreetViewMap.remove();
  
//   for (var i = 0; i < StreetViewDiv.childNodes.length; i++)
//     log(StreetViewDiv.childNodes[i].tagName + " / " + StreetViewDiv.childNodes[i].id)

  StreetViewDiv.innerHTML = "";
  
  // http://asnsblues.blogspot.cz/2011/11/google-maps-query-string-parameters.html
  StreetViewDiv.innerHTML = "<iframe width=" + StreetViewDiv.offsetWidth + " height=" + StreetViewDiv.offsetHeight + " frameborder=\"0\"" +
   "scrolling=\"no\" marginheight=\"0\" marginwidth=\"0\" src=\"http://maps.google.it/maps/sv?" + 
   /*"cbp=12,65.94660714036661,,1,19.853503009480384" +*/
   "&ll=" + coords.lat() + "," + coords.lng() + 
   "&cbll=" + coords.lat() + "," + coords.lng() + "&panoid=&v=1&hl=cs&gl=cs&om=0\"></iframe>"; 
  createResizeButton();
  createCloseButton();
  
  //StreetViewMap = new GStreetviewPanorama(StreetViewDiv);
  //setStreetViewListeners();
}

// create button to change size of SV from 50% to 100% or vice versa
function createResizeButton()
{
  svSizeButton = JAK.mel("div", {id: "sv_size_button", className: "button sidebar_button", innerHTML: settings.streetview_width});  
  StreetViewDiv.appendChild(svSizeButton);
  
  EventUtil.addHandler(svSizeButton, "click", function(e, target)
  {
    svResize(true, new SMap.Coords.fromEvent(e, m));
  });
}

// create close button
function createCloseButton()
{
  svCloseButton = JAK.mel("div", {id: "sv_close_button", className: ""});  
  StreetViewDiv.appendChild(svCloseButton);
  
  EventUtil.addHandler(svCloseButton, "click", function(e, target)
  {
    StreetViewDiv.style.display = "none";
    remove_class(document.documentElement, "streetview_on");
    markerStreetViewLayer.disable();
    mapadiv.style.display = "";
    mapadiv.style.width = "";
    createDefaultMapControls();
    m.syncPort();
  });
}

function LoadStreetView(coords)
{
  // on first start, get value from global variable
  if (window.startStreetViewCoords)
  {
    coords = window.startStreetViewCoords;
    window.startStreetViewCoords = null;
  }

  var lat = coords.lat();
  var lon = coords.lon();

  if (!StreetViewJSLoaded)
  {
    StreetViewJSLoaded = true;
    
    StreetViewMap = {};
    //StreetViewMap = new GStreetviewPanorama(StreetViewDiv);

    // add marker layer
    markerStreetViewLayer = new SMap.Layer.Marker();
    m.addLayer(markerStreetViewLayer);

    // add marker
    StreetViewMarkerDiv = JAK.mel("div", {className: "StreetViewMarker"});
    StreetViewMarker = new SMap.Marker(new SMap.Coords.fromWGS(lat, lon), null, {anchor: {left: 17,top: 19}, url: StreetViewMarkerDiv});
    StreetViewMarker.decorate(SMap.Marker.Feature.Draggable);
    markerStreetViewLayer.addMarker(StreetViewMarker);
 
    // marker drag --> change position
    m.getSignals().addListener(window, "marker-drag-stop", function(e)
    {
      if (e.target !== StreetViewMarker)
        return;

      if (flashBlocked)
      {
        restartStreetView(CoordsToGoogle(e.target.getCoords()), true);
      }
      else
      {
        StreetViewMap.afterMarkerDrag = true;
        //try{StreetViewMap.setLocationAndPOV(CoordsToGoogle(e.target.getCoords()), StreetViewMap.getPOV());} catch(ex){};      
      }
    });
    
    // marker left-click --> change heading
    EventUtil.addHandler(StreetViewMarkerDiv, "click", function(e, target)
    {
      // gecko doesn't work correctly
      if (JAK.Browser.client == "gecko")
        return;
        
      var width = target.offsetWidth;
      var height = target.offsetHeight;
      var x = e.layerX || /* IE7-8 */ e.offsetX;
      var y = e.layerY || /* IE7-8 */ e.offsetY;

      x = x - width / 2;
      y = y - height / 2;
      
      var azimuth = Math.atan(x / y) * 180 / Math.PI;
      
      if (y > 0 && x > 0)
        azimuth = 180 - azimuth;
      else if (y > 0 && x < 0)
        azimuth = 180 + Math.abs(azimuth);
      else if (y < 0 && x > 0)
        azimuth = Math.abs(azimuth);
      else if (y < 0 && x < 0)
        azimuth = 360 - azimuth;      

      //StreetViewMap.setPOV({yaw: (azimuth) % 360, pitch: 0, zoom: 0});
    });
    
    // set listeners
    //setStreetViewListeners();
    
    // create buttons
    createResizeButton();
    createCloseButton();

    // prevent PAGE UP, PAGE DOWN, ...
    EventUtil.addHandler(StreetViewDiv, 'keydown', function (e)
    {
      // not ENTER
      if (e.keyCode == 13)
        return;
    
      EventUtil.preventDefault(e);
      EventUtil.stopPropagation(e);
    }, true);
    
    // on window resize, adjust SV size
    EventUtil.addHandler(window, "resize", function()
    {
      if (!contains_class(document.documentElement, "streetview_on"))
        return;

      StreetViewDiv.style.height = mapadiv.offsetHeight - 2 /* 1px border */ + "px";
      svResize();  
    });
    
    // when not testing, prevent all errors
    if (!window.testing)
    {
      EventUtil.addHandler(window, "error", function(e)
      {
        //if (/maps\.gstatic\.com/.test(e.filename))
          return true;        
      });
    }

  }

  add_class(document.documentElement, "streetview_on");
  StreetViewDiv.style.display = "";
  //try{StreetViewMap.setLocationAndPOV(CoordsToGoogle(coords));} catch(ex){}; 
  markerStreetViewLayer.enable();
  svRotateElement(StreetViewMarkerDiv, (/*StreetViewMap.getPOV().yaw ||*/ 0) - 90);

  svResize(false);
  flashBlockedLastCoords = CoordsToGoogle(coords);
  restartStreetView(flashBlockedLastCoords, true);
}

// load after right click (not the first time, for that use LoadStreetView)
function reloadStreetView(coords)
{
  flashBlockedLastCoords = CoordsToGoogle(coords);
  add_class(document.documentElement, "streetview_on");
  StreetViewDiv.style.display = "";
  //try{StreetViewMap.setLocationAndPOV(CoordsToGoogle(coords));} catch(ex){}; 
  markerStreetViewLayer.enable();
  
  //var pov = StreetViewMap.getPOV();
  //svRotateElement(StreetViewMarkerDiv, (pov.yaw || 0) - 90);
  svResize(false);
  
  // always restart, because of unknown bug (in Opera, but probably elsewhere) where the position wouldn't update
  restartStreetView(flashBlockedLastCoords, true);
  StreetViewMap.afterMarkerDrag = true;
  //try{StreetViewMap.setLocationAndPOV(flashBlockedLastCoords, pov);} catch(ex){};   
}

function svResize(advance)
{
  var sizes = {"25%": "50%", "50%": "75%", "75%": "100%", "100%": "25%"};
  var complement_size = {"25%": "75%", "50%": "50%", "75%": "25%", "100%": "0%"};
  
  var size = advance ? sizes[svSizeButton.innerHTML] : settings.streetview_width;
  var map_size = complement_size[size];

  // resize divs
  StreetViewDiv.style.width = size;
  mapadiv.style.width = map_size;
  mapadiv.style.display = (size == "100%") ? "none" : "";
  
  // set button to value 
  settings.streetview_width = size;
  svSizeButton.innerHTML = size;

  // synchronize google maps  
  //StreetViewMap.checkResize();
  
  if (flashBlocked && flashBlockedLastCoords)
  {
    restartStreetView(flashBlockedLastCoords, true);
  }

  // synchronize mapy.cz (skip 100% to fix IE7-8 error)
  if (size !== "100%")
  {
    m.syncPort();
    createDefaultMapControls();
  }
}

function StreetViewInit()
{
  // 2015-02-23: pokud startujeme se 100%, pak street view nefunguje!
  if (settings.streetview_width == "100%")
      settings.streetview_width = "75%";

  if (!window.StreetViewDiv)
  {
    StreetViewDiv = document.createElement("div");
    StreetViewDiv.id = "StreetViewDiv";
    StreetViewDiv.style.display = "none";

    
    //loadJS("http://maps.google.com/maps?file=api&amp;v=2&amp;key=AIzaSyDiFOzfzt2mffXUcUZtaJ65KcMPfxk3yMk&sensor=false&callback=loadMaps");
    
    
    LoadStreetView();
    //loadJS("http://www.google.com/jsapi?key=AIzaSyDiFOzfzt2mffXUcUZtaJ65KcMPfxk3yMk&callback=loadMaps");
    //StreetViewDiv.innerHTML = "<iframe frameborder=\"0\" scrolling=\"no\" marginheight=\"0\" marginwidth=\"0\" src=\"http://maps.google.it/maps/sv?cbp=12,65.94660714036661,,1,19.853503009480384&cbll=40.933241,14.312311&panoid=&v=1&hl=it&gl=it\"></iframe>";
  }

  mapadiv.parentNode.insertBefore(StreetViewDiv, mapadiv.nextSibling);
  StreetViewDiv.style.height = mapadiv.offsetHeight - 2 /* 1px border */ + "px";

  if (StreetViewMap)
  {
    //StreetViewMap.checkResize();

    if (contains_class(document.documentElement, "streetview_on"))
      svResize(false);
    //alert("here");
//     // IE fix
//     if (JAK.Browser.client == "ie")
//     {
//       //var coords = StreetViewMap.getLatLng();
//       //var pov = StreetViewMap.getPOV(); 
// 
//       restartStreetView();
//       
//       StreetViewMap.afterMarkerDrag = true;
//       //try{StreetViewMap.setLocationAndPOV(coords, pov);} catch(ex){};       
//     }
  }
}

function CoordsToGoogle(coords)
{
  var lat = lat || coords.lat();
  var lon = lon || coords.lon();
  return ({lat: function() {return lat;}, lng: function() {return lon;}});
  
  //return (new GLatLng(lat, lon));
}

function svRotateElement(elm, deg)
{
  lastRotation = deg;
  return(rotateElement(elm, deg));
}

function rotateElement(elm, deg)
{
  var degStr = "rotate(" + deg + "deg)";
  var properties = ["WebkitTransform", "MozTransform", "OTransform", "msTransform", "transform"];
  var p;
  
  while (p = properties.shift())
  {
    if (typeof elm.style[p] !== 'undefined')
      elm.style[p] = degStr;  
  }
  
  /* IE7-8 */
  var rad = deg * Math.PI * 2 / 360;
  costheta = Math.cos(rad);
  sintheta = Math.sin(rad);

  var a = parseFloat(costheta).toFixed(8);
  var c = parseFloat(-sintheta).toFixed(8);
  var b = parseFloat(sintheta).toFixed(8);
  var d = parseFloat(costheta).toFixed(8);

  if (typeof elm.style.msTransform === 'undefined' && typeof elm.style.transform === 'undefined')
    elm.style.filter = "progid:DXImageTransform.Microsoft.Matrix(M11=" + a + ", M12=" + c + ", M21=" + b + ", M22=" + d + ",sizingMethod='auto expand')";
}
