function copybox(options)
{
  // window already opened? then exit
  if (document.querySelector(".lightbox_on"))
    return;
  
  if (!options.div)
  {        
    var textarea = document.createElement("textarea");
    textarea.className = "copybox";
    textarea.value = options.text || "";
    
    options.element = textarea;
    add_class(document.body, "copybox_on");
  
    // start function
    options.fnBefore = function()
    {
      if (options.select && !options.div)
        textarea.select();
    }
  }
  else
  {
    options.element = options.div;
    options.element.className = "copybox";
  }
  
  // cleanup function
  options.fnAfter = function()
  {
    remove_class(document.body, "copybox_on");
    
    if (options.getText && !options.div)
      options.getText(textarea.value);
    
    if (!options.div)  
      textarea.parentNode.removeChild(textarea);
  };
  
  lightbox(options);
}

function lightbox(options)
{
  // window already opened? then exit
  if (contains_class(document.body, "lightbox_on"))
    return;
  
  var div = document.createElement("span");  /* use span, so we prevent CSS body > div */
  div.className = "lightbox";
  div.innerHTML = ""
      + "<div class='button close_button'>" + (options.closeButtonText || tr("Close")) + "</div>";

  var blackOverlay = document.createElement("span");
  blackOverlay.className = "lightbox-overlay";
  
  var close_button = div.lastChild;

  // set style
  div.style.width = (options.width || 380) + "px";
  div.style.height = (options.height || 380) + "px";
  
  // inner element
  if (options.element)
  {
    var elm = options.element;
    add_class(elm, "lightbox_div");
    div.insertBefore(elm, div.firstChild);
    elm.style.width = div.style.width;
    elm.style.height = div.style.height;
  }
  
  // check for vertical scroll (for CSS use) - doesn't work in IE7
  // - turn off in SplitScreen mode by default (in case the function doesn't work correctly)
  // - doesn't work in IE7
  if (hasVerticalScroll() && !SplitScreen)
    add_class(document.body, "has_vertical_scroll");
    
  if (JAK.Browser.client != "ie" || JAK.Browser.version >= 8)
    add_class(document.body, "fix_lightbox_scroll");  

  // display
  add_class(document.body, "lightbox_on");
  
  document.body.appendChild(div);
  document.body.appendChild(blackOverlay);

  // custom init function
  if (options.fnBefore)
    options.fnBefore();

  // cancels all key redirections aside from escape
  function keyFix(e)
  {
    // if click, escape or enter (if set so in options), then exit
    if (e.type == "click" || e.keyCode == 27 /* escape */ || (options.exitOnEnter && e.keyCode == 13 /* enter */))
    {
      EventUtil.preventDefault(e);
      EventUtil.stopPropagation(e);  

      EventUtil.removeHandler(keyFix1);
      EventUtil.removeHandler(keyFix2);
      EventUtil.removeHandler(keyFix3);
      EventUtil.removeHandler(closeButtonHandler);
      
      remove_class(document.body, "lightbox_on");
      remove_class(document.body, "has_vertical_scroll");
      remove_class(document.body, "fix_lightbox_scroll");
      document.body.removeChild(div);
      document.body.removeChild(blackOverlay);
      
      if (e.keyCode == 27)
        options.element.value = "";

      // when exiting throught enter, wait a little bit 
      // (otherwise it would hit this function again if we call another copybox immediately after -> and end prematurely)
      window.setTimeout(function()
      {
        if (options.fnAfter)
          options.fnAfter();
      }, (options.exitOnEnter && e.keyCode == 13 /* enter */) ? 100 : 0);    
    }
  
    // if we are not intended target, then stop key event
    else if (!EventUtil.isSubnode(e.srcElement, div))  
    {
      EventUtil.preventDefault(e);
      EventUtil.stopPropagation(e);   
    }
  }
  
  var keyFix1 = EventUtil.addHandler(document.body, "keydown", keyFix);
  var keyFix2 = EventUtil.addHandler(document.body, "keyup", keyFix);
  var keyFix3 = EventUtil.addHandler(document.body, "keypress", keyFix);    

  // close on pushing close button
  var closeButtonHandler = EventUtil.addHandler(close_button, "click", keyFix);
}

window.UILoaded = true;

function hasVerticalScroll()
{
  return(document.documentElement.scrollHeight > document.documentElement.clientHeight);
}
